﻿Imports System.IO
Imports System.Windows.Forms
Imports System.IO.Ports
Imports Strings = Microsoft.VisualBasic ' so can use things like left( and right( for strings
Public Class Form1
    Dim WithEvents SerialPortName As New IO.Ports.SerialPort ' generic serial port
    'Dim WithEvents SerialPort1 As New IO.Ports.SerialPort ' serial port declare first com port com1
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer) ' for sleep statements
    Public Declare Auto Function SendMessage Lib "user32.dll" (ByVal hWnd As IntPtr, ByVal wMsg As Int32, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As IntPtr ' disable redrawing of richtextbox etc
    Public Const WM_SETREDRAW As Int32 = &HB ' for above sendmessage
    ' Constants from the Platform SDK to disable richtextbox redraw etc
    Public Const EM_SETEVENTMASK As Integer = 1073
    Public Const EM_GETPARAFORMAT As Integer = 1085
    Public Const EM_SETPARAFORMAT As Integer = 1095
    Public Const EM_SETTYPOGRAPHYOPTIONS As Integer = 1226
    Public Const TO_ADVANCEDTYPOGRAPHY As Integer = 1
    Public Const PFM_ALIGNMENT As Integer = 8
    Public Const SCF_SELECTION As Integer = 1

    Dim InPacket(0 To 2000) As Byte ' Major bug with serial.write strings like chr(255) won't go out
    Dim OutPacket(0 To 2000) As Byte
    Dim XOut(0 To 133) As Byte ' xmodem output packet
    Public CatalinaFile As String
    Public BigBasicFile As String
    Public VGAMode As String
    Public MemSize As String
    Public XMM As String
    Public Maths As String
    Public SerialPortFound As Boolean = True
    Public Baud As String
    Public ComPort As String
    Public MouseGUI As String
    Public FindString As String
    Public PlaceHolder As Integer
    Public IndentPointer As Integer
    Public CompilePause As Boolean
    Public BasicCommandLine As String



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timer1.Interval = 150 ' check for new characters every 150ms
        RichTextBox1.AcceptsTab = True ' so tab stays in the box
        RichTextBox3.AcceptsTab = True ' so tab stays in the box
        RichTextBox4.AcceptsTab = True ' so tab stays in the box
        VGAMode = "HIRES_VGA"
        MemSize = "512"
        XMM = "FALSE"
        ComPort = "COM1" ' can change later if needed
        Baud = 115200
        SettingsTabLoad() ' update the display
        Maths = ""
        LoadINI() ' load settings - overwrites above
        MouseGUI = "Default"
        FindString = ""
        CompilePause = True
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        End
    End Sub

    Private Sub NewToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click
        CatalinaFile = "NEW.C"
        CatalinaFile = InputBox("Filename eg MYFILE.C (no more than 8 characters):", , CatalinaFile)
        CatalinaFile = Strings.UCase(CatalinaFile)
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("/* Traditional first C program */" + vbCrLf)
        RichTextBox1.AppendText(vbCrLf)
        RichTextBox1.AppendText("#include <stdio.h>" + vbCrLf)
        RichTextBox1.AppendText(vbCrLf)
        RichTextBox1.AppendText("void clearscreen() // white text on dark blue background" + vbCrLf)
        RichTextBox1.AppendText("{" + vbCrLf)
        RichTextBox1.AppendText("int i;" + vbCrLf)
        RichTextBox1.AppendText("for (i=0;i<40;i++)" + vbCrLf)
        RichTextBox1.AppendText("{" + vbCrLf)
        RichTextBox1.AppendText("t_setpos(0,0,i); // move cursor to next line" + vbCrLf)
        RichTextBox1.AppendText("t_color(0,0x08FC); // RRGGBBxx eg dark blue background 00001000 white text 11111100" + vbCrLf)
        RichTextBox1.AppendText("}" + vbCrLf)
        RichTextBox1.AppendText("}" + vbCrLf)
        RichTextBox1.AppendText(vbCrLf)
        RichTextBox1.AppendText("void main ()" + vbCrLf)
        RichTextBox1.AppendText("{" + vbCrLf)
        RichTextBox1.AppendText("clearscreen();" + vbCrLf)
        RichTextBox1.AppendText("printf(" + Chr(34) + "Hello, World!\n" + Chr(34) + ");" + vbCrLf)
        RichTextBox1.AppendText("while (1); // Prop reboots on exit from main()!" + vbCrLf)
        RichTextBox1.AppendText("}" + vbCrLf)
        RichTextBox1.AppendText(vbCrLf)
        RichTextBox1.Focus()
        Indents() ' add the proper indentation
        ColorCatalina() ' display in color
        PrintFileName()
    End Sub
    Private Sub PrintFileName()
        Label1.Text = CatalinaFile
        If XMM = True Then
            Label1.Text += " in XMM External Memory"
        Else
            Label1.Text += " in LMM Propeller Memory"
        End If
    End Sub
    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Dim Filepath As String
        Filepath = "C:\Program Files\Catalina\Demos"
        OpenFileDialog1.Multiselect = False
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.C"
        OpenFileDialog1.ShowDialog()
        CatalinaFile = OpenFileDialog1.FileName
        CatalinaFile = Strings.Mid(CatalinaFile, 33) ' strip off directory
        CatalinaFile = Strings.UCase(CatalinaFile)
        PrintFileName()
        Try
            RichTextBox1.LoadFile("C:\Program Files\Catalina\Demos\" + CatalinaFile, RichTextBoxStreamType.PlainText)
            RichTextBox1.Focus()
            'ColorCatalina() ' display text in color
        Catch ex As Exception
            ' user probably hit cancel
        End Try
    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        SaveCatalina()
    End Sub
    Sub SaveCatalina()
        Try
            RichTextBox1.SaveFile("C:\Program Files\Catalina\Demos\" + CatalinaFile, RichTextBoxStreamType.PlainText)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Filepath = "C:\Program Files\Catalina\Demos\"
        SaveFileDialog1.InitialDirectory = Filepath
        SaveFileDialog1.FileName = CatalinaFile
        SaveFileDialog1.ShowDialog()
        Filenamepath = SaveFileDialog1.FileName
        PrintFileName()
        Try
            RichTextBox1.SaveFile(Filenamepath, RichTextBoxStreamType.PlainText)
            CatalinaFile = Strings.Mid(Filenamepath, 33)
        Catch ex As Exception
            're user probably hit cancel
        End Try
    End Sub

    Private Sub ColorToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ColorToolStripMenuItem.Click
        ColorCatalina()
    End Sub
    Private Sub CompileToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CompileToolStripMenuItem1.Click
        CompilePause = True
        Compile_C()
    End Sub
    Private Sub Compile_C()
        ' compile the program - 
        Dim Location As New Process
        Dim filename1 As String
        Dim filename2 As String
        Dim filename_noextension As String
        Dim batchcommand As String
        Dim LineOfText As String
        Dim CommandLine As String
        SaveCatalina()
        filename1 = CatalinaFile
        filename_noextension = Strings.Left(filename1, Len(filename1) - 2)
        If Len(filename_noextension) > 8 Then
            MsgBox("Warning - filename is >8 characters long. Suggest renaming file")
        End If
        ' create a batch file in the demo folder
        If XMM = "TRUE" Then
            CommandLine = XMMCommandline() ' done in several places
        Else
            CommandLine = "catalina -lc -D DEMO -D " + VGAMode + " " + CatalinaFile
        End If
        If BasicCommandLine <> "" Then
            CommandLine = BasicCommandLine ' overrides this one
            BasicCommandLine = "" ' reset this
        End If
        DisplayCommandLine(CommandLine)
        FileOpen(1, "C:\Program Files\Catalina\Demos\drac.bat", OpenMode.Output)
        PrintLine(1, "@echo off")
        PrintLine(1, "echo.")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo    SETTING UP CATALINA")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo.")
        PrintLine(1, "PATH=C:\Program Files\Catalina\bin;%PATH%")
        PrintLine(1, "Call catalina_env.bat()")
        PrintLine(1, CommandLine) ' see above
        If CompilePause = True Then
            PrintLine(1, "pause") ' leaves batch file window open so can see errors
        End If
        FileClose(1)
        ' compile the program
        Location.StartInfo.FileName = "drac.bat"
        Location.StartInfo.WorkingDirectory = "C:\Program Files\Catalina\Demos"
        Location.Start() ' shell the startup file
        Do
            ' wait till batch file finishes
        Loop Until Location.HasExited = True
        PrintFileSize()
    End Sub
    Sub DisplayCommandLine(ByVal LineOfText As String)
        ' easier if can see what it is
        Label38.Text = LineOfText
    End Sub

    Sub ResetPropeller()
        SerialPortName.Open()
        SerialPortName.DtrEnable = False
        SerialPortName.DtrEnable = True ' toggle the dtr line
        SerialPortName.DtrEnable = False
        SerialPortName.Close()
    End Sub

    Private Sub MemorySizeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        MemSize = InputBox("Memory Size 64 to 512", "Memory Size", MemSize)
        SaveINI()
    End Sub

    Private Sub VGAResolutionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        VGAMode = InputBox("VGA resolution", "HIRES_VGA or LORES_VGA", VGAMode)
        SaveINI()
    End Sub

    Private Sub ExtendedMemoryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        XMM = InputBox("Use Extended Memory and SD card", "TRUE or FALSE", XMM)
        SaveINI()
    End Sub

    Private Sub COMPortToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ComPort = InputBox("Serial Port", "COM1 or COM2 etc", ComPort)
        SaveINI()
    End Sub

    Private Sub BaudRateToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Baud = InputBox("Baud rate", "38400, 115200 etc", Baud)
        SaveINI()
    End Sub

    Private Sub CompileDownloadRunToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CompileDownloadRunToolStripMenuItem.Click
        ' can do both xmm and normal programs. Slower than payload
        CompilePause = False ' assumes program has been debugged
        ResetPropeller() ' boot back into kyedos
        Sleep(3000) ' compile is faster than kyedos rebooting
        Compile_C() ' compile the program
        Download_C() ' download the file
    End Sub
    Private Sub Download_C()
        Dim filename1 As String
        Dim filename_noextension As String
        Dim LineOfText As String
        Dim i As Integer
        filename1 = CatalinaFile
        filename_noextension = Strings.Left(filename1, Len(filename1) - 2)
        'MsgBox("Compiled")
        ' send the file
        'TabControl1.SelectedIndex = 0 ' display kyedos
        'TextBox3.Focus() 'display to kyedos
        ' rename .binary to .bin
        Try
            Kill("C:\Program Files\Catalina\Demos\" + filename_noextension + ".bin")
        Catch ex As Exception ' file didn't exist
        End Try
        Try
            Rename("C:\Program Files\Catalina\Demos\" + filename_noextension + ".binary", "C:\Program Files\Catalina\Demos\" + filename_noextension + ".bin")
            SerialPortName.BaudRate = Baud ' kyedos works at 115200 now
            Call XModemKyeSend("C:\Program Files\Catalina\Demos\" + filename_noextension + ".bin")
            Sleep(3000) ' wait for xmodem to end and kyedos to restart
            SerialPortName.BaudRate = Baud ' reopen at 115200 or whatever the default rate is
            SerialPortName.Open()
            LineOfText = "Catlyst2" + vbCr ' run the serial version of catalyst setup for 38400 baud
            Call StringToPacket(LineOfText)
            Label1.Text = LineOfText
            System.Windows.Forms.Application.DoEvents() ' display on screen
            'The baud rate you are fiddling with is (as the comment implies) the loader baud rate. The baud rate you need to change to affect the PC HMI option are the ones in:
            'Catalina_PC_Text.spin()
            'Catalina_PC_Keyboard.spin()
            'Catalina_PC_Mouse.spin()
            ' and recompile with    build_all DRACBLADE              <-- to use local VGA and keyboard
            'or
            'build_all DRACBLADE PC VT100     <-- to use PC terminal emulator
            ' local version is catlyst1.bin and serial version is catlyst2.bin
            Sleep(2000) ' delay while catalyst starts up
            Label1.Text = "Talking to Catalyst at 38400 baud"
            System.Windows.Forms.Application.DoEvents() ' display on screen
            SerialPortName.Close() ' close
            SerialPortName.BaudRate = 38400 ' catlyst2 talks at 38400 baud
            SerialPortName.Open()
            For i = 1 To 3
                System.Windows.Forms.Application.DoEvents() ' update the label1 message
                Sleep(1000) ' wait for reboot approx 5 seconds
            Next i
            LineOfText = UCase(filename_noextension) + vbCr ' and run the program
            Call StringToPacket(LineOfText) ' talk to catalyst and run this program
            Label1.Text = "Run program " + LineOfText ' display the command on the screen
            System.Windows.Forms.Application.DoEvents() ' display on screen
            SerialPortName.Close()
            Sleep(2000)
            Label1.Text = "Finished"
        Catch ex As Exception
            MsgBox("Compile error, check batch file for error message(s)")
            SerialPortName.Close()
        End Try
    End Sub
    Sub StringToPacket(ByVal lineoftext As String)
        ' send a string out, but don't use for data as numbers like 255 don't work
        ' also don't go over 30 (CPM commands never would be)
        Dim i As Byte
        Dim PacketLength As Byte
        Dim TypematicDelay As Integer
        Dim Character As String
        PacketLength = Strings.Len(lineoftext)
        'TypematicDelay = 10 ' anything under 50 misses characters on MPM
        ' seems to be more reliable with timer off (Sept 2010)
        ' 120 for 4800 baud don't go too short otherwise errors, errors at 60 for instance at 4800
        ' errors below 10 at 38400 baud
        ' needs 60 to send and 60 to get character back, so slow but it works
        ' comment - for some reason at wired 38400 we need the slow speed yet can send out as a whole string for radio at 1200?
        Sleep(TypematicDelay) ' typematic delay - depends on clock as much as baud rate
        For i = 1 To PacketLength
            OutPacket(0) = Strings.Asc(Strings.Mid(lineoftext, i, 1))
            If SerialPortFound = True Then
                SerialPortName.Write(OutPacket, 0, 1)
            End If
            'Sleep(TypematicDelay)
            ClearInputBuffer() ' gobble up return bytes
            System.Windows.Forms.Application.DoEvents() ' update the display
        Next
        Sleep(10)
        System.Windows.Forms.Application.DoEvents() ' update the display
    End Sub
    Sub ClearInputBuffer()
        ' eg for running pip no need to display all the background information
        Dim BytesToRead As Integer
        Dim i As Integer
        Dim Character As String
        If SerialPortFound = True Then
            Do
                If SerialPortName.BytesToRead = 0 Then Exit Do ' no more bytes
                BytesToRead = SerialPortName.BytesToRead
                If BytesToRead > 2000 Then BytesToRead = 2000
                SerialPortName.Read(InPacket, 0, BytesToRead) ' read in a packet
                For i = 1 To BytesToRead
                    Character = Strings.Chr(InPacket(i - 1))
                    'Call DisplayCharacter(Character)
                Next i
            Loop
        End If
        'Call RedrawDisplay()
        System.Windows.Forms.Application.DoEvents() ' update the display
    End Sub
    Sub Get_CPM_Filename(ByRef Filenamepath As String, ByRef CPMFilename As String)
        ' send as byref to get the answer back
        ' pass c:\n8vem\mbasic\bascom.com and returns bascom.com
        ' start at the end and look for a \ character
        Dim i As Integer
        i = Strings.Len(Filenamepath)
        Do
            If Strings.Mid(Filenamepath, i, 1) = "\" Then Exit Do
            i = i - 1
        Loop
        CPMFilename = Strings.Mid(Filenamepath, i + 1)
    End Sub
    Sub OutputXout() ' uses xout() array and sends it out in pieces of 30 bytes
        ' in a subroutine so resends are easier - passing subroutine fills up the bytes
        ' 1. an SOH byte                             {1 byte}
        ' 2. the packet number                       {1 byte}
        ' 3:      .the(1) 's complement of the packet number {1 byte}
        ' 4. the packet                            {128 bytes}
        ' 5. the checksum                            {1 byte}

        'The following terms are simply ascii codes:
        'SOH = chr(1)  = CTRL-A =
        'EOT = chr(4)  = CTRL-D = End of Transmission
        'ACK = chr(6)  = CTRL-F = Positive Acknowledgement
        'NAK = chr(21) = CTRL-U = Negative Acknowledgement
        'CAN = Chr(24) = CTRL - X = Cancel
        'The packet number sent is simply the number of the packet.  If the packet
        'number is greater than 255, then subtract 256 repeatly until the number is
        'between 0 and 255.  For example, if you were sending packet 731, then you
        'would send 731 - 256 - 256 = 219.
        'The(1) 's complement of a byte (to make life easy) is simply 255 minus the
        'byte.  For example, if you had to take the 1's complement of 142, the answer
        'would be 255 - 142 = 133.

        'The checksum is the value of all the bytes in the packet added together.  For
        'example, if the first five bytes were 45, 12, 64, 236, 173 and the other 123
        'bytes were zeroes, the checksum would be 45+12+64+236+173+0+0+...+0 = 530.
        'However, to make each block one byte smaller, they repeatly subtract 256
        'from the checksum until it is between 0 and 255.  In this case, the checksum
        'would be 530 - 256 - 256 = 18.
        'The(downloader)

        '1. ensures that the packet number sent matches the actual packet number
        'that it is (If the third block send has a '4' as the second byte,
        'something is wrong --> CANCEL TRANSFER (send CAN byte))
        '2. adds the packet number and the 1's complement of it together to make
        'sure that they add up to 255.  if they don't --> CANCEL TRANSFER
        '3. adds up all the bytes in the packet together --> THE SUM
        '4. compares the last two significant digits of THE SUM with the checksum
        '5. if everything looks ok (sum=checksum), then the downloader appends the
        'bytes in the packet to the file being created (sent).  The down-
        'loader then sends an ACK byte which tells the uploader to send the
        'next block.
        'if the sums do not match then the downloader sends an NAK byte which
        'tells the uploader to send the same block it just sent over again.

        ' send in blocks of 30 bytes to keep the Hope module happy
        ' removed the 30 byte block for the moment, hope modules go via boards not pc to board
        Dim i As Integer
        For i = 0 To 131
            OutPacket(i) = XOut(i)
        Next
        If SerialPortFound = True Then
            SerialPortName.Write(OutPacket, 0, 132)
        End If
        ' very slow code to catch bugs etc

        'Dim lineoftext As String
        'For i = 0 To 131
        ' OutPacket(0) = XOut(i)
        ' SerialPortname.Write(OutPacket, 0, 1)
        ' lineoftext = Chr(XOut(i)) ' + "  " + Str(XOut(i))
        ' Call DisplayCharacter(lineoftext)
        ' Call RedrawDisplay()
        ' System.Windows.Forms.Application.DoEvents()
        ' Sleep(100)
        ' Next

    End Sub
    Sub OutputXoutSlow()
        ' for MPM as overruns the 64 byte simh buffer if too fast
        Dim i As Integer
        Dim c As Integer
        'Dim lineoftext As String
        c = 0
        For i = 0 To 131
            OutPacket(0) = XOut(i)
            SerialPortName.Write(OutPacket, 0, 1)
            'lineoftext = Chr(XOut(i)) ' + "  " + Str(XOut(i))
            'Call DisplayCharacter(lineoftext)
            'Call RedrawDisplay()
            System.Windows.Forms.Application.DoEvents()
            c += 1
            If c > 50 Then
                c = 0
                Sleep(30) ' catchup time for MPM to process the SIMH 64 byte buffer
            End If
        Next
    End Sub
    Sub TestComPort()
        MsgBox("Com port " + ComPort + " Baud " + Baud + " trying to open...")
        Try
            SerialPortName.PortName = ComPort
            SerialPortName.BaudRate = Baud '38400
            SerialPortName.Parity = IO.Ports.Parity.None ' no parity
            SerialPortName.DataBits = 8 ' 8 bits
            SerialPortName.StopBits = IO.Ports.StopBits.One ' one stop bit
            SerialPortName.Open()
            SerialPortName.Close()
            MsgBox("Success")
        Catch ex As Exception
            MsgBox("Fail")
        End Try
    End Sub
    Sub PortsAvailable()
        Dim ports As String() = SerialPort.GetPortNames()
        Dim PortsAvailable As String
        ' Display each port name to the console.
        Dim port As String
        For Each port In ports
            PortsAvailable += port + " "
        Next port
        MsgBox(PortsAvailable)
    End Sub
    Private Sub AvailablePortsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        PortsAvailable()
    End Sub
    Private Function XMMCommandline()
        ' includes the -lm switch for maths
        ' not sure if should include this for non XMM code because it does take more code
        Dim MathsString As String
        Dim Commandline As String
        MathsString = Maths ' "" or "-lm" etc
        If MathsString <> "" Then MathsString += " " ' put a space on the end
        Commandline = "catalina -lcx " + "-D PLUGIN " + MathsString + "-x5 -M " + MemSize + "k -D DRACBLADE -D SHARED_XMM -D " + VGAMode + " " + CatalinaFile
        Return Commandline
    End Function
    Private Sub CompileDownloadRunPayloadToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CompileDownloadRunPayloadToolStripMenuItem.Click
        CompileDownloadRunNoXMM()
    End Sub

    Sub CompileDownloadRunNoXMM()
        Dim Location As New Process
        Dim filename1 As String
        Dim filename_noextension As String
        Dim LineOfText As String
        Dim PortNumber As String
        Dim CommandLine As String
        CompilePause = False ' assumes program has been debugged
        PortNumber = Strings.Right(ComPort, 1)
        filename1 = CatalinaFile
        filename_noextension = Strings.Left(filename1, Len(filename1) - 2)
        SaveCatalina()
        filename1 = CatalinaFile
        filename_noextension = Strings.Left(filename1, Len(filename1) - 2)
        If Len(filename_noextension) > 8 Then
            MsgBox("Warning - filename is >8 characters long. Suggest renaming file")
        End If
        If XMM = "TRUE" Then MsgBox("Change View/Settings and disable XMM to run small LMM programs")
        ' create a batch file in the demo folder
        'PrintLine(1, "catalina -lcx -x5 -M 128k -D DRACBLADE -D HIRES_VGA " + CatalinaFile)
        If XMM = "TRUE" Then
            CommandLine = XMMCommandline()
        Else
            CommandLine = "catalina -lc -D DEMO -D " + VGAMode + " " + CatalinaFile
        End If
        If BasicCommandLine <> "" Then
            CommandLine = BasicCommandLine ' overrides this one
            BasicCommandLine = "" ' reset this
        End If
        DisplayCommandLine(CommandLine)
        FileOpen(1, "C:\Program Files\Catalina\Demos\drac.bat", OpenMode.Output)
        PrintLine(1, "@echo off")
        PrintLine(1, "echo.")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo    SETTING UP CATALINA")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo.")
        PrintLine(1, "PATH=C:\Program Files\Catalina\bin;%PATH%")
        PrintLine(1, "Call catalina_env.bat()")
        PrintLine(1, CommandLine) ' see above
        PrintLine(1, "payload -b 115200 -p " + PortNumber + " " + filename_noextension)
        'PrintLine(1, "pause")
        FileClose(1)
        Location.StartInfo.FileName = "drac.bat"
        Location.StartInfo.WorkingDirectory = "C:\Program Files\Catalina\Demos"
        Location.Start() ' shell the startup file
        Do
            ' wait till batch file finishes
        Loop Until Location.HasExited = True
        PrintFileSize()
    End Sub
    Sub CompileDownloadEeprom()
        Dim Location As New Process
        Dim filename1 As String
        Dim filename_noextension As String
        Dim LineOfText As String
        Dim PortNumber As String
        Dim CommandLine As String
        CompilePause = False ' assumes program has been debugged
        PortNumber = Strings.Right(ComPort, 1)
        filename1 = CatalinaFile
        filename_noextension = Strings.Left(filename1, Len(filename1) - 2)
        SaveCatalina()
        filename1 = CatalinaFile
        filename_noextension = Strings.Left(filename1, Len(filename1) - 2)
        If Len(filename_noextension) > 8 Then
            MsgBox("Warning - filename is >8 characters long. Suggest renaming file")
        End If
        If XMM = "TRUE" Then MsgBox("Change View/Settings and disable XMM to run small LMM programs")
        ' create a batch file in the demo folder
        'PrintLine(1, "catalina -lcx -x5 -M 128k -D DRACBLADE -D HIRES_VGA " + CatalinaFile)
        If XMM = "TRUE" Then
            CommandLine = XMMCommandline()
        Else
            CommandLine = "catalina -lc -D DEMO -D " + VGAMode + " " + CatalinaFile
        End If
        If BasicCommandLine <> "" Then
            CommandLine = BasicCommandLine ' overrides this one
            BasicCommandLine = "" ' reset this
        End If
        DisplayCommandLine(CommandLine)
        FileOpen(1, "C:\Program Files\Catalina\Demos\drac.bat", OpenMode.Output)
        PrintLine(1, "@echo off")
        PrintLine(1, "echo.")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo    SETTING UP CATALINA")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo.")
        PrintLine(1, "PATH=C:\Program Files\Catalina\bin;%PATH%")
        PrintLine(1, "Call catalina_env.bat()")
        PrintLine(1, CommandLine) ' see above
        PrintLine(1, "payload -e -b 115200 -p " + PortNumber + " " + filename_noextension)
        'PrintLine(1, "pause")
        FileClose(1)
        Location.StartInfo.FileName = "drac.bat"
        Location.StartInfo.WorkingDirectory = "C:\Program Files\Catalina\Demos"
        Location.Start() ' shell the startup file
        Do
            ' wait till batch file finishes
        Loop Until Location.HasExited = True
        PrintFileSize()
    End Sub
    Sub SaveINI()
        SettingsTabSave() ' update the screen
        ' go through all the check boxes and update the variables

        FileOpen(1, "C:\Program Files\Catalina\Settings.INI", OpenMode.Output) ' open a file
        PrintLine(1, VGAMode)
        PrintLine(1, MemSize)
        PrintLine(1, XMM)
        PrintLine(1, ComPort)
        PrintLine(1, Baud)
        PrintLine(1, Maths)
        PrintLine(1, "Spare")
        PrintLine(1, "Spare")
        PrintLine(1, "Spare")
        PrintLine(1, "Spare")
        PrintLine(1, "Spare")
        PrintLine(1, "Spare")
        PrintLine(1, "Spare")
        FileClose(1)
    End Sub
    Sub LoadINI()
        Dim LineofText As String
        Try
            FileOpen(1, "C:\Program Files\Catalina\Settings.INI", OpenMode.Input) ' open a file
            VGAMode = LineInput(1)
            MemSize = LineInput(1)
            XMM = LineInput(1)
            ComPort = LineInput(1)
            Baud = LineInput(1)
            Maths = LineInput(1)
            LineofText = LineInput(1) ' spare
            LineofText = LineInput(1) ' spare
            LineofText = LineInput(1) ' spare
            LineofText = LineInput(1) ' spare
            LineofText = LineInput(1) ' spare
            LineofText = LineInput(1) ' spare
            LineofText = LineInput(1) ' spare
            FileClose(1)
        Catch ex As Exception
            FileClose(1)
            Call SaveINI() ' start a new file
        End Try
        SettingsTabLoad() ' update the settings tab
    End Sub
    Sub SettingsTabLoad()
        ' take settings variables and update the check boxes etc
        Dim ports As String() = SerialPort.GetPortNames()
        ' Display each port name to the console.
        Dim port As String
        ComboBox1.Items.Clear()
        For Each port In ports
            ComboBox1.Items.Add(port)
        Next port
        ComboBox1.Text = ComPort ' com port
        If VGAMode = "HIRES_VGA" Then
            RadioButton3.Checked = True
        End If
        If VGAMode = "LORES_VGA" Then
            RadioButton2.Checked = True
        End If
        TextBox15.Text = MemSize ' memory size
        If XMM = "FALSE" Then CheckBox2.Checked = False Else CheckBox2.Checked = True
        If Baud = "19200" Then RadioButton6.Checked = True
        If Baud = "38400" Then RadioButton4.Checked = True
        If Baud = "115200" Then RadioButton5.Checked = True
        ' maths flag -lm or -lma or -lmb or nothing
        If Maths = "" Then RadioButton7.Checked = True
        If Maths = "-lm" Then RadioButton8.Checked = True
        If Maths = "-lma" Then RadioButton9.Checked = True
        If Maths = "-lmb" Then RadioButton10.Checked = True
    End Sub
    Sub SettingsTabSave()
        ' take check boxes etc and change to public variables
        If RadioButton3.Checked = True Then VGAMode = "HIRES_VGA"
        If RadioButton2.Checked = True Then VGAMode = "LORES_VGA"
        MemSize = TextBox15.Text
        If CheckBox2.Checked = False Then XMM = "FALSE" Else XMM = "TRUE"
        ComPort = ComboBox1.Text
        If RadioButton6.Checked = True Then Baud = 19200
        If RadioButton4.Checked = True Then Baud = 38400
        If RadioButton5.Checked = True Then Baud = 115200
        ' save maths flag
        If RadioButton7.Checked = True Then Maths = ""
        If RadioButton8.Checked = True Then Maths = "-lm"
        If RadioButton9.Checked = True Then Maths = "-lma"
        If RadioButton10.Checked = True Then Maths = "-lmb"
    End Sub
    Private Sub SaveSettingsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        SaveINI()
    End Sub

    Private Sub LoadDemoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim Location As New Process
        ' start the spin part in the proptool
        Location.StartInfo.FileName = "Catalina_Plugin.spin"
        Location.StartInfo.WorkingDirectory = "C:\Program Files\Catalina\plugins\custom"
        Location.Start() ' shell the startup file
        ' load the demo
        CatalinaFile = "generic_plugin.c"
        RichTextBox1.LoadFile("C:\Program Files\Catalina\Plugins\custom_demo\" + CatalinaFile, RichTextBoxStreamType.PlainText)
    End Sub
    Sub PictureBoxTest()
        ' Dim PixelValue As Color
        'Dim RedByte As Byte
        'Dim GreenByte As Byte
        'Dim BlueByte As Byte
        '    PictureBox2.Image = New System.Drawing.Bitmap("c:\tweety.bmp")
        'Dim MyBitmap As New System.Drawing.Bitmap(PictureBox2.Image) 'image from picture box
        '    PixelValue = MyBitmap.GetPixel(25, 20) ' get the value of pixel at 25,20
        '    RedByte = PixelValue.R
        '    GreenByte = PixelValue.G
        '    BlueByte = PixelValue.B
        'MsgBox(Strings.Str(RedByte) + Strings.Str(GreenByte) + Strings.Str(BlueByte)) ' display
        '' change some pixels - mygraphics has all the useful drawing things, lines boxes circles etc
        'Dim red As Integer = 0
        'Dim white As Integer = 11
        'Dim MyGraphics As Graphics = Graphics.FromImage(MyBitmap)
        'While white <= 100
        ' MyGraphics.FillRectangle(Brushes.Red, 0, red, 20, 10)
        ' MyGraphics.FillRectangle(Brushes.White, 0, white, 30, 10)
        ' red += 2
        ' white += 2
        ' End While
        '    MyBitmap.SetPixel(10, 10, System.Drawing.Color.Black) ' change a pixel in array
        ' save back to the picturebox
        '    PictureBox2.Image = MyBitmap
        ' save the picturebox as a new file
        '    PictureBox2.Image.Save("C:\Newfile.bmp", System.Drawing.Imaging.ImageFormat.Bmp)
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        sizex = 256 - 1 ' baggers screen is 256x240
        sizey = 240 - 1
        Dim PixelArray(sizex, sizey, 3) As Byte ' R,G,B and calculated prop byte so 4 values
        Dim x, y, i As Integer
        Dim Propbyte As Byte
        Dim TileArray(1920 - 1) As String ' Up to 1920 tiles though this is more than hub ram
        Dim TileMap(1920 - 1) As Integer ' each entry is 2 bytes
        Dim OutputArray(30000) As Byte ' use for both tilearray and tilemap, can never be more than hub ram
        Dim TileX, TileY As Integer
        Dim TileString As String
        Dim HexString As String
        Dim t, TileCounter As Integer
        Dim TileMapCounter As Integer
        Dim TileExists As Integer
        Dim lsb, msb As Byte
        Dim Sourcefile As String
        Dim DestinationFile As String
        Sourcefile = TextBox4.Text + TextBox3.Text
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
        img = Image.FromStream(fs)
        fs.Close()
        PictureBox3.Image = img
        'PictureBox3.Image = New System.Drawing.Bitmap(Sourcefile) ' load picture
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox3.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = PixelValue.R ' red byte
                PixelArray(x, y, 1) = PixelValue.G ' green byte
                PixelArray(x, y, 2) = PixelValue.B ' blue byte
                PixelArray(x, y, 3) = 3 ' pre fill the prop byte with %00000011 for Baggers tiles
            Next
        Next
        ' create the propeller color byte
        For y = 0 To sizey
            For x = 0 To sizex
                For i = 0 To 2
                    ConvertColor(PixelArray(x, y, i), Propbyte) ' get the value 0-3
                    Select Case i
                        Case 0 : Propbyte = Propbyte * 64 ' shift to red position
                        Case 1 : Propbyte = Propbyte * 16 ' shift to green position
                        Case 2 : Propbyte = Propbyte * 4 ' shift to blue position
                    End Select
                    PixelArray(x, y, 3) = PixelArray(x, y, 3) + Propbyte ' add to existing color
                Next i
            Next x
        Next y
        'PictureBox3.Image = MyBitmap ' bitmap array to picturebox - need to convert pixelarray back to mybitmap to show the decreased color depth 
        ' now create the tiles and the map using the pixelarray data in dimension 3
        TileCounter = 0
        TileMapCounter = 0
        For TileY = 0 To 29 ' 30 rows of tiles
            For TileX = 0 To 63 ' 64 columns of tiles
                TileString = ""
                For y = TileY * 8 To TileY * 8 + 7
                    For x = TileX * 4 To TileX * 4 + 3
                        NumberToHex(PixelArray(x, y, 3), HexString) ' get the hex value
                        TileString = TileString + HexString ' add to the tilestring
                    Next x
                Next y
                ' does this tile exist already?
                TileExists = -1
                For t = 0 To TileCounter
                    If TileString = TileArray(t) Then TileExists = t ' found a match
                Next t
                If TileExists = -1 Then
                    ' no match so add as a new tile
                    TileArray(TileCounter) = TileString ' add to tile array
                    TileMap(TileMapCounter) = TileCounter ' add this to the map
                    TileCounter = TileCounter + 1 ' and add one to tile array counter
                    TileMapCounter = TileMapCounter + 1 ' and increment map counter
                Else
                    ' found a match at Tileexists so no need to add this tile
                    ' add this to the map, and increment the map
                    TileMap(TileMapCounter) = TileExists
                    TileMapCounter = TileMapCounter + 1
                End If
            Next TileX
        Next TileY
        ' now turn these arrays into binary files
        ' the map file is two bytes, lsb first

        t = 0
        For i = 0 To 1920 - 1
            IntegerToBytes(TileMap(i), msb, lsb)
            OutputArray(t) = lsb
            t += 1
            OutputArray(t) = msb
            t += 1
        Next
        DestinationFile = TextBox4.Text + TextBox6.Text
        Dim OutputMap As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputMap.Write(OutputArray, 0, 3840)
        OutputMap.Close()
        ' and now the tiles
        t = 0
        For i = 0 To TileCounter - 1
            For x = 0 To 31 ' number of bytes in each tile
                OutputArray(t) = Val("&H" + Strings.Mid(TileArray(i), x * 2 + 1, 2))
                t += 1
            Next
        Next
        DestinationFile = TextBox4.Text + TextBox5.Text
        Dim OutputTile As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputTile.Write(OutputArray, 0, TileCounter * 32) ' if tilecounter=1 then 32 bytes
        OutputTile.Close()
        ' display the file size
        Label13.Text = "Tile size (bytes) = " + Strings.Str(TileCounter * 32)
    End Sub
    Private Sub ConvertColor(ByVal Bytevalue As Byte, ByRef Returnvalue As Byte)
        ' takes a number 0 to 255 and changes to the nearest propeller color
        ' prop colors are 00,01,10,11
        ' so 0-63 is 00, 64-127 is 01, 128 to 191 is 10 and 192 to 255 is 11
        ' this is the same as dividing by 64 but do it this way in case later
        ' need to tweak the values
        ' experiments with bias at either end of the scale - so centres on 85, 170
        Select Case Bytevalue
            Case 0 To 42
                Returnvalue = 0 ' 0
            Case 43 To 127
                Returnvalue = 1 ' 85
            Case 128 To 212
                Returnvalue = 2 ' 170
            Case 213 To 255
                Returnvalue = 3 ' 255
        End Select
    End Sub
    Sub NumberToHex(ByRef N As Integer, ByRef Hexstring As String)
        ' 0 to 255 and returns 00 to FF
        Hexstring = Strings.Hex(N)
        Hexstring = Trim(Hexstring)
        If N < 16 Then Hexstring = "0" + Hexstring
    End Sub
    Sub LongToHex(ByRef n As Long, ByRef Hexstring As String)
        Hexstring = Strings.Hex(n)
        Hexstring = Trim(Hexstring)
        Hexstring = Strings.Right(Hexstring, 8)
        Hexstring = "00000000" + Hexstring
        Hexstring = Strings.Right(Hexstring, 8)
    End Sub
    Sub IntegerToBytes(ByRef N As Integer, ByRef msb As Byte, ByRef lsb As Byte)
        Dim hexstring As String ' there is a way with mod and integer division as well
        hexstring = Strings.Hex(N)
        hexstring = Trim(hexstring)
        hexstring = "0000" + hexstring
        hexstring = Strings.Right(hexstring, 4)
        msb = Val("&H" + Strings.Left(hexstring, 2))
        lsb = Val("&H" + Strings.Right(hexstring, 2))
    End Sub

    Private Sub TextBox3_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox3.TextChanged
        If Strings.Len(TextBox3.Text) > 4 Then
            TextBox5.Text = Strings.Left(TextBox3.Text, Strings.Len(TextBox3.Text) - 4) + ".chr"
            TextBox6.Text = Strings.Left(TextBox3.Text, Strings.Len(TextBox3.Text) - 4) + ".map"
        End If
    End Sub

    Private Sub TextBox8_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox8.TextChanged
        If Strings.Len(TextBox8.Text) > 4 Then
            TextBox9.Text = Strings.Left(TextBox8.Text, Strings.Len(TextBox8.Text) - 4) + ".vga"
        End If
        If Strings.Len(TextBox9.Text) > 12 Then MsgBox("File name cannot be more than 8 characters (8.3 format)")
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        sizex = 160 - 1 ' kye screen is 160x120
        sizey = 120 - 1
        Dim PixelArray(sizex, sizey, 3) As Byte ' R,G,B and calculated prop byte so 4 values
        Dim x, y, i As Integer
        Dim Propbyte As Byte
        Dim OutputArray(20000) As Byte
        Dim t As Integer
        Dim Sourcefile As String
        Dim DestinationFile As String
        Sourcefile = TextBox7.Text + TextBox8.Text
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
        img = Image.FromStream(fs)
        fs.Close()
        PictureBox2.Image = img
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox2.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = PixelValue.R ' red byte
                PixelArray(x, y, 1) = PixelValue.G ' green byte
                PixelArray(x, y, 2) = PixelValue.B ' blue byte
                PixelArray(x, y, 3) = 0 ' pre fill the prop byte with %00000000 for Kye's code
            Next
        Next
        ' create the propeller color byte
        For y = 0 To sizey
            For x = 0 To sizex
                For i = 0 To 2
                    ConvertColor(PixelArray(x, y, i), Propbyte) ' get the value 0-3
                    Select Case i
                        Case 0 : Propbyte = Propbyte * 64 ' shift to red position
                        Case 1 : Propbyte = Propbyte * 16 ' shift to green position
                        Case 2 : Propbyte = Propbyte * 4 ' shift to blue position
                    End Select
                    PixelArray(x, y, 3) = PixelArray(x, y, 3) + Propbyte ' add to existing color
                Next i
            Next x
        Next y
        'PictureBox3.Image = MyBitmap ' bitmap array to picturebox - need to convert pixelarray back to mybitmap to show the decreased color depth 
        ' now turn the pixelarray x,y,3 into a binary file
        t = 0
        For y = 0 To sizey
            For x = 0 To sizex
                OutputArray(t) = PixelArray(x, y, 3) ' move to output array
                t += 1
            Next
        Next
        DestinationFile = TextBox7.Text + TextBox9.Text
        Dim OutputVGA As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputVGA.Write(OutputArray, 0, 19200) ' save 19200 bytes
        OutputVGA.Close()
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        sizex = 160 - 1 ' kye screen is 160x120
        sizey = 120 - 1
        Dim PixelArray(sizex, sizey, 3) As Byte ' R,G,B and calculated prop byte so 4 values
        Dim x, y, i As Integer
        Dim Propbyte As Byte
        Dim OutputArray(20000) As Byte
        Dim t As Integer
        Dim Sourcefile As String
        Dim DestinationFile As String
        Dim StartNumber As Integer
        Dim FinishNumber As Integer
        Dim Filecounter As Integer
        Dim LineofText As String
        DestinationFile = TextBox10.Text + TextBox14.Text
        StartNumber = Strings.Val(TextBox12.Text)
        FinishNumber = Strings.Val(TextBox13.Text)
        Dim OutputVGA As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        For Filecounter = StartNumber To FinishNumber
            Sourcefile = TextBox10.Text + TextBox11.Text ' directory plus rootname
            ' add the right number of leading zeros, (AVS4YOU adds a different number based on how big the total file is)
            LineofText = Strings.Right("000000" + Trim(Strings.Str(Filecounter)), Strings.Len(TextBox12.Text)) ' convert to a string
            Label25.Text = LineofText
            Sourcefile += LineofText + ".bmp"
            ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
            Dim img As Image
            Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
            img = Image.FromStream(fs)
            fs.Close()
            ' display the image in the picture box
            PictureBox4.Image = img
            ' Get the source bitmap.
            Dim bm_source As New Bitmap(PictureBox4.Image)
            ' Make a bitmap for the result shrunk to 160x120
            Dim bm_dest As New Bitmap(CInt(160), CInt(120))
            ' Make a Graphics object for the result Bitmap.
            Dim gr_dest As Graphics = Graphics.FromImage(bm_dest)
            ' Copy the source image into the destination bitmap.
            gr_dest.DrawImage(bm_source, 0, 0, bm_dest.Width + 1, bm_dest.Height + 1)
            ' Display the result.
            PictureBox5.Image = bm_dest
            gr_dest.Dispose()
            Dim MyBitmap As New System.Drawing.Bitmap(PictureBox5.Image) 'image from picture box
            For y = 0 To sizey
                For x = 0 To sizex
                    PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                    PixelArray(x, y, 0) = PixelValue.R ' red byte
                    PixelArray(x, y, 1) = PixelValue.G ' green byte
                    PixelArray(x, y, 2) = PixelValue.B ' blue byte
                    PixelArray(x, y, 3) = 0 ' pre fill the prop byte with %00000000 for Kye's code
                Next
            Next
            ' create the propeller color byte
            For y = 0 To sizey
                For x = 0 To sizex
                    For i = 0 To 2
                        ConvertColor(PixelArray(x, y, i), Propbyte) ' get the value 0-3
                        Select Case i
                            Case 0 : Propbyte = Propbyte * 64 ' shift to red position
                            Case 1 : Propbyte = Propbyte * 16 ' shift to green position
                            Case 2 : Propbyte = Propbyte * 4 ' shift to blue position
                        End Select
                        PixelArray(x, y, 3) = PixelArray(x, y, 3) + Propbyte ' add to existing color
                    Next i
                Next x
            Next y
            'PictureBox3.Image = MyBitmap ' bitmap array to picturebox - need to convert pixelarray back to mybitmap to show the decreased color depth 
            ' now turn the pixelarray x,y,3 into a binary file
            t = 0
            For y = 0 To sizey
                For x = 0 To sizex
                    OutputArray(t) = PixelArray(x, y, 3) ' move to output array
                    t += 1
                Next
            Next
            System.Windows.Forms.Application.DoEvents() ' update the display
            OutputVGA.Write(OutputArray, 0, 19200) ' save 19200 bytes
        Next Filecounter
        OutputVGA.Close()
    End Sub

    Private Sub SettingsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        TabControl1.SelectedIndex = 3 'settings
    End Sub
    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        SaveINI()
        PrintFileName()
    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        TestComPort()
    End Sub

    Private Sub CutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CutToolStripMenuItem.Click
        Select Case TabControl1.SelectedIndex
            Case 0 : RichTextBox1.Cut()
            Case 4 : RichTextBox3.Cut()
            Case 6 : RichTextBox4.Cut()
        End Select
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyToolStripMenuItem.Click
        Select Case TabControl1.SelectedIndex
            Case 0 : RichTextBox1.Copy()
            Case 4 : RichTextBox3.Copy()
            Case 6 : RichTextBox4.Copy()
        End Select
    End Sub

    Private Sub PasteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PasteToolStripMenuItem.Click
        Select Case TabControl1.SelectedIndex
            Case 0 : RichTextBox1.Paste()
            Case 4 : RichTextBox3.Paste()
            Case 6 : RichTextBox4.Paste()
        End Select
    End Sub

    Private Sub SelectAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SelectAllToolStripMenuItem.Click
        Select Case TabControl1.SelectedIndex
            Case 0 : RichTextBox1.SelectAll()
            Case 4 : RichTextBox3.SelectAll()
            Case 6 : RichTextBox4.SelectAll()
        End Select
    End Sub

    Private Sub FindToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FindToolStripMenuItem.Click
        FindString = InputBox("String to find", "Find", FindString)
        RichTextBox1.Find(FindString)
        PlaceHolder = RichTextBox1.SelectionStart + 1
    End Sub

    Private Sub UndoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UndoToolStripMenuItem.Click
        RichTextBox1.Undo()
    End Sub

    Private Sub RedoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RedoToolStripMenuItem.Click
        RichTextBox1.Redo()
    End Sub

    Private Sub FindAgainToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FindAgainToolStripMenuItem.Click
        Dim x As Integer
        Dim opt As RichTextBoxFinds = 0
        x = RichTextBox1.Find(FindString, PlaceHolder, opt)
        PlaceHolder = RichTextBox1.SelectionStart + 1
        If x < 0 Then
            PlaceHolder = 0
            RichTextBox1.Find(FindString)
            PlaceHolder = RichTextBox1.SelectionStart + 1
        End If
    End Sub

    Private Sub BlackToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BlackToolStripMenuItem.Click
        RichTextBox1.Select(0, RichTextBox1.Text.Length)
        RichTextBox1.SelectionColor = Color.Black
        RichTextBox1.DeselectAll()
    End Sub

    Private Sub SettingsToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SettingsToolStripMenuItem.Click
        TabControl1.SelectedIndex = 0 ' display code
    End Sub

    Private Sub SettingsToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SettingsToolStripMenuItem1.Click
        TabControl1.SelectedIndex = 3 ' display settings
    End Sub
    Private Sub IndentsToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IndentsToolStripMenuItem1.Click
        Indents()
    End Sub

    Private Sub Indents()
        Dim TempString As String
        Dim i As Long
        Dim L As Long
        Dim Character As String
        Dim NextCharacter As String
        Dim Indent As Integer
        Dim LeadingSpace As Boolean
        Dim CommentCounter As Integer
        Dim StarSlash As Boolean
        Indent = 0
        TempString = ""
        Label3.Text = "Start Indents"
        System.Windows.Forms.Application.DoEvents() ' update the label
        L = Strings.Len(RichTextBox1.Text)
        ' add a carriage return at the end if the last line is }
        If Strings.Mid(RichTextBox1.Text, L, 1) = "}" Then
            RichTextBox1.Text += vbCr
            RichTextBox1.Text += vbLf
        End If
        L = Strings.Len(RichTextBox1.Text) ' update length
        ' remove tabs
        For i = 1 To L
            Character = Strings.Mid(RichTextBox1.Text, i, 1)
            If Character <> Strings.Chr(9) Then ' remove tabs
                TempString += Character
            End If
        Next
        RichTextBox1.Text = TempString
        ' purge all the previous indents (spaces)
        ' but only if not in a /* ... */ comment section
        LeadingSpace = False
        TempString = ""
        L = Strings.Len(RichTextBox1.Text)
        StarSlash = False
        For i = 1 To L
            ' is the text within a /* comment section?
            If i < L Then
                If Strings.Mid(RichTextBox1.Text, i, 2) = "/*" Then StarSlash = True ' start comment section
            End If
            If i > 1 Then
                If Strings.Mid(RichTextBox1.Text, i - 1, 2) = "*/" Then StarSlash = False ' end comment section
            End If
            ' now do the rest of the code
            Character = Strings.Mid(RichTextBox1.Text, i, 1)
            If Character = Strings.Chr(10) And StarSlash = False Then
                LeadingSpace = True
                TempString += Character ' add the linefeed
            End If
            If StarSlash = True Then LeadingSpace = False ' override leading space if within a comment
            If LeadingSpace = False Then
                TempString += Character ' add the character
            End If
            If LeadingSpace = True And Character <> Strings.Chr(10) Then
                If Character = " " Then
                    ' add nothing
                Else
                    LeadingSpace = False ' reset the leading space flag
                    TempString += Character ' and add this character
                End If
            End If
        Next
        RichTextBox1.Text = TempString
        ' now add new indents
        LeadingSpace = False
        TempString = ""
        L = Strings.Len(RichTextBox1.Text)
        For i = 1 To L
            Character = Strings.Mid(RichTextBox1.Text, i, 1)
            If i < L Then NextCharacter = Strings.Mid(RichTextBox1.Text, i + 1, 1)
            If Character = "{" Then Indent = Indent + 7
            If NextCharacter = "}" Then Indent = Indent - 7
            If Indent < 0 Then Indent = 0
            TempString += Character
            If Indent > 0 And Character = Strings.Chr(10) Then
                TempString += Strings.Space(Indent)
            End If
        Next
        RichTextBox1.Text = TempString
        ' put comments in the same column
        CommentCounter = 0
        TempString = ""
        L = Strings.Len(RichTextBox1.Text)
        For i = 1 To L - 1
            Character = Strings.Mid(RichTextBox1.Text, i, 1)
            If Character = Strings.Chr(10) Then CommentCounter = 0 ' reset counter when get a line feed
            If Character = "/" And Strings.Mid(RichTextBox1.Text, i + 1, 1) = "/" Then
                ' double //
                If CommentCounter < 70 Then
                    TempString += Strings.Space(70 - CommentCounter) ' add some spaces
                End If
            End If
            TempString += Character ' add the character
            CommentCounter += 1 ' add one to the comment counter
        Next
        TempString += Strings.Mid(RichTextBox1.Text, L, 1) ' add the last character
        RichTextBox1.Text = TempString
        RichTextBox1.Select(0, RichTextBox1.Text.Length)
        RichTextBox1.SelectionColor = Color.Black
        RichTextBox1.DeselectAll()
        Label3.Text = "Finish Indents"
        System.Windows.Forms.Application.DoEvents() ' update the label
    End Sub

    Private Sub PayloadXMMCompileDownloadRunToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PayloadXMMCompileDownloadRunToolStripMenuItem.Click
        PayloadCompile()
    End Sub

    Private Sub PayloadCompile()
        ' compile the program using Payload and XMM
        Dim Location As New Process
        Dim filename1 As String
        Dim filename2 As String
        Dim filename_noextension As String
        Dim batchcommand As String
        Dim LineOfText As String
        Dim CommandLine As String
        Dim PayloadLine As String
        Dim Mathsstring As String
        FileCopy("c:\program files\catalina\utilities\XMM.BINARY", "c:\program files\catalina\demos\XMM.BINARY")
        SaveCatalina()
        filename1 = CatalinaFile
        filename_noextension = Strings.Left(filename1, Len(filename1) - 2)
        If Len(filename_noextension) > 8 Then
            MsgBox("Warning - filename is >8 characters long. Suggest renaming file")
        End If
        ' create a batch file in the demo folder
        If XMM = "TRUE" Then
            CommandLine = XMMCommandline()
        Else
            MsgBox("Only works for XMM programs - see the Settings tab")
        End If
        If BasicCommandLine <> "" Then
            CommandLine = BasicCommandLine ' overrides this one
            BasicCommandLine = "" ' reset this
        End If
        DisplayCommandLine(CommandLine)
        PayloadLine = "Payload XMM " + filename_noextension ' loads xmm.binary then new.binary
        ' note - need to copy XMM.BINARY from utilities to demos folder
        FileOpen(1, "C:\Program Files\Catalina\Demos\drac.bat", OpenMode.Output)
        PrintLine(1, "@echo off")
        PrintLine(1, "echo.")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo    SETTING UP CATALINA")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo.")
        PrintLine(1, "PATH=C:\Program Files\Catalina\bin;%PATH%")
        PrintLine(1, "Call catalina_env.bat()")
        PrintLine(1, "echo " + CommandLine)
        PrintLine(1, CommandLine) ' see above
        ' see above beginning of subroutine, easier to copy it each time.
        'PrintLine(1, "echo ***Make sure XMM.BINARY is copied from Utilities to Demos folder***")
        PrintLine(1, "echo " + PayloadLine)
        PrintLine(1, PayloadLine)
        'If CompilePause = True Then
        'PrintLine(1, "pause") ' leaves batch file window open so can see errors
        'End If
        FileClose(1)
        ' compile the program
        Location.StartInfo.FileName = "drac.bat"
        Location.StartInfo.WorkingDirectory = "C:\Program Files\Catalina\Demos"
        Location.Start() ' shell the startup file
        ColorCatalina() ' redo the colors as takes about as long as a download
        Do
            ' wait till batch file finishes
        Loop Until Location.HasExited = True
        PrintFileSize()
    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        RichTextBox3.Text = ""
        RichTextBox3.AppendText("CON" + vbCrLf)
        RichTextBox3.AppendText("  _clkfreq = 80_000_000" + vbCrLf)
        RichTextBox3.AppendText("  _clkmode = xtal1 + pll16x" + vbCrLf)
        RichTextBox3.AppendText(vbCrLf)
        RichTextBox3.AppendText("PUB Main" + vbCrLf)
        RichTextBox3.AppendText("    coginit(1,@cogstart,0)  ' cog 1, cogstart, dummy value" + vbCrLf)
        RichTextBox3.AppendText(vbCrLf)
        RichTextBox3.AppendText("DAT" + vbCrLf)
        RichTextBox3.AppendText("                  org 0" + vbCrLf)
        RichTextBox3.AppendText("cogstart          wrbyte  testvalue, testvariable ' test value A" + vbCrLf)
        RichTextBox3.AppendText("                  jmp #cogstart" + vbCrLf)
        RichTextBox3.AppendText(vbCrLf)
        RichTextBox3.AppendText("testvariable      long    5000           ' test memory location 5000" + vbCrLf)
        RichTextBox3.AppendText("testvalue         long    65             ' ascii A" + vbCrLf)
        RichTextBox3.AppendText("                  fit 496" + vbCrLf)
        TextBox16.Text = "cogject.spin"
    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        Dim Filepath As String
        Dim FileName As String
        Filepath = "C:\Propeller\cogjects"
        OpenFileDialog1.Multiselect = False
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.SPIN"
        OpenFileDialog1.ShowDialog()
        FileName = OpenFileDialog1.FileName
        FileName = Strings.Mid(FileName, 23) ' strip off directory
        FileName = Strings.UCase(FileName)
        TextBox16.Text = FileName
        Try
            RichTextBox3.LoadFile("C:\Propeller\Cogjects\" + FileName, RichTextBoxStreamType.PlainText)
            'RichTextBox3.Focus()
        Catch ex As Exception
            ' user probably hit cancel
        End Try
    End Sub

    Private Sub Button16_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button16.Click
        RichTextBox3.SaveFile("C:\Propeller\cogjects\" + TextBox16.Text, RichTextBoxStreamType.PlainText)
    End Sub

    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Dim Filename As String
        Filename = TextBox16.Text
        Filepath = "C:\Propeller\cogjects\"
        SaveFileDialog1.InitialDirectory = Filepath
        SaveFileDialog1.FileName = Filename
        SaveFileDialog1.ShowDialog()
        Filenamepath = SaveFileDialog1.FileName
        TextBox16.Text = Strings.Mid(Filenamepath, 23) ' new name
        If Strings.Len(TextBox16.Text) > 13 Then MsgBox("Consider using a filename with no more than 8 characters for the filename")
        Try
            RichTextBox3.SaveFile(Filenamepath, RichTextBoxStreamType.PlainText)
        Catch ex As Exception
            're user probably hit cancel
        End Try
    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.Click
        CompilePause = True ' for just compile
        CompilePasm()
    End Sub
    Private Sub CompilePasm()
        Dim Location As New Process
        Dim filename_noextension As String
        ' alternate to this is to use the spin tool and save as a binary file and rename to a .cog
        ' and copy to the sd card

        TextBox16.Text = Strings.LCase(TextBox16.Text)
        RichTextBox3.SaveFile("C:\Propeller\cogjects\" + TextBox16.Text, RichTextBoxStreamType.PlainText)
        filename_noextension = Strings.Left(TextBox16.Text, Len(TextBox16.Text) - 5)
        ' copy from c:\propeller\cogjects to the catalina demos folder
        FileCopy("C:\Propeller\cogjects\" + filename_noextension + ".spin", "C:\Program Files\Catalina\Demos\" + filename_noextension + ".spin")
        FileOpen(1, "C:\Program Files\Catalina\Demos\dracspin.bat", OpenMode.Output)
        PrintLine(1, "@echo off")
        PrintLine(1, "echo.")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo    SETTING UP CATALINA")
        PrintLine(1, "echo    ===================")
        PrintLine(1, "echo.")
        PrintLine(1, "PATH=C:\Program Files\Catalina\bin;%PATH%")
        PrintLine(1, "echo Call catalina_env.bat()")
        PrintLine(1, "Call catalina_env.bat()")
        PrintLine(1, "echo Erase previous files")
        PrintLine(1, "del " + filename_noextension + ".binary")
        PrintLine(1, "del " + filename_noextension + ".h")
        PrintLine(1, "del " + Strings.Chr(34) + "c:\program files\catalina\include\" + filename_noextension + ".h" + Strings.Chr(34))
        PrintLine(1, "echo homespun -b -d " + TextBox16.Text)
        PrintLine(1, "homespun -b -d " + TextBox16.Text)
        PrintLine(1, "echo spinc " + filename_noextension + ".binary to " + filename_noextension + ".h")
        PrintLine(1, "spinc " + filename_noextension + ".binary" + " > " + " " + filename_noextension + ".h")
        PrintLine(1, "echo xcopy to the include folder")
        PrintLine(1, "xcopy " + filename_noextension + ".h " + Strings.Chr(34) + "c:\program files\catalina\include" + Strings.Chr(34) + " /Y")
        PrintLine(1, "echo also creates .cog file from .binary file")
        ' in xcopy either get an uppercase file name, OR or specify it exactly, it asks do you want to save as a file or as a directory, even with the Y option. So leave it as upper case
        If CompilePause = True Then
            PrintLine(1, "pause") ' leaves batch file window open so can see errors
        End If
        FileClose(1)
        ' compile the program
        Location.StartInfo.FileName = "dracspin.bat"
        Location.StartInfo.WorkingDirectory = "C:\Program Files\Catalina\Demos"
        Location.Start() ' shell the startup file
        Do
            ' wait till batch file finishes
        Loop Until Location.HasExited = True
        BinaryToCog("C:\Program Files\Catalina\Demos\" + filename_noextension + ".binary", "C:\Program Files\Catalina\Demos\" + filename_noextension + ".cog")
    End Sub
    Sub BinaryToCog(ByVal Source As String, ByVal Destination As String)
        ' converts a .binary file to a .cog file
        Dim BinaryFileLength As Long
        Dim BinaryFileCounter As Long = 0
        Dim Cogstore(2047) As Byte
        Dim i As Integer
        Dim Input As New FileStream(Source, FileMode.Open, FileAccess.Read)
        Dim br As New BinaryReader(Input)
        BinaryFileLength = br.BaseStream.Length() - 1
        While BinaryFileCounter <= BinaryFileLength
            Cogstore(BinaryFileCounter) = br.ReadByte
            BinaryFileCounter += 1
        End While
        Dim Output As New FileStream(Destination, FileMode.Create, FileAccess.Write)
        Dim bw As New BinaryWriter(Output)
        For i = 0 To 2044 Step 4 ' fixed size output 2048-24 bytes
            Output.WriteByte(Cogstore(i + 0))
            Output.WriteByte(Cogstore(i + 1))
            Output.WriteByte(Cogstore(i + 2))
            Output.WriteByte(Cogstore(i + 3))
        Next
        Output.Close()
        Input.Close()
    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.Click
        Dim filename_noextension As String
        Dim short_filename As String
        ResetPropeller() ' if not in kyedos
        Sleep(4000) ' for kyedos to reboot
        CompilePause = False ' don't pause
        CompilePasm() ' compile the program
        filename_noextension = Strings.Left(TextBox16.Text, Strings.Len(TextBox16.Text) - 5) ' remove .spin
        If Strings.Len(filename_noextension) > 8 Then
            short_filename = Strings.Left(filename_noextension, 8) ' xmodem uses 8.3 format
        Else
            short_filename = filename_noextension ' leave as it is
        End If
        Try
            Call XModemKyeSend("C:\Program Files\Catalina\Demos\" + short_filename + ".cog")
        Catch ex As Exception
            MsgBox(ex.Message)
            'SerialPortName.Close()
        End Try
    End Sub

    Private Sub Button20_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ' obsolete now - better just to copy the .c array file manually
        Dim PasteString As String
        Dim cogname As String
        CompilePause = False ' assumes no errors 
        CompilePasm()
        cogname = LCase(Strings.Left(TextBox16.Text, Len(TextBox16.Text) - 5))
        PasteString = "#include <" + cogname + ".h>" + vbCrLf
        PasteString += vbCrLf
        PasteString += "unsigned long par_" + cogname + "[] = { 1, 2, 3 };   // data to pass to cog - ignore if not used" + vbCrLf
        PasteString += vbCrLf
        PasteString += "void load_" + cogname + "()" + vbCrLf
        PasteString += "{" + vbCrLf
        PasteString += "       _coginit((int)par_" + cogname + ">>2, (int)" + cogname + "_array>>2, 7);      // load into cog 7" + vbCrLf
        PasteString += vbCrLf
        PasteString += "}" + vbCrLf
        PasteString += vbCrLf
        Clipboard.SetText(PasteString) ' put in clipboard
        TabControl1.SelectedIndex = 0 ' display the c program
        RichTextBox1.Paste() ' paste in the rich text box
        ColorCatalina() ' change to color text
    End Sub
    Private Sub NewPASMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewPASMToolStripMenuItem.Click
        CatalinaFile = "NEWPASM.C"
        CatalinaFile = InputBox("Filename eg MYFILE.C (no more than 8 characters):", , CatalinaFile)
        CatalinaFile = Strings.UCase(CatalinaFile)
        RichTextBox1.Text = ""
        With RichTextBox1
            Text = ""
            .AppendText("/* PASM demo for use with Catalina IDE Precompiler and Compiler */" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("#include <stdio.h>" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("/* PASM Code for compilation using SpinC and inclusion as a data file" + vbCrLf)
            .AppendText("PASM Start mycogject.spin" + vbCrLf)
            .AppendText("CON" + vbCrLf)
            .AppendText("                                                                     ' add your values here" + vbCrLf)
            .AppendText("  _clkfreq = 80_000_000                                              ' 5Mhz Crystal" + vbCrLf)
            .AppendText("  _clkmode = xtal1 + pll16x                                          ' x 16" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("PUB Main" + vbCrLf)
            .AppendText("    coginit(1,@cogstart,0)                                           ' cog 1, cogstart, dummy value" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("DAT" + vbCrLf)
            .AppendText("                  org 0" + vbCrLf)
            .AppendText("cogstart" + vbCrLf)
            .AppendText("                  mov    temp2, par         ' parameters array" + vbCrLf)
            .AppendText("                  rdlong testaddress,temp2  ' hub location" + vbCrLf)
            .AppendText("                  add    temp2,#4           ' increment counter by 4 bytes = 1 long" + vbCrLf)
            .AppendText("                  rdlong temp, temp2        ' get data byte" + vbCrLf)
            .AppendText("                  wrlong temp, testaddress  ' store to hub" + vbCrLf)
            .AppendText("                  add    temp2,#4" + vbCrLf)
            .AppendText("                  add    testaddress,#4" + vbCrLf)
            .AppendText("                  rdlong temp, temp2        ' get data byte" + vbCrLf)
            .AppendText("                  wrlong temp, testaddress" + vbCrLf)
            .AppendText("                  add    temp2,#4" + vbCrLf)
            .AppendText("                  add    testaddress,#4" + vbCrLf)
            .AppendText("                  rdlong temp, temp2        ' get data byte" + vbCrLf)
            .AppendText("                  wrlong temp, testaddress" + vbCrLf)
            .AppendText("finish" + vbCrLf)
            .AppendText("                  jmp #finish" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("testaddress       long    0                 ' hub memory location" + vbCrLf)
            .AppendText("temp              long    0                 ' temp variable" + vbCrLf)
            .AppendText("temp2             long    0                 ' temp variable" + vbCrLf)
            .AppendText("                  fit     496" + vbCrLf)
            .AppendText("PASM End" + vbCrLf)
            .AppendText("*/ " + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("void mycogject(int cognumber, unsigned long *parameters_array)                                        // this name copied from the .spin name in the pasm section - names must match eg void mycogject matches mycogject.spin. Also first code after this must be the .h array file. Put your code after the };" + vbCrLf)
            .AppendText("{" + vbCrLf)
            .AppendText("       /**" + vbCrLf)
            .AppendText("       * @file mycogject_array.h" + vbCrLf)
            .AppendText("       * Created with spin.binary PASM to C Array Converter." + vbCrLf)
            .AppendText("       * Copyright (c) 2011, John Doe" + vbCrLf)
            .AppendText("       */" + vbCrLf)
            .AppendText("       unsigned long mycogject_array[] =                               // dummy data or compiled above code or #include file.h" + vbCrLf)
            .AppendText("       {" + vbCrLf)
            .AppendText("              0x003c0602, 0x5c7c0000, 0x00001388, 0x00000041" + vbCrLf)
            .AppendText("       };" + vbCrLf)
            .AppendText("       _coginit((int)parameters_array>>2, (int)mycogject_array>>2, cognumber);  // array name built from spin file name" + vbCrLf)
            .AppendText("}" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("void clearscreen()                                                   // white text on dark blue background" + vbCrLf)
            .AppendText("{" + vbCrLf)
            .AppendText("       int i;" + vbCrLf)
            .AppendText("       for (i=0;i<40;i++)" + vbCrLf)
            .AppendText("       {" + vbCrLf)
            .AppendText("               t_setpos(0,0,i);                                      // move cursor to next line" + vbCrLf)
            .AppendText("               t_color(0,0x08FC);                                    // RRGGBBxx eg dark blue background 00001000 white text 11111100" + vbCrLf)
            .AppendText("       }" + vbCrLf)
            .AppendText("}" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("void sleep(int milliseconds)                                         // sleep function" + vbCrLf)
            .AppendText("{" + vbCrLf)
            .AppendText("       _waitcnt(_cnt()+(milliseconds*(_clockfreq()/1000))-4296);" + vbCrLf)
            .AppendText("}" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("char peek(int address)                                               // function implementation of peek" + vbCrLf)
            .AppendText("{" + vbCrLf)
            .AppendText("       return *((char *)address);" + vbCrLf)
            .AppendText("}" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("void poke(int address, char value)                                   // function implementation of poke" + vbCrLf)
            .AppendText("{" + vbCrLf)
            .AppendText("       *((char *)address) = value;" + vbCrLf)
            .AppendText("}" + vbCrLf)
            .AppendText(vbCrLf)
            .AppendText("void main ()" + vbCrLf)
            .AppendText("{" + vbCrLf)
            .AppendText("       char c;" + vbCrLf)
            .AppendText("       int i;" + vbCrLf)
            .AppendText("       unsigned long hubaddress=100;" + vbCrLf)
            .AppendText("       unsigned long parameters_array[20];                            // for passing parameters to the cog" + vbCrLf)
            .AppendText("       parameters_array[0]=hubaddress;					               // hub address" + vbCrLf)
            .AppendText("       parameters_array[1]=80;						                  // some data to pass" + vbCrLf)
            .AppendText("       parameters_array[2]=81;" + vbCrLf)
            .AppendText("       parameters_array[3]=82;" + vbCrLf)
            .AppendText("       clearscreen();" + vbCrLf)
            .AppendText("       printf(" + Chr(34) + "Clock speed %u \n" + Chr(34) + ",_clockfreq());                     // see page 28 of the propeller manual for other useful commands" + vbCrLf)
            .AppendText("       printf(" + Chr(34) + "Catalina running in cog number %i \n" + Chr(34) + ",_cogid());      // integer" + vbCrLf)
            .AppendText("       i=hubaddress;                                               // location to peek and poke" + vbCrLf)
            .AppendText("       poke(i,66);                                                   // poke a B, the cog should change this" + vbCrLf)
            .AppendText("       printf(" + Chr(34) + "load cogject into cog 7\n" + Chr(34) + ");" + vbCrLf)
            .AppendText("       mycogject(7,parameters_array);                                                 // run in cog 7" + vbCrLf)
            .AppendText("       c=peek(i);                                                    // peek byte at this location" + vbCrLf)
            .AppendText("       printf(" + Chr(34) + "Peek value at %i = character %c Ascii value %d \n" + Chr(34) + ",i,c,c);" + vbCrLf)
            .AppendText("       i=i+4;" + vbCrLf)
            .AppendText("       c=peek(i);" + vbCrLf)
            .AppendText("       printf(" + Chr(34) + "Peek value at %i = character %c Ascii value %d \n" + Chr(34) + ",i,c,c);" + vbCrLf)
            .AppendText("       i=i+4;" + vbCrLf)
            .AppendText("       c=peek(i);" + vbCrLf)
            .AppendText("       printf(" + Chr(34) + "Peek value at %i = character %c Ascii value %d \n" + Chr(34) + ",i,c,c);" + vbCrLf)
            .AppendText("       while (1); // Prop reboots on exit from main()" + vbCrLf)
            .AppendText("}" + vbCrLf)
            .AppendText(vbCrLf)
            .Focus()
        End With
        'Indents() ' add the proper indentation (already done)
        ColorCatalina() ' display in color
        PrintFileName()
    End Sub

    Private Sub CompileWithPASMCodeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Precompile()
    End Sub
    Private Sub Precompile()
        ' convert all pasm code into data listings underneath the pasm code as a C function
        ' and copy all constants from the c constants to each pasm object
        Dim i, j As Long
        Dim PasmCode As Boolean
        Dim LineOfText As String
        Dim PasmString As String
        Dim PASMFilename As String
        Dim PASMFilenameLength As Integer
        Dim PreRemoveflag As Boolean
        Dim RemoveFlag As Boolean
        Dim TempString As String
        Dim ConstantString As String
        Dim ConstantFlag As Boolean
        Dim TempConst As String

        ConstantString = ""
        ConstantFlag = False
        PasmCode = False ' not reading some pasm code
        ' get the cursor position
        SendMessage(RichTextBox1.Handle, WM_SETREDRAW, New IntPtr(CInt(False)), IntPtr.Zero) ' disable refresh
        Dim selectStart As Integer = RichTextBox1.SelectionStart ' preserve cursor

        ' experiments with trying to speed it up http://geekswithblogs.net/pvidler/archive/2003/10/15/182.aspx

        'SendMessage(RichTextBox1.Handle, EM_SETEVENTMASK, 0, 0) ' stop updates
        'SendMessage(RichTextBox1.Handle, WM_SETREDRAW, 0, 0) ' stop redraw

        ' didn't make much difference. It is the deleting lines that is taking all the time
        ' it may be better to save to a text file, then reload in line by line into an array
        ' process that, then save back, then do the color while compiling.
        ' for each line as string did speed up reading the lines
        ' use code from the BFHC program. Save to and from text files eg when removing lines just don't save them
        ' 
        'NumberLines = RichTextBox1.Lines.Length
        'OldText = RichTextBox1.Text ' save in case crashes with the Try
        ' get the list of C constants at the beginning of the program
        ' for each is supposed to be much faster than for i = 1 to ...
        For Each Line As String In RichTextBox1.Lines ' much faster than for i=0 to richtextbox1.lines.length
            LineOfText = Line
            If Strings.Left(LineOfText, 13) = "/* Global con" Then ConstantFlag = True ' start of constant list
            If ConstantFlag = True And Strings.Left(LineOfText, 17) = "/* End global con" Then ConstantFlag = False ' end of constant list
            If ConstantFlag = True Then
                If Strings.Left(LineOfText, 5) = "const" Then ' only do constant lines
                    TempConst = Strings.Mid(LineOfText, 21) ' strip off the const unsigned long
                    j = Strings.InStr(TempConst, ";")
                    TempConst = Strings.Left(TempConst, j - 1)
                    ConstantString += "  " + TempConst + vbCrLf ' two spaces plus changed to spin syntax
                End If
            End If
        Next
        System.Windows.Forms.Application.DoEvents()
        ' rebuild constantstring with comments
        ConstantString = "                                                                     ' Start of C hub constants" + vbCrLf + ConstantString
        ConstantString += "                                                                     ' End of C constants" + vbCrLf
        ' remove existing CON sections in all pasm objects after _clkmode ready for new one
        i = 0
        ConstantFlag = False
        While i < RichTextBox1.Lines.Length
            LineOfText = RichTextBox1.Lines(i)
            If Strings.Left(LineOfText, 3) = "PUB" Then ConstantFlag = False ' reset flag
            If ConstantFlag = True Then
                RemoveLine(i)
                i -= 1 ' point to next line otherwise misses a line
            End If
            If Strings.Left(LineOfText, 10) = "  _clkmode" Then ConstantFlag = True ' add after the _clkmode
            i += 1 ' next line
        End While
        System.Windows.Forms.Application.DoEvents()
        ' now add to each CON section
        i = 0
        While i < RichTextBox1.Lines.Length
            LineOfText = RichTextBox1.Lines(i)
            If Strings.Left(LineOfText, 10) = "  _clkmode" Then
                AddLine(i, ConstantString) ' add the string of C constants created earlier
            End If
            i += 1
        End While
        System.Windows.Forms.Application.DoEvents()
        PasmCode = False ' not reading some pasm code
        'create all the cogs as .h files
        For Each Line As String In RichTextBox1.Lines ' much faster than for i=0 to richtextbox1.lines.length
            LineOfText = Line
            ' order here is important - end first, then check, then start
            If Strings.Left(LineOfText, 8) = "PASM End" Then
                TextBox16.Text = PASMFilename ' move over to the pasm tab
                RichTextBox3.Text = PasmString ' move to the pasm richtextbox
                CompilePause = False ' stop at end of shell - not writing file properly with no pause?!
                System.Windows.Forms.Application.DoEvents() ' update the richtextbox
                CompilePasm() ' compile it and save it
                PasmCode = False ' finish logging
                'System.Windows.Forms.Application.DoEvents() ' update the richtextbox
            End If
            If PasmCode = True Then PasmString += LineOfText + vbCrLf
            If Strings.Left(LineOfText, 10) = "PASM Start" Then
                TabControl1.SelectedIndex = 4 ' display the pasm code
                System.Windows.Forms.Application.DoEvents() ' update the richtextbox
                PasmCode = True ' start logging the data
                PasmString = "" ' clear the string
                PASMFilename = Strings.Mid(LineOfText, 12) ' filename stored after PASM Start
            End If
        Next
        System.Windows.Forms.Application.DoEvents()
        ' remove the compiled pasm code array ready for the new one
        RemoveFlag = False
        PreRemoveflag = False
        i = 0
        While i < RichTextBox1.Lines.Length
            LineOfText = RichTextBox1.Lines(i)
            If Strings.Left(LineOfText, 10) = "PASM Start" Then ' get the name
                PASMFilename = Strings.Mid(LineOfText, 12) ' filename stored after PASM Start
                PASMFilename = Strings.Left(PASMFilename, Strings.Len(PASMFilename) - 5) ' strip off the spin bit
                PASMFilenameLength = Strings.Len(PASMFilename) ' used later
            End If
            If Strings.Left(LineOfText, PASMFilenameLength + 5) = "void " + PASMFilename Then
                PreRemoveflag = True
            End If
            If PreRemoveflag = True And Strings.Left(LineOfText, 10) = "       /**" Then
                RemoveFlag = True ' only remove the copied .h file
            End If
            If RemoveFlag = True Then
                RemoveLine(i)
                i -= 1 ' point to next line otherwise misses a line
            End If
            If RemoveFlag = True And Strings.Left(LineOfText, 9) = "       };" Then
                RemoveFlag = False
                PreRemoveflag = False
            End If
            i += 1
        End While
        System.Windows.Forms.Application.DoEvents()
        ' add in new cog loader code
        i = 0
        While i < RichTextBox1.Lines.Length
            LineOfText = RichTextBox1.Lines(i)
            If Strings.Left(LineOfText, 10) = "PASM Start" Then ' get name for the function to be created
                PASMFilename = Strings.Mid(LineOfText, 12) ' filename stored after PASM Start
                PASMFilename = Strings.Left(PASMFilename, Strings.Len(PASMFilename) - 5) ' strip off the spin bit
            End If
            If Strings.Left(LineOfText, 8) = "PASM End" Then
                TempString = "" ' new data to add
                i += 4 ' skip the next 4 lines
                'TempString = "void " + PASMFilename + "(char cognumber)                              // function name copied from .spin name above CON section" + vbCrLf
                'TempString += "{" + vbCrLf
                ' add the .h file
                Try
                    FileOpen(1, "C:\Program Files\Catalina\Demos\" + PASMFilename + ".h", OpenMode.Input) ' open a file
                    Do
                        LineOfText = LineInput(1) ' add line from .h file with leading spaces
                        TempString += "       " + LineOfText + vbCrLf
                    Loop Until LineOfText = "};"
                Catch ex As Exception
                    MsgBox(".h file not created, check syntax of PASM code with Compile in the PASM tab")
                End Try
                FileClose(1) ' close the .h file
                TempString = Strings.Left(TempString, Strings.Len(TempString) - 2) ' remove last CRLF
                AddLine(i, TempString) ' add the new array data
            End If
            i += 1
        End While
        System.Windows.Forms.Application.DoEvents()
        'Indents() ' add the proper indentation
        'ColorCatalina() ' display in color 
        'RichTextBox1.Select(0, RichTextBox1.Text.Length) ' convert to black
        'RichTextBox1.SelectionColor = Color.Black
        RichTextBox1.SelectionStart = selectStart ' restore cursor
        RichTextBox1.SelectionLength = 0
        SendMessage(RichTextBox1.Handle, WM_SETREDRAW, New IntPtr(CInt(True)), IntPtr.Zero) ' restore cursor
        RichTextBox1.Refresh()
        'RichTextBox1.DeselectAll()
        TabControl1.SelectedIndex = 0 ' display the c code
    End Sub
    Private Sub PreCompilePASMCodeFastToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        PrecompileFast() ' much faster but changes text to black
    End Sub
    Private Sub PrecompileFast()
        Dim LineofText As String
        Dim Textarray(30000) As String
        Dim Textarray2(30000) As String ' move data back and forward between these
        Dim FileLength As Integer
        Dim i, j, k As Long
        Dim PasmCode As Boolean
        Dim PasmString As String
        Dim PASMFilename As String
        Dim PASMFilenameLength As Integer
        Dim PreRemoveflag As Boolean
        Dim RemoveFlag As Boolean
        Dim TempString As String
        Dim ConstantString(200) As String
        Dim ConstantArrayLength As Integer
        Dim ConstantFlag As Boolean
        Dim TempConst As String
        SendMessage(RichTextBox1.Handle, WM_SETREDRAW, New IntPtr(CInt(False)), IntPtr.Zero) ' disable refresh
        Dim selectStart As Integer = RichTextBox1.SelectionStart ' preserve cursor
        RichTextBox1.SaveFile("C:\Program Files\Catalina\Demos\Temp1.txt", RichTextBoxStreamType.PlainText)

        FileOpen(1, "C:\Program Files\Catalina\Demos\Temp1.txt", OpenMode.Input) ' open a file
        i = 0
        While EOF(1) = False
            Textarray(i) = LineInput(1) ' read back program into a text array
            i += 1
        End While
        FileClose(1)
        FileLength = i - 1 ' loop 0 to filelength to get lines
        ' all this block commented out as using the 'par' method rather than trying to have common variables between pasm and C
        '        k = 0 ' used by the constant array counter
        '       ConstantString(j) = "                                                                     ' Start of C hub constants"
        '      k += 1 ' add one to counter
        'For i = 0 To FileLength
        'LineofText = Textarray(i)
        'If Strings.Left(LineofText, 13) = "/* Global con" Then ConstantFlag = True ' start of constant list
        'If ConstantFlag = True And Strings.Left(LineofText, 17) = "/* End global con" Then ConstantFlag = False ' end of constant list
        'If ConstantFlag = True Then
        ' If Strings.Left(LineofText, 5) = "const" Then ' only do constant lines
        ' TempConst = Strings.Mid(LineofText, 21) ' strip off the const unsigned long 
        ' j = Strings.InStr(TempConst, ";")
        ' TempConst = Strings.Left(TempConst, j - 1)
        ' ConstantString(k) = "  " + TempConst ' two spaces plus changed to spin syntax
        ' k += 1
        ' End If
        ' End If
        ' Next
        ' rebuild constantstring with comments
        'ConstantString(k) = "                                                                     ' End of C constants"
        'ConstantArrayLength = k ' store for later
        ' remove existing CON sections in all pasm objects after _clkmode ready for new one
        'i = 0
        'j = 0
        'ConstantFlag = False
        'For i = 0 To FileLength
        'LineofText = Textarray(i)
        'If Strings.Left(LineofText, 3) = "PUB" Then ConstantFlag = False ' reset flag
        'If ConstantFlag = False Then
        ' Textarray2(j) = LineofText ' move to the second array
        ' j += 1
        'End If
        'If Strings.Left(LineofText, 10) = "  _clkmode" Then ConstantFlag = True ' add after the _clkmode
        'Next
        'FileLength = j - 1 ' length is now smaller and array is in textarray2
        ' now add the C constants to each PASM CON section
        'i = 0
        'j = 0
        'For i = 0 To FileLength ' moves from textarray2 back to textarray
        'LineofText = Textarray2(i)
        'Textarray(j) = LineofText
        'j += 1
        'If Strings.Left(LineofText, 10) = "  _clkmode" Then
        ' For k = 0 To ConstantArrayLength
        ' Textarray(j) = ConstantString(k)
        ' j += 1 ' add in the constants at the beginning of the C program, translated to PASM format
        ' Next
        'End If
        'Next
        'FileLength = j - 1 ' new file length
        'create all the cogs as .h files
        PasmCode = False ' not reading some pasm code
        For i = 0 To FileLength
            LineofText = Textarray(i)
            ' order here is important - end first, then check, then start
            If Strings.Left(LineofText, 8) = "PASM End" Then
                TextBox16.Text = PASMFilename ' move over to the pasm tab
                RichTextBox3.Text = PasmString ' move to the pasm richtextbox
                CompilePause = False ' stop at end of shell - not writing file properly with no pause?!
                System.Windows.Forms.Application.DoEvents() ' update the richtextbox
                CompilePasm() ' compile it and save it
                PasmCode = False ' finish logging
            End If
            If PasmCode = True Then PasmString += LineofText + vbCrLf
            If Strings.Left(LineofText, 10) = "PASM Start" Then
                TabControl1.SelectedIndex = 4 ' display the pasm code
                System.Windows.Forms.Application.DoEvents() ' update the richtextbox
                PasmCode = True ' start logging the data
                PasmString = "" ' clear the string
                PASMFilename = Strings.Mid(LineofText, 12) ' filename stored after PASM Start
            End If
        Next i
        ' remove the compiled pasm code array ready for the new one
        RemoveFlag = False
        j = 0 ' counter for textarray2()
        PreRemoveflag = False
        For i = 0 To FileLength
            LineofText = Textarray(i)
            If Strings.Left(LineofText, 10) = "PASM Start" Then ' get the name
                PASMFilename = Strings.Mid(LineofText, 12) ' filename stored after PASM Start
                PASMFilename = Strings.Left(PASMFilename, Strings.Len(PASMFilename) - 5) ' strip off the spin bit
                PASMFilenameLength = Strings.Len(PASMFilename) ' used later
            End If
            If Strings.Left(LineofText, PASMFilenameLength + 5) = "void " + PASMFilename Then
                PreRemoveflag = True
            End If
            If PreRemoveflag = True And Strings.Left(LineofText, 10) = "       /**" Then
                RemoveFlag = True ' only remove the copied .h file
            End If
            If RemoveFlag = False Then
                Textarray2(j) = LineofText ' move line to textarray2()
                j += 1
            End If
            If RemoveFlag = True And Strings.Left(LineofText, 9) = "       };" Then
                RemoveFlag = False
                PreRemoveflag = False
            End If
        Next i
        FileLength = j - 1 ' new length is a bit shorter

        ' add in new cog loader code
        j = 0
        i = 0
        While i <= FileLength
            LineofText = Textarray2(i)
            If Strings.Left(LineofText, 10) = "PASM Start" Then ' get name for the function to be created
                PASMFilename = Strings.Mid(LineofText, 12) ' filename stored after PASM Start
                PASMFilename = Strings.Left(PASMFilename, Strings.Len(PASMFilename) - 5) ' strip off the spin bit
            End If
            Textarray(j) = LineofText ' save the line
            j += 1
            i += 1
            If Strings.Left(LineofText, 8) = "PASM End" Then
                For k = 0 To 3
                    Textarray(j) = Textarray2(i)
                    j += 1 ' read in the next 3 lines - a blank line and the function name
                    i += 1
                Next
                ' add the .h file
                Try
                    FileOpen(1, "C:\Program Files\Catalina\Demos\" + PASMFilename + ".h", OpenMode.Input) ' open a file
                    Do
                        LineofText = LineInput(1) ' add line from .h file with leading spaces
                        Textarray(j) = "       " + LineofText ' add in spaces
                        j += 1
                    Loop Until LineofText = "};"
                Catch ex As Exception
                    MsgBox(".h file not created, check syntax of PASM code with Compile in the PASM tab")
                End Try
                FileClose(1) ' close the .h file
            End If
        End While
        FileLength = j - 1 ' new file length
        ' move back into the richtextbox - quicker to save to a file then read back
        FileOpen(1, "C:\Program Files\Catalina\Demos\Temp2.txt", OpenMode.Output) ' open a file
        For i = 0 To FileLength
            PrintLine(1, Textarray(i))
        Next
        FileClose(1)
        RichTextBox1.LoadFile("C:\Program Files\Catalina\Demos\Temp2.txt", RichTextBoxStreamType.PlainText)

        RichTextBox1.SelectionStart = selectStart ' restore cursor
        RichTextBox1.SelectionLength = 0
        SendMessage(RichTextBox1.Handle, WM_SETREDRAW, New IntPtr(CInt(True)), IntPtr.Zero) ' restore cursor
        RichTextBox1.Refresh()
        TabControl1.SelectedIndex = 0 ' display the c code
    End Sub
    Private Sub PrecompilePayloadXMMCompileDownloadRunToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        PrecompileFast() ' better to use the fast one and can do the recolor while downloading
        PayloadCompile() ' compile and download
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' ticks once a second, display the current line number
        ' as using the textchanged method slows a lot of things down
        Static OldValue As Integer
        Dim NewValue As Integer
        NewValue = RichTextBox1.GetLineFromCharIndex(RichTextBox1.SelectionStart) + 1 ' first line is 1
        If OldValue <> NewValue Then
            Label3.Text = "Line" + Strings.Str(NewValue)
            OldValue = NewValue
        End If
    End Sub

    Private Sub Button21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button21.Click
        ' turn a 32x32 icon into a .h file for inclusion in a C program
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        sizex = 32 - 1 ' size
        sizey = 32 - 1
        Dim PixelArray(sizex, sizey, 3) As Byte ' R,G,B and calculated prop byte so 4 values
        Dim x, y, i, j, k As Integer
        Dim Propbyte As Byte
        Dim OutputArray(20000) As Byte
        Dim t As Integer
        Dim Sourcefile As String
        Dim destinationfile As String
        Dim LineOfText As String
        Dim Hexstring As String
        Sourcefile = TextBox17.Text
        destinationfile = TextBox18.Text
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
        img = Image.FromStream(fs)
        fs.Close()
        PictureBox6.Image = img
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox6.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = PixelValue.R ' red byte
                PixelArray(x, y, 1) = PixelValue.G ' green byte
                PixelArray(x, y, 2) = PixelValue.B ' blue byte
                PixelArray(x, y, 3) = 0 ' pre fill the prop byte with %00000000 for Kye's code
            Next
        Next
        ' create the propeller color byte
        For y = 0 To sizey
            For x = 0 To sizex
                For i = 0 To 2
                    ConvertColor(PixelArray(x, y, i), Propbyte) ' get the value 0-3
                    Select Case i
                        Case 0 : Propbyte = Propbyte * 64 ' shift to red position
                        Case 1 : Propbyte = Propbyte * 16 ' shift to green position
                        Case 2 : Propbyte = Propbyte * 4 ' shift to blue position
                    End Select
                    PixelArray(x, y, 3) = PixelArray(x, y, 3) + Propbyte ' add to existing color
                Next i
            Next x
        Next y
        'PictureBox3.Image = MyBitmap ' bitmap array to picturebox - need to convert pixelarray back to mybitmap to show the decreased color depth 
        ' now turn the pixelarray x,y,3 into a binary file
        t = 0
        For y = 0 To sizey
            For x = 0 To sizex
                OutputArray(t) = PixelArray(x, y, 3) ' move to output array
                t += 1
            Next
        Next
        t = 0
        FileOpen(1, destinationfile, OpenMode.Output)
        PrintLine(1, "                                              // File " + destinationfile)
        PrintLine(1, "       char " + TextBox19.Text + "[] =")
        PrintLine(1, "       {")
        For i = 0 To 31 ' 32 lines each containing 32 bytes
            LineOfText = "              "
            For j = 0 To 31 ' each row
                NumberToHex(OutputArray(t), Hexstring)
                LineOfText += "0x" + LCase(Hexstring) + ", "
                t += 1
            Next
            PrintLine(1, LineOfText) ' save the line
        Next i
        PrintLine(1, "       };")
        FileClose(1)
        'MsgBox("Done")
    End Sub

    Private Sub RemoveLine(ByVal i As Long)
        ' remove a line from richtextbox1
        Dim Startline As Long
        Dim Endline As Long
        If Endline <> -1 Then
            Startline = RichTextBox1.GetFirstCharIndexFromLine(i)
            Endline = RichTextBox1.GetFirstCharIndexFromLine(i + 1)
            RichTextBox1.SelectionStart = Startline
            RichTextBox1.SelectionLength = Endline - Startline
            RichTextBox1.SelectedText = ""
        End If
    End Sub
    Private Sub AddLine(ByVal i As Long, ByVal InsertString As String)
        RichTextBox1.SelectionStart = RichTextBox1.GetFirstCharIndexFromLine(i + 1) ' character pos
        RichTextBox1.SelectionLength = 0
        RichTextBox1.SelectedText = InsertString + vbCrLf
    End Sub
    Private Sub ColorCatalina()
        Dim Greenwords As New List(Of String)
        Dim Bluewords As New List(Of String)
        Dim Goldwords As New List(Of String) ' syntax errors
        Dim Purplewords As New List(Of String)
        Dim i, q As Integer
        Dim NumberLines As Integer
        Dim StartLine As Integer
        Dim EndLine As Integer
        Dim LineOfText As String
        Dim GreenFlag, PASMflag, CommentBlockflag, Quoteflag As Boolean
        Dim CurrentColor As New Color
        Dim CommentMarker As Integer
        Dim QuoteMarker As Integer
        GreenFlag = False
        CommentBlockflag = False
        ' http://condor.depaul.edu/sjost/it236/documents/colorNames.htm
        ' purple words
        Purplewords.Add("FILE")
        'Goldwords.Add(" as ") ' should use =
        ' blue words
        Bluewords.Add("char ")
        Bluewords.Add("char*")
        Bluewords.Add("do")
        Bluewords.Add("double")
        Bluewords.Add("#define")
        Bluewords.Add("else")
        Bluewords.Add("for ")
        Bluewords.Add("fopen")
        Bluewords.Add("fclose")
        Bluewords.Add("fread")
        Bluewords.Add("fwrite")
        Bluewords.Add("fputc")
        Bluewords.Add("fgetc")
        Bluewords.Add("fprintf")
        Bluewords.Add("getchar")
        Bluewords.Add("int ")
        Bluewords.Add("if")
        Bluewords.Add("#include")
        Bluewords.Add("kbhit")
        Bluewords.Add("printf")
        Bluewords.Add("return")
        Bluewords.Add("sprintf")
        Bluewords.Add("srand")
        Bluewords.Add("void")
        Bluewords.Add("unsigned")
        Bluewords.Add("while")
        Bluewords.Add("_coginit")
        Bluewords.Add("long ")
        Bluewords.Add("const ")
        SendMessage(RichTextBox1.Handle, WM_SETREDRAW, New IntPtr(CInt(False)), IntPtr.Zero) ' disable refresh
        Dim selectStart As Integer = RichTextBox1.SelectionStart ' preserve cursor
        RichTextBox1.Select(0, RichTextBox1.Text.Length)
        RichTextBox1.SelectionColor = Color.Black ' all text to black
        RichTextBox1.DeselectAll()
        NumberLines = RichTextBox1.Lines.Length
        CurrentColor = Color.Black
        'do blue words
        For Each oneWord As String In Bluewords
            Dim pos As Integer = 0
            Do While RichTextBox1.Text.ToUpper.IndexOf(oneWord.ToUpper, pos) >= 0
                pos = RichTextBox1.Text.ToUpper.IndexOf(oneWord.ToUpper, pos)
                RichTextBox1.Select(pos, oneWord.Length)
                RichTextBox1.SelectionColor = Color.Blue ' change the foreground color
                'RichTextBox1.SelectionBackColor = Color.Black ' change the background color
                pos = pos + 1
            Loop
        Next
        Label3.Text = "Start purple"
        System.Windows.Forms.Application.DoEvents() ' update the label
        'do purple words (syntax errors eg using as instead of = because vb.net uses as
        For Each oneWord As String In Purplewords
            Dim pos As Integer = 0
            Do While RichTextBox1.Text.ToUpper.IndexOf(oneWord.ToUpper, pos) >= 0
                pos = RichTextBox1.Text.ToUpper.IndexOf(oneWord.ToUpper, pos)
                RichTextBox1.Select(pos, oneWord.Length)
                RichTextBox1.SelectionColor = Color.Purple
                pos = pos + 1
            Loop
        Next
        System.Windows.Forms.Application.DoEvents() ' update the richtextbox


        For i = 0 To NumberLines - 1
            LineOfText = RichTextBox1.Lines(i)
            If Strings.InStr(LineOfText, "/*") <> 0 Then
                CommentBlockflag = True ' start of comment block
            End If
            If CommentBlockflag = True Then ' block of comments
                StartLine = RichTextBox1.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox1.GetFirstCharIndexFromLine(i + 1) ' end of the line
                RichTextBox1.Select(StartLine, EndLine - StartLine)
                RichTextBox1.SelectionColor = Color.Green
            End If
            If Strings.Left(LineOfText, 10) = "PASM Start" Then
                PASMflag = True
                CurrentColor = Color.Green ' still in the comment section
            End If
            If Strings.Left(LineOfText, 8) = "PASM End" Then
                PASMflag = False
                CurrentColor = Color.Green ' still in the comment section
            End If
            If PASMflag = True And Strings.Left(LineOfText, 3) = "CON" Then
                CurrentColor = Color.Goldenrod
            End If
            If PASMflag = True And Strings.Left(LineOfText, 3) = "PUB" Then
                CurrentColor = Color.Firebrick
            End If
            If PASMflag = True And Strings.Left(LineOfText, 3) = "DAT" Then
                CurrentColor = Color.DarkSlateBlue
            End If
            If PASMflag = True Then
                StartLine = RichTextBox1.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox1.GetFirstCharIndexFromLine(i + 1) ' end of the line
                RichTextBox1.Select(StartLine, EndLine - StartLine)
                RichTextBox1.SelectionColor = CurrentColor
            End If
            ' do text in quotes as red
            QuoteMarker = Strings.InStr(LineOfText, Strings.Chr(34)) ' look for "
            If QuoteMarker <> 0 Then
                StartLine = RichTextBox1.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox1.GetFirstCharIndexFromLine(i + 1) ' end of the line
                For q = 1 To Strings.Len(LineOfText)
                    If Strings.Mid(LineOfText, q, 1) = Strings.Chr(34) Then
                        If Quoteflag = True Then Quoteflag = False Else Quoteflag = True ' start turning text red
                    End If
                    If Quoteflag = True Then
                        RichTextBox1.Select(StartLine + q - 1, 2) 'include the second quote
                        RichTextBox1.SelectionColor = Color.Red
                    End If
                Next
            End If
            CommentMarker = Strings.InStr(LineOfText, "'") ' search for '
            If CommentMarker <> 0 Then
                StartLine = RichTextBox1.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox1.GetFirstCharIndexFromLine(i + 1) ' end of the line
                'RichTextBox1.Select(StartLine, CommentMarker - 1) ' text before the comment in the default color
                'RichTextBox1.SelectionColor = CurrentColor ' this can change depending on the line, usually black
                RichTextBox1.Select(StartLine + CommentMarker - 1, EndLine - StartLine - CommentMarker) ' comment in green
                RichTextBox1.SelectionColor = Color.Green
            End If
            CommentMarker = Strings.InStr(LineOfText, "//") ' search for //
            If CommentMarker <> 0 Then
                StartLine = RichTextBox1.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox1.GetFirstCharIndexFromLine(i + 1) ' end of the line
                'RichTextBox1.Select(StartLine, CommentMarker - 1) ' text before the comment in the default color
                'RichTextBox1.SelectionColor = CurrentColor ' this can change depending on the line, usually black
                RichTextBox1.Select(StartLine + CommentMarker - 1, EndLine - StartLine - CommentMarker) ' comment in green
                RichTextBox1.SelectionColor = Color.Green
            End If
            If Strings.InStr(LineOfText, "*/") <> 0 Then
                CommentBlockflag = False
            End If
        Next
        RichTextBox1.SelectionStart = selectStart ' restore cursor
        RichTextBox1.SelectionLength = 0
        SendMessage(RichTextBox1.Handle, WM_SETREDRAW, New IntPtr(CInt(True)), IntPtr.Zero) ' restore cursor
        RichTextBox1.Refresh()
    End Sub

    Private Sub InsertSkeletonCogCodeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InsertSkeletonCogCodeToolStripMenuItem.Click
        Dim Mytext As String
        Dim Cogname As String
        Cogname = InputBox("Cog name. This will form the name of the .Spin file, the name of the loading function and the name of the array passed to _coginit.", "Cog Filename", "mycogject")
        Mytext = ""
        Mytext += "/* PASM Code for compilation using SpinC and inclusion as a data file" + vbCrLf
        Mytext += "PASM Start " + Cogname + ".spin" + vbCrLf
        Mytext += "CON" + vbCrLf
        Mytext += "                                                                     ' add your values here" + vbCrLf
        Mytext += "  _clkfreq = 80_000_000                                              ' 5Mhz Crystal" + vbCrLf
        Mytext += "  _clkmode = xtal1 + pll16x                                          ' x 16" + vbCrLf
        Mytext += "  graphicstart = 2048                                                ' precompiler will overwrite this" + vbCrLf
        Mytext += vbCrLf
        Mytext += "PUB Main" + vbCrLf
        Mytext += "    coginit(1,@cogstart,0)                                           ' cog 1, cogstart, dummy value" + vbCrLf
        Mytext += vbCrLf
        Mytext += "DAT" + vbCrLf
        Mytext += "                  org 0" + vbCrLf
        Mytext += "cogstart          wrbyte  testvalue, testvariable                    ' test value A" + vbCrLf
        Mytext += "                  jmp #cogstart" + vbCrLf
        Mytext += vbCrLf
        Mytext += "testvariable      long    5000                                       ' test memory location at this hub location" + vbCrLf
        Mytext += "testvalue         long    65                                         ' ascii A" + vbCrLf
        Mytext += "                  fit     496" + vbCrLf
        Mytext += "PASM End" + vbCrLf
        Mytext += "*/ " + vbCrLf
        Mytext += vbCrLf
        Mytext += "void " + Cogname + "(int cognumber, unsigned long parameters)                                        // this name copied from the .spin name in the pasm section - names must match eg void mycogject matches mycogject.spin. Also first code after this must be the .h array file. Put your code after the };" + vbCrLf
        Mytext += "{" + vbCrLf
        Mytext += "       /**" + vbCrLf
        Mytext += "       * @file " + Cogname + "_array.h" + vbCrLf
        Mytext += "       * Created with spin.binary PASM to C Array Converter." + vbCrLf
        Mytext += "       * Copyright (c) 2011, John Doe" + vbCrLf
        Mytext += "       */" + vbCrLf
        Mytext += "       unsigned long " + Cogname + "_array[] =                               // dummy data or compiled above code or #include file.h" + vbCrLf
        Mytext += "       {" + vbCrLf
        Mytext += "              0x003c0602, 0x5c7c0000, 0x00001388, 0x00000041" + vbCrLf
        Mytext += "       };" + vbCrLf
        Mytext += "       unsigned long par_cogject[] = { 1, 2, 3 };                    // data to pass to cog - ignore if not used" + vbCrLf
        Mytext += "       _coginit((int)par_cogject>>2, (int)" + Cogname + "_array>>2, cognumber);  // array name built from spin file name" + vbCrLf
        Mytext += "}" + vbCrLf
        Clipboard.Clear()
        Clipboard.SetText(Mytext)
        RichTextBox1.Paste()
    End Sub

    Private Sub SendWithXmodemToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SendWithXmodemToolStripMenuItem.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Dim Result
        Filepath = "C:\Program Files\catalina\demos"
        OpenFileDialog1.Multiselect = True
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.*" ' ? put CPM files somewhere safe
        Result = OpenFileDialog1.ShowDialog()
        If Result = 1 Then ' clicked ok 
            For Each Filenamepath In OpenFileDialog1.FileNames
                Call XModemKyeSend(Filenamepath)
            Next Filenamepath
        End If
    End Sub
    Sub XModemKyeSend(ByRef FName As String)
        Dim Filenamepath As String
        Dim a, j, i As Integer
        Dim k As Integer
        Dim LineOfText As String
        Dim SerialString As String
        Dim Counter As Integer
        Dim ErrorString As String
        Dim Packetnumber As Integer
        Dim Checksum As Long
        Dim OnesComplement As Byte
        Dim ByteRead As Byte
        Dim BinaryFileLength As Long
        Dim BinaryFileCounter As Long
        Dim Percent As Single
        Dim ErrorCounter As Byte ' 0 to 10
        Dim CPMFilename As String
        Dim Timeout As Boolean
        ProgressBar1.Maximum = 100
        ProgressBar1.Minimum = 0
        ' timer restart =true for sending via menu. False for auto send
        Filenamepath = FName
        Packetnumber = 1 ' 1 for the first packet (not zero)
        ' Try
        Dim Input As New FileStream(Filenamepath, FileMode.Open, FileAccess.Read)
        Dim br As New BinaryReader(Input)
        OpenSerialPort() ' open the serial port
        Label3.Text = "Error Count"
        Label2.Text = "0%"
        BinaryFileLength = br.BaseStream.Length() - 1
        'i = Len(Filepath) + 1 + 1  ' eg c:\n8vem and a \ = 9 and 1 more for start of name only
        Call Get_CPM_Filename(Filenamepath, CPMFilename)
        CPMFilename = Strings.UCase(CPMFilename)
        LineOfText = "XMODEM R " + CPMFilename + vbCr
        Call StringToPacket(LineOfText) ' 
        Call ClearInputBuffer()  ' clear the buffer into the PC
        For i = 1 To 35 ' need to wait for kyedos to run the xmodem program
            Sleep(100) ' wait for the xmodem text to come back so the next one is a 21
            Label3.Text = Str$(i)
            Call ClearInputBuffer()  ' clear the buffer into the PC
        Next i
        Call ClearInputBuffer()  ' clear the buffer into the PC
        Do
            SerialString = ""
            If SerialPortFound = True Then
                If SerialPortName.BytesToRead > 0 Then
                    SerialPortName.Read(InPacket, 0, 1) ' get one byte
                    SerialString = Chr(InPacket(0)) ' get a single character/string/byte
                End If
            End If
            If InPacket(0) = 21 Then
                ErrorString = "NAK"
                Exit Do ' got a ^U
            End If
            If SerialString <> "" Then
                'LineOfText = SerialString
                'Call TextLines(LineOfText) ' print it out unless it is a chr21
            End If
            Counter = Counter + 10
            Sleep(10) ' don't change this one - this is waiting for NAK
            Label1.Text = "Waiting for NAK to start" + Strings.Str(Counter) + "ms" ' display in milliseconds
            System.Windows.Forms.Application.DoEvents() ' update the label1 message
            ' add a counter and timeout if nothing
            If Counter > 5000 Then
                ErrorString = "Bypass wait for NAK - xmodem failed"
                Exit Do
            End If
            If ErrorString <> "" Then Exit Do
        Loop
        Label1.Text = ErrorString
        System.Windows.Forms.Application.DoEvents() ' update the label1 message
        Do
            ' act on each byte in the buffer array here
            XOut(0) = 1 'SOH ^A
            XOut(1) = Packetnumber
            OnesComplement = 255 - Packetnumber
            XOut(2) = OnesComplement
            Packetnumber = Packetnumber + 1
            If Packetnumber > 255 Then Packetnumber = Packetnumber - 256
            Checksum = 0
            For i = 0 To 127 ' get 128 bytes from file
                If BinaryFileCounter <= BinaryFileLength Then
                    ByteRead = br.ReadByte ' get a byte
                Else
                    ByteRead = 26 ' pad with char 26 = hex 1A because hyperterm does this ? why but it works
                End If
                XOut(i + 3) = ByteRead
                Checksum = Checksum + ByteRead
                BinaryFileCounter = BinaryFileCounter + 1
            Next
            ' create checksum
            Do
                If Checksum < 256 Then Exit Do ' work out checksum
                Checksum = Checksum - 256
            Loop
            XOut(131) = Checksum
            Call OutputXout()
            System.Windows.Forms.Application.DoEvents() ' update the label
            Timeout = False
            Do
                k = 0
                Do
                    If SerialPortFound = True Then
                        j = SerialPortName.BytesToRead
                    End If
                    If j >= 1 Then
                        If SerialPortFound = True Then
                            SerialPortName.Read(InPacket, 0, 1) ' get one byte
                        End If
                        Exit Do
                    End If
                    k += 1
                    If k > 5000 Then
                        Timeout = True ' 5 second delay for timeout, must be more than the Rx side timeout
                        Exit Do
                    End If
                    Sleep(1) ' 1ms delay
                Loop
                If InPacket(0) = 6 Then Exit Do ' remote got the packet so exit
                If InPacket(0) = 21 Then
                    ' remote didn't get it so try sending again - does up to 10x
                    ErrorCounter = ErrorCounter + 1
                    Call ClearInputBuffer() ' clear the input buffer to the PC
                    Sleep(1000) ' let the remote get itself sorted before resending the packet
                    Call OutputXout() ' resend the packet
                    Label3.Text = "Nak: " + Strings.Str(ErrorCounter)
                    System.Windows.Forms.Application.DoEvents() ' update the label
                End If
                If Timeout = True Then
                    Label3.Text = "Timeout waiting for Ack"
                    ErrorCounter = 20 'force an exit now
                    System.Windows.Forms.Application.DoEvents() ' update the label
                End If
                If ErrorCounter >= 10 Then Exit Do ' more than 10 errors
            Loop
            If ErrorCounter >= 10 Then
                Label1.Text = "10 or more errors - aborting"
                Label2.Text = "0%"
                OutPacket(0) = 24 ' send a ^X cancel
                If SerialPortFound = True Then
                    SerialPortName.Write(OutPacket, 0, 1) ' send 1 byte
                    OutPacket(0) = 3 ' send a ^C
                    SerialPortName.Write(OutPacket, 0, 1) ' send 1 byte
                End If
                Exit Do
            End If
            If BinaryFileCounter > BinaryFileLength Then Exit Do ' finish up
            Label1.Text = "Sent packet: " + Strings.Str(Packetnumber) + " = OK"
            Percent = BinaryFileCounter / BinaryFileLength
            Percent = Percent * 100
            Percent = Int(Percent)
            Label2.Text = Strings.Str(Percent) + "%"
            ProgressBar1.Value = Percent
        Loop
        If ErrorCounter < 10 Then
            OutPacket(0) = 4 ' finish byte
            If SerialPortFound = True Then
                SerialPortName.Write(OutPacket, 0, 1) ' send 1 byte
            End If
            Label2.Text = "100%"
            Label1.Text = "Finished"
            ProgressBar1.Value = 0 'done
            Call StringToPacket(vbCrLf) ' back to kyedos
        End If
        Input.Close()
        Sleep(200) ' wait for next file
        System.Windows.Forms.Application.DoEvents() ' update the labels
        'Catch ex As Exception
        '    Close()
        '    Label1.Text = Filenamepath + " not found"
        '    System.Windows.Forms.Application.DoEvents() ' update the labels
        '    Sleep(1000) ' so time to read message
        'End Try
        SerialPortName.Close() ' close the serial port
    End Sub
    Sub OpenSerialPort()
        SerialPortName.PortName = "COM1"
        SerialPortName.BaudRate = Baud ' baud rate
        SerialPortName.Parity = IO.Ports.Parity.None ' no parity
        SerialPortName.DataBits = 8 ' 8 bits
        SerialPortName.StopBits = IO.Ports.StopBits.One ' one stop bit
        SerialPortName.Open() ' open the port
        SerialPortName.DiscardInBuffer() ' clear the input buffer
    End Sub

    Private Sub ReceiveWithXmodemToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReceiveWithXmodemToolStripMenuItem.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Dim Result
        Filepath = "C:\Program Files\catalina\demos"
        SaveFileDialog1.InitialDirectory = Filepath
        SaveFileDialog1.FileName = "*.*" ' ? put CPM files somewhere safe
        Result = SaveFileDialog1.ShowDialog()
        If Result = 1 Then ' clicked ok 
            Filenamepath = SaveFileDialog1.FileName
            Call XModemKyeReceive(Filenamepath)
        End If
    End Sub
    Sub XModemKyeReceive(ByRef Filenamepath As String)
        ' pass full path eg C:\n8vem\FILE.TXT
        ' true for calls from menu bar, false for calls from pip
        'Dim Filepath As String
        Dim FileName As String
        Dim XModemIn(0 To 131) As Byte
        Dim PacketSave(0 To 127) As Byte
        Dim i As Integer
        Dim LineOfText As String
        Dim Packetnumber As Integer
        Dim OnesComplement As Byte
        Dim BinaryFileLength As Long
        Dim ErrorCounter As Byte ' give up if gets to 10
        Dim Checksum As Long
        Dim ValidPacket As Boolean
        Dim ErrorType As String
        Dim BytesToRead As Integer
        Dim RetryCounter As Integer
        OpenSerialPort() ' open the serial port
        Packetnumber = 1 ' I think it is 1 for the first packet
        Dim Output As New FileStream(Filenamepath, FileMode.Create, FileAccess.Write)
        Dim br As New BinaryWriter(Output)
        BinaryFileLength = br.BaseStream.Length() - 1
        FileName = Strings.Mid(Filenamepath, 33) ' strip off the directory
        FileName = Strings.UCase(FileName) ' upper case
        'LineOfText = Strings.Chr(13)
        'Call StringToPacket(LineOfText)
        'Sleep(300) ' to process the return
        ' run xmodem on the board
        'System.Windows.Forms.Application.DoEvents() ' update the label1 message
        LineOfText = "XMODEM S " + FileName
        Call StringToPacket(LineOfText) ' start xmodem
        LineOfText = vbCrLf
        Call StringToPacket(LineOfText) ' send a return/LF
        System.Windows.Forms.Application.DoEvents() ' update the label1 message
        Sleep(3500) ' wait a 3.5  seconds for kyedos to run xmodem
        System.Windows.Forms.Application.DoEvents() ' update the label1 message
        Call ClearInputBuffer()  ' clear the buffer into the PC
        OutPacket(0) = 21 ' send a NAK
        If SerialPortFound = True Then
            SerialPortName.Write(OutPacket, 0, 1) ' send it out
        End If
        Sleep(1000) ' wait for xmodem to put the line together
        Packetnumber = 1
        Label2.Text = ""
        Do
            ' get first byte back
            ValidPacket = True ' start with true but errors could make it false
            RetryCounter = 0
            Do
                Try
                    If SerialPortFound = True Then
                        SerialPortName.Read(InPacket, 0, 1)
                        RetryCounter = 255 ' set so it restarts
                    End If
                Catch
                    RetryCounter += 1
                    Sleep(10)
                End Try
            Loop Until RetryCounter > 100
            If RetryCounter <> 255 Then
                ValidPacket = False
                ErrorCounter = ErrorCounter + 1
                ErrorType = "Serial port timeout"
            End If
            If InPacket(0) = 4 Then
                Label1.Text = "Finished transfer"
                Label2.Text = "100%"
                Exit Do
            End If
            If InPacket(0) = 1 Then
                ' valid packet so read the rest in
                XModemIn(0) = InPacket(0) ' already got the 1st byte so put it in xmodemin array
                If SerialPortFound = True Then
                    For i = 1 To 131
                        SerialPortName.Read(InPacket, 0, 1)
                        XModemIn(i) = InPacket(0)
                    Next
                End If
                Label1.Text = "Packet " + Strings.Str(Packetnumber) ' display packet
                System.Windows.Forms.Application.DoEvents() ' update the label1 message
            End If
            If XModemIn(0) <> 1 And ValidPacket = True Then ' first number should be a 1
                ValidPacket = False
                ErrorType = "First # not ^A SOH"
                ErrorCounter = ErrorCounter + 1
            End If
            Do
                If Packetnumber < 256 Then Exit Do
                Packetnumber = Packetnumber - 256
            Loop
            OnesComplement = 255 - Packetnumber ' ones complement must match
            If Packetnumber <> XModemIn(1) And ValidPacket = True Then ' packet number should be the next one
                ValidPacket = False
                ErrorType = "Packet number mismatch"
                ErrorCounter = ErrorCounter + 1
            End If
            If XModemIn(2) <> OnesComplement And ValidPacket = True Then
                ValidPacket = False
                ErrorType = "Ones complement not valid"
                ErrorCounter = ErrorCounter + 1
            End If
            Checksum = 0
            For i = 3 To 130
                Checksum = Checksum + XModemIn(i)
            Next
            Do
                If Checksum < 256 Then Exit Do ' work out checksum
                Checksum = Checksum - 256
            Loop
            If Checksum <> XModemIn(131) And ValidPacket = True Then
                ValidPacket = False
                ErrorType = "Checksum invalid"
                ErrorCounter = ErrorCounter + 1
            End If
            If ValidPacket = True Then ' got a good packet
                'Sleep(50) ' 50 at 4800 wait a tick then acknowledge that got it
                ' no sleeps needed now with RetryCounter variable - that keeps trying till a byte arrives
                OutPacket(0) = 6 ' got the packet ^F=ACK
                If SerialPortFound = True Then
                    SerialPortName.Write(OutPacket, 0, 1) ' send it out
                End If
                'Sleep(50) ' 400 at 4800 wait for next packet to all come through - at least 200ms in pauses, plus the data, 200 does work but make it 400
                For i = 3 To 130
                    PacketSave(i - 3) = XModemIn(i) ' read for save
                Next
                Output.Write(PacketSave, 0, 128) ' save 128 bytes
                Packetnumber = Packetnumber + 1
            Else ' an error
                ' don't add one to packet number
                ' send a NAK
                ' try again
                Sleep(50) ' wait a tick then ask to send again
                OutPacket(0) = 21 ' NAK
                If SerialPortFound = True Then
                    SerialPortName.Write(OutPacket, 0, 1) ' send it out
                End If
                Sleep(3000) ' wait for next packet to all come through - at least 200ms in pauses, plus the data, 200 does work but make it 400
            End If
            Label3.Text = "Error: " + Strings.Str(ErrorCounter) + " " + ErrorType
            System.Windows.Forms.Application.DoEvents() ' update the label1 message
            If ErrorCounter >= 10 Then Exit Do
        Loop
        If ErrorCounter < 10 Then
            ' tell board got it all ok
            OutPacket(0) = 21
            If SerialPortFound = True Then
                SerialPortName.Write(OutPacket, 0, 1)
            End If
            Sleep(100)
            ' expect back a 4, and then send a 6
            OutPacket(0) = 6
            If SerialPortFound = True Then
                SerialPortName.Write(OutPacket, 0, 1)
            End If
        Else
            Label1.Text = "File transfer failed"
            Label2.Text = "0%"
            System.Windows.Forms.Application.DoEvents() ' update the label1 message
            For i = 1 To 10
                OutPacket(0) = 24 ' ^X cancel send 10 times
                If SerialPortFound = True Then
                    SerialPortName.Write(OutPacket, 0, 1) ' send it out
                End If
                Sleep(200)
            Next i
            OutPacket(0) = 3 ' ^C
            If SerialPortFound = True Then
                SerialPortName.Write(OutPacket, 0, 1) ' send it out
            End If
        End If
        Output.Close() ' close the file
        SerialPortName.Close()
    End Sub
    Private Sub Button23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.Click
        ' new
        BigBasicFile = "New.bas"
        RichTextBox4.Clear()
        RichTextBox4.AppendText("' BCX help file http://www.bcxgurus.com/help/index.html" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("#include <stdio.h>" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("$COMMAND" + vbCrLf)
        RichTextBox4.AppendText("catalina -lc -lm -D DEMO -D HIRES_VGA" + vbCrLf) ' add the name later
        RichTextBox4.AppendText("' library c, library maths, demo board, hires vga, mouse, keyboard" + vbCrLf)
        RichTextBox4.AppendText("$COMMAND" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("' ************ main **********" + vbCrLf)
        RichTextBox4.AppendText("Dim Mystring$ as string * 80            ' dim with 80 bytes" + vbCrLf)
        RichTextBox4.AppendText("Call WhiteOnBlue                        ' change the screen to white text on blue" + vbCrLf)
        RichTextBox4.AppendText("Mystring = " + Strings.Chr(34) + "Hello World" + Strings.Chr(34) + "                ' put Hello World in a string" + vbCrLf)
        RichTextBox4.AppendText("Print Mystring$                          ' print out the string" + vbCrLf)
        RichTextBox4.AppendText("Do" + vbCrLf)
        RichTextBox4.AppendText("Loop Until 0=1                          ' infinite loop" + vbCrLf)
        RichTextBox4.AppendText("' *********** end main *******" + vbCrLf + vbCrLf)
        RichTextBox4.AppendText("Sub WhiteOnBlue()                       ' white text on blue background" + vbCrLf)
        RichTextBox4.AppendText("$CCODE" + vbCrLf)
        RichTextBox4.AppendText("  int i;" + vbCrLf)
        RichTextBox4.AppendText("  for (i=0;i<40;i++)" + vbCrLf)
        RichTextBox4.AppendText("    {" + vbCrLf)
        RichTextBox4.AppendText("      t_setpos(0,0,i);                 // move cursor to next line" + vbCrLf)
        RichTextBox4.AppendText("      t_color(0,0x08FC);               // RRGGBBxx eg dark blue background 00001000 white text 11111100" + vbCrLf)
        RichTextBox4.AppendText("    }" + vbCrLf)
        RichTextBox4.AppendText("$CCODE" + vbCrLf)
        RichTextBox4.AppendText("End Sub" + vbCrLf)
        XMM = False ' small memory mode
        CheckBox2.Checked = False
        SaveINI()
        ColorBasic()
    End Sub
    Private Sub Button25_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button25.Click
        ' save
        RichTextBox4.SaveFile("C:\Program Files\Catalina\Demos\" + BigBasicFile, RichTextBoxStreamType.PlainText)
    End Sub

    Private Sub Button24_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button24.Click
        ' open
        Dim Filepath As String
        Filepath = "C:\Program Files\Catalina\Demos"
        OpenFileDialog1.Multiselect = False
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.bas"
        OpenFileDialog1.ShowDialog()
        BigBasicFile = OpenFileDialog1.FileName
        BigBasicFile = Strings.Mid(BigBasicFile, 33) ' strip off directory
        BigBasicFile = Strings.UCase(BigBasicFile)
        'PrintFileName()
        Try
            RichTextBox4.LoadFile("C:\Program Files\Catalina\Demos\" + BigBasicFile, RichTextBoxStreamType.PlainText)
            RichTextBox4.Focus()
        Catch ex As Exception
            ' user probably hit cancel
        End Try
        Label39.Text = BigBasicFile
    End Sub

    Private Sub Button26_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button26.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Filepath = "C:\Program Files\Catalina\Demos\"
        SaveFileDialog1.InitialDirectory = Filepath
        SaveFileDialog1.FileName = BigBasicFile
        SaveFileDialog1.ShowDialog()
        Filenamepath = SaveFileDialog1.FileName
        PrintFileName()
        Try
            RichTextBox4.SaveFile(Filenamepath, RichTextBoxStreamType.PlainText)
            BigBasicFile = Strings.Mid(Filenamepath, 33)
        Catch ex As Exception
            're user probably hit cancel
        End Try
        Label39.Text = BigBasicFile
    End Sub

    Private Sub Button27_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button27.Click
        CompilePause = True
        RunBCX()
    End Sub
    Private Sub Button29_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button29.Click
        Dim ErrorFlag As Boolean
        CompilePause = False
        ErrorFlag = RunBCX()
        If ErrorFlag = True Then
            CompilePause = True
            ErrorFlag = RunBCX() ' run again with a pause on the command box so can see error
        End If
    End Sub
    Function RunBCX()
        Dim Location As New Process
        Dim i As Integer
        Dim Lineoftext As String
        Dim SaveFlag As Boolean
        Dim StrUpperLowerFlag As Boolean
        Dim ItoaFlag As Boolean
        Dim ErrorFlag As Boolean = False
        Try
            ' save the file
            If BigBasicFile = "" Then BigBasicFile = InputBox("Filename", "Filename", "NEW.BAS")
            RichTextBox4.SaveFile("C:\Program Files\Catalina\Demos\" + BigBasicFile, RichTextBoxStreamType.PlainText)
            ' copy to Cat0.bas in BCX\Bin directory
            FileCopy("C:\Program Files\Catalina\Demos\" + BigBasicFile, "C:\Program Files\BCX\Bin\Cat0.bas")
            BasicCommandLine = ExtractCommand("Cat0.bas", "Cat01.bas") ' returns basiccommandline blank or with a command in it for Catalina
            BinaryPreprocessor("Cat01.bas", "Cat1.bas") ' convert all 0b to 0x, uses Cat0.bas saves as Cat1.bas in BCX\Bin
            ExtractIncludes("Cat1.bas") ' saves all the includes in a file includes.txt for later. Works on cat1.bas
            ' create a batch file
            FileOpen(1, "C:\Program Files\BCX\Bin\Cat.bat", OpenMode.Output)
            PrintLine(1, "BC cat1.bas")
            If CompilePause = True Then
                PrintLine(1, "pause") ' leaves batch file window open so can see errors
            End If
            FileClose(1)
            ' run BC and convert to cat1.c
            Location.StartInfo.FileName = "cat.bat"
            Location.StartInfo.WorkingDirectory = "C:\Program Files\BCX\Bin"
            Location.Start() ' shell the startup file
            Do
                ' wait till batch file finishes
            Loop Until Location.HasExited = True
            ' now start the multipass editing process
            ' step 1 - remove all the windows #includes
            i = 0
            FileOpen(1, "C:\Program Files\BCX\Bin\Cat1.c", OpenMode.Input)
            FileOpen(2, "C:\Program Files\BCX\Bin\Cat2.c", OpenMode.Output)
            While EOF(1) = False
                Lineoftext = LineInput(1)
                If i > 0 Then i += 1 ' increment the counter
                If Lineoftext = "// End of Object/Import Libraries To Search" Then
                    i = 1 ' start a counter
                End If
                If i > 3 Then
                    PrintLine(2, Lineoftext) ' save this line
                End If
            End While
            FileClose(1)
            FileClose(2)
            ' step 2 - add in the essential #includes
            ' later might not include all of these if running not in external memory
            ' list of catalina .h files is C:\Program Files\catalina\source\lib\include
            FileOpen(1, "C:\Program Files\BCX\Bin\Cat2.c", OpenMode.Input)
            FileOpen(2, "C:\Program Files\BCX\Bin\Cat3.c", OpenMode.Output) ' save as cat3.c
            Includefiles() ' add the include files at the beginning
            While EOF(1) = False
                Lineoftext = LineInput(1) ' read the line
                PrintLine(2, Lineoftext) ' save this line
            End While
            FileClose(1)
            FileClose(2)
            ' step 3 - replace some string handling functions and chr$
            SaveFlag = True ' save the line
            FileOpen(1, "C:\Program Files\BCX\Bin\Cat3.c", OpenMode.Input)
            FileOpen(2, "C:\Program Files\BCX\Bin\Cat4.c", OpenMode.Output)
            While EOF(1) = False
                Lineoftext = LineInput(1)
                SaveFlag = Trim_Replace(Lineoftext, SaveFlag) ' note order changed, this comes up repeatedly, see function
                SaveFlag = Left_replace(Lineoftext, SaveFlag)
                SaveFlag = Mid_declare(Lineoftext, SaveFlag) ' replace mid declare
                SaveFlag = Chr_declare(Lineoftext, SaveFlag) ' replace int=0, int=0 and one value
                SaveFlag = Chr_replace(Lineoftext, SaveFlag) ' replace the chr code
                SaveFlag = Instr(Lineoftext, SaveFlag) ' replace one line
                SaveFlag = MakeLCaseTBL(Lineoftext, SaveFlag) ' find and replace
                SaveFlag = Lpad_declare(Lineoftext, SaveFlag) ' replace one line
                SaveFlag = String_Replace(Lineoftext, SaveFlag) ' comment out a line for string$
                If SaveFlag = True Then PrintLine(2, Lineoftext) ' save this line
                SaveFlag = True ' reset for next line
            End While
            FileClose(1)
            FileClose(2)
            ' step 4 - add in RossHs strupr code and strlwr if needed
            StrUpperLowerFlag = FindStrUpperLower() ' true if these are needed, otherwise false
            SaveFlag = True
            FileOpen(1, "C:\Program Files\BCX\Bin\Cat4.c", OpenMode.Input)
            FileOpen(2, "C:\Program Files\BCX\Bin\Cat5.c", OpenMode.Output) ' save as cat5.c
            While EOF(1) = False
                Lineoftext = LineInput(1) ' read the line
                If StrUpperLowerFlag = True Then ' find and replace
                    SaveFlag = Str_upper_declare(Lineoftext, SaveFlag) ' upper and lower declare
                    SaveFlag = Str_upper(Lineoftext, SaveFlag) ' add strupper and lower
                End If
                If SaveFlag = True Then PrintLine(2, Lineoftext) ' save this line
                SaveFlag = True ' reset to true
            End While
            FileClose(1)
            FileClose(2)
            ' step 5 - add in RossHs itoa code if needed (power, bin$ and several others)
            ItoaFlag = Find_itoa() ' true if these are needed, otherwise false
            SaveFlag = True
            FileOpen(1, "C:\Program Files\BCX\Bin\Cat5.c", OpenMode.Input)
            FileOpen(2, "C:\Program Files\BCX\Bin\Cat6.c", OpenMode.Output) ' save as cat6.c
            While EOF(1) = False
                Lineoftext = LineInput(1) ' read the line
                If ItoaFlag = True Then ' find and replace
                    SaveFlag = Add_itoa_declare(Lineoftext, SaveFlag) ' itoa declare
                    SaveFlag = Add_itoa_code(Lineoftext, SaveFlag) ' add the code
                End If
                If SaveFlag = True Then PrintLine(2, Lineoftext) ' save this line
                SaveFlag = True ' reset to true
            End While
            FileClose(1)
            FileClose(2)
            'step 6 - swap memset and static in subroutines and functions
            BubbleSortMemset("C:\Program Files\BCX\Bin\Cat6.c", "C:\Program Files\BCX\Bin\Cat7.c")
            ' step 7 - remove all static variables in local functions. replace "static int a;" with "int a;"
            RemoveStatic("C:\Program Files\BCX\Bin\Cat7.c", "C:\Program Files\BCX\Bin\Cat8.c")
            ' if add more steps here, change the filecopy name below
            ' now copy this file back to the catalina directory and open it in the catalina text window
            CatalinaFile = Strings.Left(BigBasicFile, Strings.Len(BigBasicFile) - 4) + ".c"
            FileCopy("C:\Program Files\BCX\Bin\Cat8.c", "C:\Program Files\Catalina\Demos\" + CatalinaFile)
            RichTextBox1.LoadFile("C:\Program Files\Catalina\Demos\" + CatalinaFile, RichTextBoxStreamType.PlainText)
            TabControl1.SelectedIndex = 0 ' display code tab
            RichTextBox1.Focus()
            'Indents() ' add the proper indentation
            ColorCatalina() ' display in color
            PrintFileName()
        Catch ex As Exception
            MsgBox(ex.Message + " - click the 'BCX Pause' button to see the error")
            ErrorFlag = True
        End Try
        Return ErrorFlag
    End Function
    Sub Includefiles()
        ' add the include files stored earlier
        Dim LineOfText As String
        FileOpen(3, "C:\Program Files\BCX\Bin\Include.txt", OpenMode.Input)
        While EOF(3) = False
            LineOfText = LineInput(3)
            PrintLine(2, LineOfText)
        End While
        FileClose(3)

        PrintLine(2, "")
        PrintLine(2, "// *************************************************")
        PrintLine(2, "//                Typedef")
        PrintLine(2, "// *************************************************")
        PrintLine(2, "")
        PrintLine(2, "typedef unsigned char UCHAR;") ' so UCHAR works
        PrintLine(2, "typedef unsigned long DWORD;") ' so DWORD works
        PrintLine(2, "typedef unsigned long UINT;") ' so UINT works
        PrintLine(2, "")
    End Sub
    Function Trim_Replace(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        ' swap around the declarations so they are all at the start, eg register. TinyC does not mind but Catalina does. 
        'char *trim (char *S)
        '{
        ' while(*S==32 || *S==9 || *S==10 || *S==11 || *S==13)
        ' S++;
        'register int i = strlen(S);
        'while( i>0 && (S[i-1]==32 || S[i-1]==9 || S[i-1]==10
        '|| S[i-1]==11 || S[i-1]==13))
        'i--;
        'char *strtmp=BCX_TmpStr(i);
        'return (char*)memcpy(strtmp,S,i);
        '}
        If Strings.Left(Lineoftext, 20) = "char *trim (char *S)" Then
            For i = 1 To 10 ' replace function
                Lineoftext = LineInput(1) ' read in lines and discard
            Next
            PrintLine(2, "char *trim (char *S)")
            PrintLine(2, "{")
            PrintLine(2, "   register int i = strlen(S);")
            PrintLine(2, "   char *strtmp=BCX_TmpStr(i);")
            PrintLine(2, "   while(*S==32 || *S==9 || *S==10 || *S==11 || *S==13)")
            PrintLine(2, "      S++;")
            PrintLine(2, "   while( i>0 && (S[i-1]==32 || S[i-1]==9 || S[i-1]==10 || S[i-1]==11 || S[i-1]==13))")
            PrintLine(2, "      i--;")
            PrintLine(2, "   strtmp=BCX_TmpStr(i);")
            PrintLine(2, "   return (char*)memcpy(strtmp,S,i);")
            PrintLine(2, "}")
            SaveFlag = False
        End If
        Return SaveFlag
    End Function
    Function MakeLCaseTBL(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Strings.Left(Lineoftext, 26) = "char  *MakeLCaseTbl (void)" Then
            For i = 1 To 10 ' replace function
                Lineoftext = LineInput(1) ' read in lines and discard
            Next
            PrintLine(2, "char *MakeLCaseTbl (void) {")
            PrintLine(2, "   static char tbl[257];")
            PrintLine(2, "   int i; ")
            PrintLine(2, "   for (i = 0; i < 256; i++) {")
            PrintLine(2, "      tbl[i] = tolower(i);") ' string terminator
            PrintLine(2, "   }")
            PrintLine(2, "   tbl[256] = 0;")
            PrintLine(2, "   return tbl;")
            PrintLine(2, "}")
            SaveFlag = False ' this code has run so don't save line
        End If
        Return SaveFlag
    End Function
    Function Instr(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "int     instr(char*,char*,int=0,int=0);" Then
            PrintLine(2, "int     instr(char*,char*,int,int);") ' instr
            SaveFlag = False
        End If
        Return SaveFlag ' unchanged
    End Function
    Function Chr_declare(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "char*   chr(int,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0);" Then
            PrintLine(2, "char*   chr(int);") ' only one value, not 10
            SaveFlag = False
        End If
        Return SaveFlag
    End Function
    Function Mid_declare(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "char*   mid (char*, int, int=-1);" Then
            PrintLine(2, "char*   mid (char*, int, int);")
            SaveFlag = False
        End If
        Return SaveFlag
    End Function
    Function Lpad_declare(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "char*   lpad (char*,int,int=32);" Then
            PrintLine(2, "char*   lpad (char*,int,int);")
            SaveFlag = False
        End If
        Return SaveFlag
    End Function
    Function Chr_replace(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "char *chr (int a,int b,int c,int d,int e,int f,int g,int h,int i,int j)" Then
            For i = 1 To 15 ' replace entire chr function
                Lineoftext = LineInput(1) ' read in lines and discard
            Next
            PrintLine(2, "char *chr (int a)")
            PrintLine(2, "{")
            PrintLine(2, "   register char *strtmp = BCX_TmpStr(11);")
            PrintLine(2, "   strtmp[0] = a;")
            PrintLine(2, "   strtmp[1] = 0;") ' string terminator
            PrintLine(2, "   return strtmp;")
            PrintLine(2, "}")
            SaveFlag = False
        End If
        Return SaveFlag
    End Function
    Function Left_replace(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "char *left (char *S, int length)" Then
            For i = 1 To 8
                Lineoftext = LineInput(1) ' read in lines and discard
            Next
            ' add in new code - solution thanks to Kuroneko
            PrintLine(2, "char *left (char *S, int length)")
            PrintLine(2, "{")
            PrintLine(2, "  char *strtmp;")
            PrintLine(2, "  register int tmplen = strlen(S);")
            PrintLine(2, "  if(length<1) return BCX_TmpStr(1);")
            PrintLine(2, "  if(length<tmplen) tmplen=length;")
            PrintLine(2, "  strtmp = BCX_TmpStr(tmplen);")
            PrintLine(2, "  return (char*)memcpy(strtmp,S,tmplen);")
            PrintLine(2, "}")
            SaveFlag = False ' no need to save any more
        End If
        Return SaveFlag
    End Function
    Function String_Replace(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "char *string (int count, int a)" Then
            For i = 1 To 5
                Lineoftext = LineInput(1) ' read in lines and discard
            Next
            ' add in new code - swap the order - register value first before any if, while, or other conditional tests
            PrintLine(2, "char *string (int count, int a)")
            PrintLine(2, "{")
            PrintLine(2, "  register char *strtmp = BCX_TmpStr(count);")
            PrintLine(2, "  if(count<1) return BCX_TmpStr(1);")
            PrintLine(2, "  return (char*)memset(strtmp,a,count);")
            PrintLine(2, "}")
            SaveFlag = False ' no need to save any more
        End If
        Return SaveFlag
    End Function
    Function Str_upper_declare(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "//               Standard Prototypes" Then
            PrintLine(2, Lineoftext) ' save this line
            Lineoftext = LineInput(1) ' read the line
            PrintLine(2, Lineoftext) ' save this line
            Lineoftext = LineInput(1) ' read the line
            PrintLine(2, Lineoftext) ' save this line
            PrintLine(2, "char *strlwr(char *);") ' lower
            PrintLine(2, "char *strupr(char *);") ' upper
            SaveFlag = False ' don't save any more lines
        End If
        Return SaveFlag
    End Function
    Function Str_upper(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "//                 Runtime Functions" Then
            PrintLine(2, Lineoftext) ' save this line
            Lineoftext = LineInput(1) ' read the line
            PrintLine(2, Lineoftext) ' save this line
            Lineoftext = LineInput(1) ' read the line
            PrintLine(2, Lineoftext) ' save this line
            PrintLine(2, "char *strupr(char *string) {")
            PrintLine(2, "    int i, len;")
            PrintLine(2, "    len = strlen(string);")
            PrintLine(2, "    for (i = 0; i < len; i++) {")
            PrintLine(2, "      if (!isupper(string[i])) {")
            PrintLine(2, "      string[i] = toupper(string[i]);")
            PrintLine(2, "    }")
            PrintLine(2, "  }")
            PrintLine(2, "  return string;")
            PrintLine(2, "}")
            PrintLine(2, vbCrLf) ' add a space
            PrintLine(2, "char *strlwr(char *string) {")
            PrintLine(2, "    int i, len;")
            PrintLine(2, "    len = strlen(string);")
            PrintLine(2, "    for (i = 0; i < len; i++) {")
            PrintLine(2, "      if (!islower(string[i])) {")
            PrintLine(2, "      string[i] = tolower(string[i]);")
            PrintLine(2, "    }")
            PrintLine(2, "  }")
            PrintLine(2, "  return string;")
            PrintLine(2, "}")
            PrintLine(2, vbCrLf) ' add a space
            SaveFlag = False
        End If
        Return SaveFlag
    End Function
    Function Add_itoa_declare(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "//               Standard Prototypes" Then
            PrintLine(2, Lineoftext) ' save this line
            Lineoftext = LineInput(1) ' read the line
            PrintLine(2, Lineoftext) ' save this line
            Lineoftext = LineInput(1) ' read the line
            PrintLine(2, Lineoftext) ' save this line
            PrintLine(2, "char* itoa(int, char*, int);") ' declaration
            SaveFlag = False ' don't save any more lines
        End If
        Return SaveFlag
    End Function
    Function Add_itoa_code(ByVal Lineoftext As String, ByVal SaveFlag As Boolean)
        If Lineoftext = "//                 Runtime Functions" Then
            PrintLine(2, Lineoftext) ' save this line
            Lineoftext = LineInput(1) ' read the line
            PrintLine(2, Lineoftext) ' save this line
            Lineoftext = LineInput(1) ' read the line
            PrintLine(2, Lineoftext) ' save this line
            PrintLine(2, "char *itoa(int value, char *string, int radix)")
            PrintLine(2, "{")
            PrintLine(2, "  char tmp[33];")
            PrintLine(2, "  char *tp = tmp;")
            PrintLine(2, "  int i;")
            PrintLine(2, "  unsigned v;")
            PrintLine(2, "  int sign;")
            PrintLine(2, "  char *sp;")
            PrintLine(2, "  // if (radix > 36 || radix <= 1)")
            PrintLine(2, "  //  {")
            PrintLine(2, "  //     __set_errno(EDOM);")
            PrintLine(2, "  //     return 0;")
            PrintLine(2, "  //  }")
            PrintLine(2, "  sign = (radix == 10 && value < 0);")
            PrintLine(2, "  if (sign)")
            PrintLine(2, "    v = -value;")
            PrintLine(2, "  else")
            PrintLine(2, "    v = (unsigned)value;")
            PrintLine(2, "  while (v || tp == tmp)")
            PrintLine(2, "    {")
            PrintLine(2, "      i = v % radix;")
            PrintLine(2, "      v = v / radix;")
            PrintLine(2, "      if (i < 10)")
            PrintLine(2, "        *tp++ = i+'0';")
            PrintLine(2, "      else")
            PrintLine(2, "        *tp++ = i + 'a' - 10;")
            PrintLine(2, "    }")
            PrintLine(2, "  if (string == 0)")
            PrintLine(2, "  string = (char *)malloc((tp-tmp)+sign+1);")
            PrintLine(2, "  sp = string;")
            PrintLine(2, "  if (sign)")
            PrintLine(2, "    *sp++ = '-';")
            PrintLine(2, "  while (tp > tmp)")
            PrintLine(2, "    *sp++ = *--tp;")
            PrintLine(2, "  *sp = 0;")
            PrintLine(2, "  return string;")
            PrintLine(2, "}")
            PrintLine(2, vbCrLf) ' add a space
            SaveFlag = False
        End If
        Return SaveFlag
    End Function

    Function FindStrUpperLower()
        ' look for strupr( and strlwr( eg in ucase
        ' and return a flag True if found
        Dim LineOfText As String
        Dim Found As Boolean
        Dim a As Integer
        Found = False
        FileOpen(1, "C:\Program Files\BCX\Bin\Cat3.c", OpenMode.Input)
        While EOF(1) = False
            LineOfText = LineInput(1)
            a = Strings.InStr(LineOfText, "strupr(")
            If a <> 0 Then Found = True
            a = Strings.InStr(LineOfText, "strlwr(")
            If a <> 0 Then Found = True
            If Found = True Then Exit While ' no need to keep searching any more
        End While
        FileClose(1)
        Return Found
    End Function
    Function Find_itoa()
        ' look for itoa( which is used to convert numbers to hex, binary, power of 10 etc
        ' and return a flag True if found
        Dim LineOfText As String
        Dim Found As Boolean
        Dim a As Integer
        Found = False
        FileOpen(1, "C:\Program Files\BCX\Bin\Cat3.c", OpenMode.Input)
        While EOF(1) = False
            LineOfText = LineInput(1)
            a = Strings.InStr(LineOfText, "itoa(")
            If a <> 0 Then Found = True
            If Found = True Then Exit While ' no need to keep searching any more
        End While
        FileClose(1)
        Return Found
    End Function

    Sub BinaryPreprocessor(ByVal Source As String, ByVal Destination As String)
        ' opens Cat0.bas and saves cat1.bas
        ' search through all files looking for 0b010101010 etc and converts to 0xFFF
        ' numbers 0 to 0xFFFFFFFF
        ' can only do one instance per line
        Dim LineOfText As String
        Dim i, j As Integer
        Dim BinaryString As String
        Dim HexString As String
        Dim h As String
        Dim EndPointer As Integer
        FileOpen(1, "C:\Program Files\BCX\Bin\" + Source, OpenMode.Input)
        FileOpen(2, "C:\Program Files\BCX\Bin\" + Destination, OpenMode.Output)
        While EOF(1) = False
            LineOfText = LineInput(1)
            i = Strings.InStr(LineOfText, "0b")
            If i <> 0 Then
                BinaryString = "" ' reset
                j = i + 2 ' start of the digits
                While Strings.Mid(LineOfText, j, 1) = "0" Or Strings.Mid(LineOfText, j, 1) = "1" Or Strings.Mid(LineOfText, j, 1) = "_"
                    If Strings.Mid(LineOfText, j, 1) <> "_" Then
                        BinaryString += Strings.Mid(LineOfText, j, 1) ' remove _ and build up the string
                    End If
                    EndPointer = j ' so know where it finished
                    j += 1
                    If j > Strings.Len(LineOfText) Then Exit While ' end of the line
                End While
                BinaryString = "00000000000000000000000000000000" + BinaryString
                BinaryString = Strings.Right(BinaryString, 32) ' now 32 digits long
                HexString = ""
                For j = 1 To 29 Step 4
                    Select Case Strings.Mid(BinaryString, j, 4)
                        Case "0000" : h = "0" ' I'm sure there is a more efficient way to code this
                        Case "0001" : h = "1" ' but this is only a few lines so speed is not important
                        Case "0010" : h = "2"
                        Case "0011" : h = "3"
                        Case "0100" : h = "4"
                        Case "0101" : h = "5"
                        Case "0110" : h = "6"
                        Case "0111" : h = "7"
                        Case "1000" : h = "8"
                        Case "1001" : h = "9"
                        Case "1010" : h = "A"
                        Case "1011" : h = "B"
                        Case "1100" : h = "C"
                        Case "1101" : h = "D"
                        Case "1110" : h = "E"
                        Case "1111" : h = "F"
                    End Select
                    HexString += h
                Next
                LineOfText = Strings.Left(LineOfText, i - 1) + "0x" + HexString + Strings.Mid(LineOfText, EndPointer + 1)
            End If
            PrintLine(2, LineOfText)
        End While
        FileClose(1)
        FileClose(2)
    End Sub
    Sub BubbleSortMemset(ByVal Source As String, ByVal Destination As String)
        ' in subroutines all the static declarations must come first in C89 and then 
        ' all the memsets (ie set to zero) are in a group after them
        ' the BCX compiler does 
        ' static a int;
        ' memset 
        ' static b int
        ' memset
        Dim ProgramArray(30000) As String
        Dim FileSize As Integer
        Dim LineOfText As String
        Dim BubbleSwap As Boolean
        Dim i As Integer
        i = 0
        FileOpen(1, Source, OpenMode.Input)
        While EOF(1) = False
            LineOfText = LineInput(1) ' get the file in an array
            ProgramArray(i) = LineOfText
            i += 1
        End While
        FileClose(1)
        FileSize = i - 1 ' get the correct size
        Do
            BubbleSwap = False
            For i = 0 To FileSize - 1 ' set flag to false
                If Strings.Left(ProgramArray(i), 8) = "  memset" And Strings.Left(ProgramArray(i + 1), 8) = "  static" Then
                    LineOfText = ProgramArray(i) ' swap static and memset
                    ProgramArray(i) = ProgramArray(i + 1) ' swap the entries
                    ProgramArray(i + 1) = LineOfText
                    BubbleSwap = True
                End If
            Next
        Loop Until BubbleSwap = False ' loop until no more swaps
        FileOpen(1, Destination, OpenMode.Output)
        For i = 0 To FileSize
            PrintLine(1, ProgramArray(i))
        Next
        FileClose(1)
    End Sub
    Sub RemoveStatic(ByVal Source As String, ByVal Destination As String)
        ' the C compiler is putting "static" in front of everything
        ' this will fill up the stack very quickly
        ' so in all the user subs, any 'static' variables need to be removed
        Dim LineOfText As String
        Dim StaticFlag As Boolean
        StaticFlag = False
        FileOpen(1, Source, OpenMode.Input) ' open the files
        FileOpen(2, Destination, OpenMode.Output)
        While EOF(1) = False
            LineOfText = LineInput(1) ' get the line
            If LineOfText = "//       User Subs and Functions" Then
                StaticFlag = True ' from now on do the replace
            End If
            If Strings.Left(LineOfText, 11) = "  static   " Then
                LineOfText = "  " + Strings.Mid(LineOfText, 12) ' remove the static part
            End If
            PrintLine(2, LineOfText) ' save the line
        End While
        FileClose(1) ' close the files
        FileClose(2)
    End Sub

    Private Sub Button28_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button28.Click
        ColorBasic()
    End Sub

    Sub ColorBasic()
        Dim Greenwords As New List(Of String)
        Dim Bluewords As New List(Of String)
        Dim Goldwords As New List(Of String) ' syntax errors
        Dim Purplewords As New List(Of String)
        Dim i, q As Integer
        Dim NumberLines As Integer
        Dim StartLine As Integer
        Dim EndLine As Integer
        Dim LineOfText As String
        Dim GreenFlag, PASMflag, CommentBlockflag, Quoteflag As Boolean
        Dim CurrentColor As New Color
        Dim CommentMarker As Integer
        Dim QuoteMarker As Integer
        Dim CFlag As Boolean
        GreenFlag = False
        CommentBlockflag = False
        ' http://condor.depaul.edu/sjost/it236/documents/colorNames.htm
        ' purple words
        'Purplewords.Add("FILE")
        'Goldwords.Add(" as ") ' should use =
        ' greem words
        Greenwords.Add("$COMMENT")
        ' blue words
        Bluewords.Add("#include")
        Bluewords.Add("Abs(")
        Bluewords.Add(" And ")
        Bluewords.Add(" As ")
        Bluewords.Add("Atn(")
        Bluewords.Add("Binary")
        Bluewords.Add("Begin")
        Bluewords.Add("Call ")
        Bluewords.Add("Case ")
        Bluewords.Add("Chain ")
        Bluewords.Add("Chr$(")
        Bluewords.Add("Close ")
        'Bluewords.Add("com")
        'Bluewords.Add("comment")
        Bluewords.Add("Concat(")
        Bluewords.Add("Cos(")
        Bluewords.Add("$CCODE")
        'Bluewords.Add("create")
        Bluewords.Add("Data ")
        Bluewords.Add("Delete ")
        Bluewords.Add("Dim ")
        Bluewords.Add("Do")
        Bluewords.Add("Double")
        Bluewords.Add("Else")
        Bluewords.Add("End")
        Bluewords.Add("End Function")
        Bluewords.Add("End Sub")
        'Bluewords.Add("eqv")
        'Bluewords.Add("execute")
        Bluewords.Add("Exp")
        Bluewords.Add("Fcb")
        Bluewords.Add("Files")
        Bluewords.Add("Fint")
        Bluewords.Add("Fre(")
        Bluewords.Add("Function ")
        Bluewords.Add("Gosub ")
        Bluewords.Add("Goto ")
        Bluewords.Add("$HARDWARE")
        Bluewords.Add("Hex$(")
        Bluewords.Add("If ")
        Bluewords.Add("Incr(")
        Bluewords.Add("Input ")
        Bluewords.Add("Instr(")
        Bluewords.Add("Int(")
        Bluewords.Add("Left$(")
        Bluewords.Add("Left(")
        Bluewords.Add("Len(")
        Bluewords.Add("Let ")
        Bluewords.Add("Line ")
        Bluewords.Add("Loop")
        Bluewords.Add("Log(")
        Bluewords.Add("Mid(")
        Bluewords.Add("Mid$(")
        Bluewords.Add("Next ")
        Bluewords.Add("Not ")
        Bluewords.Add("Num$(")
        Bluewords.Add("Of ")
        'Bluewords.Add("on ")
        Bluewords.Add("Open ")
        Bluewords.Add("Or ")
        Bluewords.Add("For ") ' For overides Or
        Bluewords.Add("Out ")
        Bluewords.Add("Peek(")
        Bluewords.Add("Poke ")
        Bluewords.Add("Print")
        Bluewords.Add("Procedure ")
        'Bluewords.Add("read")
        'Bluewords.Add("rename")
        Bluewords.Add("Repeat")
        Bluewords.Add("Restore")
        'Bluewords.Add("ret")
        Bluewords.Add("Return" + vbLf)
        Bluewords.Add("Right(")
        Bluewords.Add("Right$(")
        Bluewords.Add("Rnd(")
        Bluewords.Add("Seek ")
        Bluewords.Add("Select ")
        Bluewords.Add("Sgn(")
        Bluewords.Add("Sin(")
        'Bluewords.Add("size")
        Bluewords.Add("Space$(")
        'Bluewords.Add("spc")
        Bluewords.Add("Sqr(")
        Bluewords.Add("Step ")
        'Bluewords.Add("stop")
        Bluewords.Add("Str$(")
        Bluewords.Add(" String") ' need the space otherwise t_string gets changed
        Bluewords.Add("String$(")
        Bluewords.Add("Sub")
        'Bluewords.Add("tab")
        Bluewords.Add("Tan(")
        'Bluewords.Add("text ")
        Bluewords.Add("Then ")
        Bluewords.Add("To ")
        Bluewords.Add("Until ")
        Bluewords.Add("Var ")
        Bluewords.Add("Val(")
        'Bluewords.Add("variable")
        Bluewords.Add("While ")
        Bluewords.Add("Wend")
        Bluewords.Add("Write ")
        'Bluewords.Add("xlate")
        Bluewords.Add("Xor ")

        SendMessage(RichTextBox4.Handle, WM_SETREDRAW, New IntPtr(CInt(False)), IntPtr.Zero) ' disable refresh
        Dim selectStart As Integer = RichTextBox4.SelectionStart ' preserve cursor
        RichTextBox4.Select(0, RichTextBox4.Text.Length)
        RichTextBox4.SelectionColor = Color.Black ' all text to black
        RichTextBox4.DeselectAll()
        NumberLines = RichTextBox4.Lines.Length
        CurrentColor = Color.Black
        ' do green workds
        For Each oneWord As String In Greenwords
            Dim pos As Integer = 0
            Do While RichTextBox4.Text.ToUpper.IndexOf(oneWord.ToUpper, pos) >= 0
                pos = RichTextBox4.Text.ToUpper.IndexOf(oneWord.ToUpper, pos)
                RichTextBox4.Select(pos, oneWord.Length)
                RichTextBox4.SelectionColor = Color.Green ' change the foreground color
                pos = pos + 1
            Loop
        Next
        'do blue words
        For Each oneWord As String In Bluewords
            Dim pos As Integer = 0
            Do While RichTextBox4.Text.ToUpper.IndexOf(oneWord.ToUpper, pos) >= 0
                pos = RichTextBox4.Text.ToUpper.IndexOf(oneWord.ToUpper, pos)
                RichTextBox4.Select(pos, oneWord.Length)
                RichTextBox4.SelectionColor = Color.Blue ' change the foreground color
                pos = pos + 1
            Loop
        Next
        'Label3.Text = "Start purple"
        'System.Windows.Forms.Application.DoEvents() ' update the label
        'do purple words (syntax errors eg using as instead of = because vb.net uses as
        'For Each oneWord As String In Purplewords
        'Dim pos As Integer = 0
        'Do While RichTextBox4.Text.ToUpper.IndexOf(oneWord.ToUpper, pos) >= 0
        ' pos = RichTextBox4.Text.ToUpper.IndexOf(oneWord.ToUpper, pos)
        ' RichTextBox4.Select(pos, oneWord.Length)
        ' RichTextBox4.SelectionColor = Color.Purple
        ' pos = pos + 1
        ' Loop
        ' Next
        System.Windows.Forms.Application.DoEvents() ' update the richtextbox
        ' *** Word wrap must be false and both scrollbars enabled on the richtextbox for the following to work ***
        RichTextBox4.WordWrap = False
        CommentBlockflag = False
        For i = 0 To NumberLines - 1
            LineOfText = RichTextBox4.Lines(i)
            ' do text in quotes as red
            QuoteMarker = Strings.InStr(LineOfText, Strings.Chr(34)) ' look for "
            If QuoteMarker <> 0 Then
                StartLine = RichTextBox4.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox4.GetFirstCharIndexFromLine(i + 1) ' end of the line
                Quoteflag = False
                For q = 1 To Strings.Len(LineOfText)
                    If Strings.Mid(LineOfText, q, 1) = Strings.Chr(34) Then
                        If Quoteflag = True Then Quoteflag = False Else Quoteflag = True ' start turning text red
                    End If
                    If Quoteflag = True Then
                        RichTextBox4.Select(StartLine + q - 1, 2) 'include the second quote
                        RichTextBox4.SelectionColor = Color.Red
                    End If
                Next
            End If
            If Strings.InStr(LineOfText, "$COMMENT") <> 0 Then
                If CommentBlockflag = False Then
                    CommentBlockflag = True ' start of comment block
                Else
                    CommentBlockflag = False ' swap 
                End If
            End If
            If CommentBlockflag = True Then ' block of comments
                StartLine = RichTextBox4.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox4.GetFirstCharIndexFromLine(i + 1) ' end of the line
                RichTextBox4.Select(StartLine, EndLine - StartLine)
                RichTextBox4.SelectionColor = Color.Green
            End If
            CommentMarker = Strings.InStr(LineOfText, "'") ' search for '
            If CommentMarker <> 0 Then
                ' doesn't like double comments '' but try not to use these
                StartLine = RichTextBox4.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox4.GetFirstCharIndexFromLine(i + 1) ' end of the line
                If EndLine <> -1 Then
                    RichTextBox4.Select(StartLine + CommentMarker - 1, EndLine - StartLine - CommentMarker) ' comment in green
                    RichTextBox4.SelectionColor = Color.Green
                End If
            End If
            CommentMarker = Strings.InStr(LineOfText, "//") ' search for //
            If CommentMarker <> 0 Then
                StartLine = RichTextBox4.GetFirstCharIndexFromLine(i) ' start of the line
                EndLine = RichTextBox4.GetFirstCharIndexFromLine(i + 1) ' end of the line
                RichTextBox4.Select(StartLine + CommentMarker - 1, EndLine - StartLine - CommentMarker) ' comment in green
                RichTextBox4.SelectionColor = Color.Green
            End If
        Next i
        ' replace with capitalised version but only if not in a CCODE block
        ' find ccode blocks and make them gray
        CFlag = False
        Dim a As Integer = 0
        Dim s As Integer = 0
        Do While RichTextBox4.Text.ToUpper.IndexOf("$CCODE", a) >= 0
            a = RichTextBox4.Text.ToUpper.IndexOf("$CCODE", a)
            If CFlag = False Then
                CFlag = True
                s = a ' start
            Else
                CFlag = False
                RichTextBox4.Select(s, a - s + 6)
                RichTextBox4.SelectionColor = Color.DarkGray
            End If
            a += 1
        Loop
        ' now replace 'print' with 'Print' but only if text is blue
        For Each oneWord As String In Bluewords
            Dim pos As Integer = 0
            Do While RichTextBox4.Text.ToUpper.IndexOf(oneWord.ToUpper, pos) >= 0
                pos = RichTextBox4.Text.ToUpper.IndexOf(oneWord.ToUpper, pos)
                RichTextBox4.Select(pos, oneWord.Length)
                If RichTextBox4.SelectionColor = Color.Blue Then ' not replaced by red, gray, green etc
                    'RichTextBox4.SelectionColor = Color.YellowGreen
                    RichTextBox4.SelectedText = oneWord
                End If
                pos = pos + 1
            Loop
        Next
        ' add here to go through all the blue ( and make them black
        Dim n
        For n = 1 To RichTextBox4.Text.Length - 1
            If Strings.Mid(RichTextBox4.Text, n, 1) = "(" Then
                RichTextBox4.Select(n - 1, 1)
                If RichTextBox4.SelectionColor = Color.Blue Then
                    RichTextBox4.SelectionColor = Color.Black
                End If
            End If
        Next
        RichTextBox4.SelectionStart = selectStart ' restore cursor
        RichTextBox4.SelectionLength = 0
        SendMessage(RichTextBox4.Handle, WM_SETREDRAW, New IntPtr(CInt(True)), IntPtr.Zero) ' restore cursor
        RichTextBox4.Refresh()
    End Sub
    Private Sub CompileCCodeWithTinyCToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CompileCCodeWithTinyCToolStripMenuItem.Click
        CompileTinyC()
    End Sub
    Private Sub CompileTinyC()
        ' comment out a few non C89 ANSI lines, eg target specific screen colors
        ' and then run the program
        Dim Location As New Process
        Dim Lineoftext As String
        Dim i As Integer
        SaveCatalina()
        Try
            Kill("C:\Program Files\tcc\Cat2.exe") ' remove the old file - otherwise if there is an error it loads the previous one
        Catch ex As Exception

        End Try
        FileCopy("C:\Program Files\Catalina\Demos\" + CatalinaFile, "C:\Program Files\tcc\Cat1.c")
        ' remove references to changing the screen color
        FileOpen(1, "C:\Program Files\tcc\Cat1.c", OpenMode.Input)
        FileOpen(2, "C:\Program Files\tcc\Cat2.c", OpenMode.Output)
        While EOF(1) = False
            Lineoftext = LineInput(1) ' load in a line
            If Strings.Left(Lineoftext, 18) = "void clearscreen()" Or Strings.Left(Lineoftext, 23) = "void WhiteOnBlue (void)" Then
                PrintLine(2, Lineoftext) ' save this line
                For i = 1 To 8
                    Lineoftext = LineInput(1) ' read in the function and discard
                Next
                PrintLine(2, "  {") ' save a dummy function instead
                PrintLine(2, "  }")
                Lineoftext = vbCrLf
            End If
            PrintLine(2, Lineoftext) ' save 
        End While
        FileClose(1)
        FileClose(2)


        ' create a batch file
        FileOpen(1, "C:\Program Files\tcc\Cat2.bat", OpenMode.Output)
        PrintLine(1, "tcc cat2.c") ' compile
        PrintLine(1, "cat2") ' run
        PrintLine(1, "pause") ' keep console open
        FileClose(1)
        ' run the batch file
        Location.StartInfo.FileName = "cat2.bat"
        Location.StartInfo.WorkingDirectory = "C:\Program Files\tcc"
        Location.Start() ' shell the startup file
        Do
            ' wait till batch file finishes
        Loop Until Location.HasExited = True
    End Sub

    Private Sub Button30_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button30.Click
        Dim ErrorFlag As Boolean = False
        CompilePause = False
        ErrorFlag = RunBCX()
        If ErrorFlag = False Then
            TabControl1.SelectedIndex = 6 ' back to basic tab, but briefly show the C tab
            RichTextBox4.Focus() ' focus back to this program
            System.Windows.Forms.Application.DoEvents() ' display on screen
            CompileTinyC()
            ColorBasic() ' do while console is in the foreground
            System.Windows.Forms.Application.DoEvents() ' display on screen
        End If
    End Sub

    Private Sub Button31_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button31.Click
        BigBasicFile = "New.bas"
        RichTextBox4.Clear()
        RichTextBox4.AppendText("' BCX help file http://www.bcxgurus.com/help/index.html" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("#include <stdio.h>" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("' ************ main **********" + vbCrLf)
        RichTextBox4.AppendText("Dim Mystring$ as string * 80            ' dim with 80 bytes" + vbCrLf)
        RichTextBox4.AppendText("Mystring = " + Strings.Chr(34) + "Hello World" + Strings.Chr(34) + "                ' put Hello World in a string" + vbCrLf)
        RichTextBox4.AppendText("Print Mystring$                          ' print out the string" + vbCrLf)
        RichTextBox4.AppendText("Line Input " + Strings.Chr(34) + "Enter a string: " + Strings.Chr(34) + ", Mystring$ ' input a string. Use Line Input and needs some text" + vbCrLf)
        RichTextBox4.AppendText("Print Mystring$                          ' print out the string" + vbCrLf)

        ColorBasic()
    End Sub
    Sub ExtractIncludes(ByVal Source As String)
        ' get all the includes in the program and store them for later
        Dim LineOfText As String
        FileOpen(1, "C:\Program Files\BCX\Bin\" + Source, OpenMode.Input)
        FileOpen(2, "C:\Program Files\BCX\Bin\Include.txt", OpenMode.Output)
        While EOF(1) = False
            LineOfText = LineInput(1)
            If Strings.Left(LineOfText, 8) = "#include" Then
                PrintLine(2, LineOfText)
            End If
        End While
        FileClose(1)
        FileClose(2)
    End Sub
    Function ExtractCommand(ByVal Source As String, ByVal Destination As String)
        ' extract out all instructions in the command line
        ' use this if it exists, if not, returns empty string and use the default in Settings
        Dim CommandLineString As String
        Dim LineOfText As String
        CommandLineString = "" ' returns blank if nothing
        FileOpen(1, "C:\Program Files\BCX\Bin\" + Source, OpenMode.Input)
        FileOpen(2, "C:\Program Files\BCX\Bin\" + Destination, OpenMode.Output)
        While EOF(1) = False
            LineOfText = LineInput(1)
            If Strings.Left(LineOfText, 8) = "$COMMAND" Then
                CommandLineString = LineInput(1) ' read in the command line
                ' need to add in my filename - hopefully can add at the beginning or end
                CommandLineString += " " + Strings.Left(BigBasicFile, Strings.Len(BigBasicFile) - 4) + ".c"
                'LineOfText = LineInput(1) ' discard next line
                While LineInput(1) <> "$COMMAND"
                    ' read in until the second $Command (might be comments)
                End While
            Else
                PrintLine(2, LineOfText)
            End If
        End While
        FileClose(1)
        FileClose(2)
        Return CommandLineString
    End Function


    Private Sub Button32_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button32.Click
        ' new
        BigBasicFile = "New.bas"
        RichTextBox4.Clear()
        RichTextBox4.AppendText("' BCX help file http://www.bcxgurus.com/help/index.html" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("#include <stdio.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <stdlib.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <string.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <math.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <ctype.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <errno.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <float.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <inttypes.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <limits.h>" + vbCrLf)
        ' RichTextBox4.AppendText("#include <mathconst.h>" + vbCrLf) ' commented out as tinyc does not like this
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("$COMMAND" + vbCrLf)
        RichTextBox4.AppendText("catalina -lcx -lm -x5 -M 128k -D DRACBLADE -D VGA_HIRES" + vbCrLf)
        RichTextBox4.AppendText("' library cx, library maths (slow, doesn't use a cog), memory size, board, high res vga, mouse, keyboard" + vbCrLf)
        RichTextBox4.AppendText("$COMMAND" + vbCrLf)
        RichTextBox4.AppendText("' ************ main **********" + vbCrLf)
        RichTextBox4.AppendText("Dim Mystring$ as string * 80            ' dim with 80 bytes" + vbCrLf)
        RichTextBox4.AppendText("Call WhiteOnBlue                        ' change the screen to white text on blue" + vbCrLf)
        RichTextBox4.AppendText("Mystring = " + Strings.Chr(34) + "Hello World" + Strings.Chr(34) + "                ' put Hello World in a string" + vbCrLf)
        RichTextBox4.AppendText("Print Mystring$                          ' print out the string" + vbCrLf)
        RichTextBox4.AppendText("Do" + vbCrLf)
        RichTextBox4.AppendText("Loop Until 0=1                          ' infinite loop" + vbCrLf)
        RichTextBox4.AppendText("' *********** end main *******" + vbCrLf + vbCrLf)
        RichTextBox4.AppendText("Sub WhiteOnBlue()                       ' white text on blue background" + vbCrLf)
        RichTextBox4.AppendText("$CCODE" + vbCrLf)
        RichTextBox4.AppendText("  int i;" + vbCrLf)
        RichTextBox4.AppendText("  for (i=0;i<40;i++)" + vbCrLf)
        RichTextBox4.AppendText("    {" + vbCrLf)
        RichTextBox4.AppendText("      t_setpos(0,0,i);                 // move cursor to next line" + vbCrLf)
        RichTextBox4.AppendText("      t_color(0,0x08FC);               // RRGGBBxx eg dark blue background 00001000 white text 11111100" + vbCrLf)
        RichTextBox4.AppendText("    }" + vbCrLf)
        RichTextBox4.AppendText("$CCODE" + vbCrLf)
        RichTextBox4.AppendText("End Sub" + vbCrLf)
        XMM = True ' large memory mode
        CheckBox2.Checked = True
        SaveINI()
        ColorBasic()
    End Sub

    Private Sub Button33_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button33.Click
        Dim ErrorFlag As Boolean = False
        CompilePause = False
        ErrorFlag = RunBCX()
        If ErrorFlag = False Then
            TabControl1.SelectedIndex = 6 ' back to basic tab, but briefly show the C tab
            RichTextBox4.Focus() ' focus back to this program
            System.Windows.Forms.Application.DoEvents() ' display on screen
            ColorBasic() ' do while console is in the foreground
            System.Windows.Forms.Application.DoEvents() ' display on screen
            If XMM = False Then ' different compiles depending on external memory
                CompileDownloadRunNoXMM()
            Else
                PayloadCompile()
            End If
        End If
    End Sub
    Sub PrintFileSize()
        Dim Filename As String
        Dim Size As Integer
        ' print after the batch file has completed
        Try
            Filename = Strings.Left(CatalinaFile, Strings.Len(CatalinaFile) - 2) ' remove the .c
            Filename += ".binary"
            'Label37.Text = Filename
            Filename = "c:\program files\catalina\demos\" + Filename
            Dim info As New FileInfo(Filename)
            Dim length As Long = info.Length
            Size = length / 1000
            Label37.Text = Strings.Str(Size) + "K"
        Catch ex As Exception
            ' in case file doesn't exist
        End Try
    End Sub

    Private Sub Button34_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button34.Click
        BigBasicFile = "New.bas"
        RichTextBox4.Clear()
        RichTextBox4.AppendText("' BCX help file http://www.bcxgurus.com/help/index.html" + vbCrLf)
        RichTextBox4.AppendText("' Minimialist version for the Propeller for flashing leds etc" + vbCrLf)
        RichTextBox4.AppendText("#include <catalina_cog.h>" + vbCrLf)
        RichTextBox4.AppendText("$COMMAND" + vbCrLf)
        RichTextBox4.AppendText("catalina -lci -D DEMO -D NO_HMI -D NO_ARGS  -D ALTERNATE -D NO_FLOAT" + vbCrLf)
        RichTextBox4.AppendText("' library ci, demo board, no vga, no mouse, no keyboard, no floating point" + vbCrLf)
        RichTextBox4.AppendText("$COMMAND" + vbCrLf)
        RichTextBox4.AppendText("' ************ main **********" + vbCrLf)
        RichTextBox4.AppendText("Do" + vbCrLf)
        RichTextBox4.AppendText("  High(0)              ' bit 0 high (pin 1 on physical chip)" + vbCrLf)
        RichTextBox4.AppendText("  Sleep(1000)          ' sleep this number of milliseconds" + vbCrLf)
        RichTextBox4.AppendText("  Low(0)               ' bit 0 low" + vbCrLf)
        RichTextBox4.AppendText("  Sleep(1000)          ' sleep" + vbCrLf)
        RichTextBox4.AppendText("Loop" + vbCrLf)
        RichTextBox4.AppendText("' ********** end main ********" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("Sub High(Pin as Integer)" + vbCrLf)
        RichTextBox4.AppendText("  Dim Mask As uint" + vbCrLf)
        RichTextBox4.AppendText("  Mask = Mask Or (1 << Pin) ' shift and logical OR" + vbCrLf)
        RichTextBox4.AppendText("  _dira(Mask, Mask)" + vbCrLf)
        RichTextBox4.AppendText("  _outa(Mask,0xFFFFFFFF)' set just this pin high" + vbCrLf)
        RichTextBox4.AppendText("End Sub" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("Sub Low(Pin as Integer)" + vbCrLf)
        RichTextBox4.AppendText("  Dim Mask As uint" + vbCrLf)
        RichTextBox4.AppendText("  Mask = Mask Or (1 << Pin) ' shift and logical OR" + vbCrLf)
        RichTextBox4.AppendText("  _dira(Mask, Mask)" + vbCrLf)
        RichTextBox4.AppendText("  _outa(Mask,0x00000000)' set just this pin low" + vbCrLf)
        RichTextBox4.AppendText("End Sub" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("Sub Sleep(ByVal milliseconds As int)" + vbCrLf)
        RichTextBox4.AppendText("  Dim clkcycles As uint ' uint = long" + vbCrLf)
        RichTextBox4.AppendText("  clkcycles = (_clockfreq() / 1000) * milliseconds ' calculate the number of cycles" + vbCrLf)
        RichTextBox4.AppendText("  clkcycles -= 4296 ' subtract 4296" + vbCrLf)
        RichTextBox4.AppendText("  If clkcycles < 381 Then clkcycles = 381 ' minimum" + vbCrLf)
        RichTextBox4.AppendText("  _waitcnt(clkcycles + _cnt())" + vbCrLf)
        RichTextBox4.AppendText("End Sub" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        ColorBasic()
    End Sub

    Private Sub CompileDownloadEepromLMMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CompileDownloadEepromLMMToolStripMenuItem.Click
        CompileDownloadEeprom()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim ErrorFlag As Boolean = False
        CompilePause = False
        ErrorFlag = RunBCX()
        If ErrorFlag = False Then
            TabControl1.SelectedIndex = 6 ' back to basic tab, but briefly show the C tab
            RichTextBox4.Focus() ' focus back to this program
            System.Windows.Forms.Application.DoEvents() ' display on screen
            ColorBasic() ' do while console is in the foreground
            System.Windows.Forms.Application.DoEvents() ' display on screen
            CompileDownloadEeprom()
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ' new
        BigBasicFile = "New.bas"
        RichTextBox4.Clear()
        RichTextBox4.AppendText("' BCX help file http://www.bcxgurus.com/help/index.html" + vbCrLf)
        RichTextBox4.AppendText("' See the file catalina_hmi.h in 'C:\Program Files\Catalina\include' for mouse/display/keyboard commands" + vbCrLf)
        RichTextBox4.AppendText("' Much smaller code than stdio using custom print and keyboard and mouse functions' for mouse/display/keyboard commands" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("#include <stdio.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <catalina_hmi.h>" + vbCrLf)
        RichTextBox4.AppendText("#include <ctype.h>" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("$COMMAND" + vbCrLf)
        RichTextBox4.AppendText("catalina -lc -lm -D DEMO -D HIRES_VGA" + vbCrLf) ' add the name later
        RichTextBox4.AppendText("' library c, library maths, demo board, hires vga, mouse, keyboard" + vbCrLf)
        RichTextBox4.AppendText("$COMMAND" + vbCrLf)
        RichTextBox4.AppendText(vbCrLf)
        RichTextBox4.AppendText("' ************ main **********" + vbCrLf)
        RichTextBox4.AppendText("  Dim key As char" + vbCrLf)
        RichTextBox4.AppendText("  t_string(1," + Chr(34) + "Hello World. Hit a key:" + Chr(34) + ") 	' startup prompt" + vbCrLf)
        RichTextBox4.AppendText("  t_char(1,13)					' carriage return" + vbCrLf)
        RichTextBox4.AppendText("  t_char(1,10)					' line feed" + vbCrLf)
        RichTextBox4.AppendText("  key = (char)k_wait() 				' get the key" + vbCrLf)
        RichTextBox4.AppendText("  t_string(1," + Chr(34) + "Key pressed=" + Chr(34) + ") 			' print a line" + vbCrLf)
        RichTextBox4.AppendText("  t_char(1,key)  					' print the character" + vbCrLf)
        RichTextBox4.AppendText("  t_char(1,13)					' carriage return" + vbCrLf)
        RichTextBox4.AppendText("  t_char(1,10)					' line feed" + vbCrLf)
        RichTextBox4.AppendText("  t_hex(1,key) 					' hex value" + vbCrLf)
        RichTextBox4.AppendText("  Do" + vbCrLf)
        RichTextBox4.AppendText("  Loop Until 0=1					' endless loop" + vbCrLf)
        RichTextBox4.AppendText("' ******** end main *********")
        XMM = False ' small memory mode
        CheckBox2.Checked = False ' no external memory
        SaveINI()
        ColorBasic()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        RichTextBox3.Text = ""
        RichTextBox3.AppendText("CON" + vbCrLf)
        RichTextBox3.AppendText("  _clkfreq = 80_000_000" + vbCrLf)
        RichTextBox3.AppendText("  _clkmode = xtal1 + pll16x" + vbCrLf)
        RichTextBox3.AppendText(vbCrLf)
        RichTextBox3.AppendText("PUB Main" + vbCrLf)
        RichTextBox3.AppendText("    coginit(1,@entry,0)                     ' cog 1, entry, dummy value" + vbCrLf)
        RichTextBox3.AppendText(vbCrLf)
        RichTextBox3.AppendText("DAT" + vbCrLf)
        RichTextBox3.AppendText("                  org 0" + vbCrLf)
        RichTextBox3.AppendText("entry                                          ' start of the cog code" + vbCrLf)
        RichTextBox3.AppendText("                  mov arraypointer,par         ' arraypointer is the address of the array" + vbCrLf)
        RichTextBox3.AppendText("                  rdlong array0,arraypointer   ' array0 = array[0]" + vbCrLf)
        RichTextBox3.AppendText("                  mov array1,array0            ' array[1]=array[0] - long is 4 bytes so add 4" + vbCrLf)
        RichTextBox3.AppendText("                  add array1,#4                ' array[1] += 1 change the value so see cog works" + vbCrLf)
        RichTextBox3.AppendText("                  add arraypointer,#1          ' pointer += 1" + vbCrLf)
        RichTextBox3.AppendText("                  wrlong array1,arraypointer   ' write array[1] back to hub" + vbCrLf)
        RichTextBox3.AppendText("                  jmp #entry" + vbCrLf)
        RichTextBox3.AppendText(vbCrLf)
        RichTextBox3.AppendText("arraypointer      long    $00000000            ' pointer to array[0]" + vbCrLf)
        RichTextBox3.AppendText("array0            long    $00000000            ' first array location" + vbCrLf)
        RichTextBox3.AppendText("array1            long    $00000000            ' second array location" + vbCrLf)
        RichTextBox3.AppendText("                  fit 496" + vbCrLf)
        TextBox16.Text = "cogpar.spin"
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        Dim width As Integer
        Dim WidthArray(127) As Byte  ' width of each character
        Dim CharacterArray(127, 11) As Long ' the characters
        sizex = 32 ' size
        sizey = 32
        Dim PixelArray(sizex, sizey, 2) As Byte ' R,G,B
        Dim x, y, i, j, k, w, t As Integer
        Dim Lineoftext As String
        Dim HexString As String
        Dim Character As Integer
        Dim MyBitmap As New Bitmap(sizex, sizey)
        Dim myGR As Graphics = Graphics.FromImage(MyBitmap)
        Dim SolidBrush As New SolidBrush(Color.White) ' white background in the bitmap
        ' Create string to draw.
        Dim drawString As String
        ' Create font and brush.
        Dim drawFont As New Font("Microsoft Sans Serif", 8)
        'Dim drawFont As New Font("Courier New", 10)
        Dim drawBrush As New SolidBrush(Color.Black)
        ' Create point for upper-left corner of drawing.
        'Dim drawPoint As New PointF(10.0F, 10.0F)
        Dim drawPoint As New PointF(0.0F, 0.0F)
        Label29.Text = "Processing"
        For Character = 0 To 127
            TextBox1.Text = Strings.Chr(Character) + "|"
            drawString = TextBox1.Text
            myGR.FillRectangle(SolidBrush, 0, 0, 32, 32) ' paint background
            ' Draw string to screen.
            myGR.DrawString(drawString, drawFont, drawBrush, drawPoint)
            PictureBox1.Image = MyBitmap ' displays but the format seems to be remembered by the picturebox
            'MyBitmap.Save("C:\Temp.bmp", System.Drawing.Imaging.ImageFormat.Bmp) ' for debugging
            For y = 0 To sizey - 1
                For x = 0 To sizex - 1
                    PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                    PixelArray(x, y, 0) = PixelValue.R ' red byte
                    PixelArray(x, y, 1) = PixelValue.G ' green byte
                    PixelArray(x, y, 2) = PixelValue.B ' blue byte
                Next
            Next
            ' work out the width - type the character plus | at the end
            ' examples using BitFontCreator
            ' space is 3x16, A is 9x16, B is 10x16, a is 8x16, { is 5x16
            ' some of these are not coming out the same
            For x = 31 To 0 Step -1
                If PixelArray(x, 3, 0) <> 255 Then
                    width = x - 3 ' test this with a few characters - { is the tallest, underscore the lowest
                    Exit For
                End If
            Next
            Label6.Text = Strings.Str(width) + "x12"
            RichTextBox7.Text = ""
            For y = 1 To 12
                w = 2 ^ (width - 1)
                For x = 2 To 1 + width
                    If PixelArray(x, y, 0) = 0 Then
                        RichTextBox7.Text += "X"
                        CharacterArray(Character, y - 1) += w ' add to character array
                    Else
                        RichTextBox7.Text += "."
                    End If
                    w = w / 2 ' width counter in binary
                Next
                RichTextBox7.Text += vbCrLf
            Next y
            System.Windows.Forms.Application.DoEvents() ' display on screen
            'Sleep(500)
            WidthArray(Character) = width ' store the width
        Next Character
        ' work out how many longs
        k = 12 * 128 + 128 ' 12 lines per character, 128 characters, plus 128 for the widths
        FileOpen(1, "c:\sans_serif.c", OpenMode.Output)
        ' save the font
        t = 0
        PrintLine(1, "// 128 rows, one for each ascii character 0 to 127")
        PrintLine(1, "// first long is 0000HHWW where HH is the height in hex and WW is the width in hex")
        PrintLine(1, "       unsigned long sans_serif_font["+trim(Strings.Str(k))+"] =") ' fonts - 128x12 = 1536
        PrintLine(1, "       {")
        For i = 0 To 127 ' 128 lines each with 12 longs (12 lines per character)
            Lineoftext = "              "
            ' get the width and add &H0C which is the height
            k = WidthArray(i) + &HC00
            LongToHex(k, HexString)
            Lineoftext += "0x" + LCase(HexString) + ","
            For j = 0 To 11 ' each row
                ' add the pixels, one row per ascii character
                LongToHex(CharacterArray(i, j), HexString)
                Lineoftext += "0x" + LCase(HexString) + ", "
                t += 1
            Next
            PrintLine(1, Lineoftext) ' save the line
        Next i
        PrintLine(1, "       };")
        FileClose(1)
        Label29.Text = "Done"
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim FontHeight As Integer ' this value determined by the underscore and the { - use BitFontCreater but test all chars because sometimes the top and bottom lines are never used
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        Dim width As Integer
        Dim WidthArray(127) As Byte  ' width of each character
        Dim CharacterArray(127, 20) As Long ' the characters
        sizex = 32 ' size
        sizey = 32
        Dim PixelArray(sizex, sizey, 2) As Byte ' R,G,B
        Dim x, y, i, j, k, w, t, h As Integer
        Dim Lineoftext As String
        Dim HexString As String
        Dim Character As Integer
        Dim MyBitmap As New Bitmap(sizex, sizey)
        Dim myGR As Graphics = Graphics.FromImage(MyBitmap)
        Dim SolidBrush As New SolidBrush(Color.White) ' white background in the bitmap
        ' Create string to draw.
        Dim drawString As String
        ' Create font and brush.
        Dim drawFont As New Font("Courier New", 10)
        Dim drawBrush As New SolidBrush(Color.Black)
        ' Create point for upper-left corner of drawing.
        'Dim drawPoint As New PointF(10.0F, 10.0F)
        Dim drawPoint As New PointF(0.0F, 0.0F)
        FontHeight = 15
        Label29.Text = "Processing"
        For Character = 0 To 127
            TextBox1.Text = Strings.Chr(Character) + "|"
            drawString = TextBox1.Text
            myGR.FillRectangle(SolidBrush, 0, 0, 32, 32) ' paint background
            ' Draw string to screen.
            myGR.DrawString(drawString, drawFont, drawBrush, drawPoint)
            PictureBox1.Image = MyBitmap ' displays but the format seems to be remembered by the picturebox
            'MyBitmap.Save("C:\Temp.bmp", System.Drawing.Imaging.ImageFormat.Bmp) ' for debugging
            For y = 0 To sizey - 1
                For x = 0 To sizex - 1
                    PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                    PixelArray(x, y, 0) = PixelValue.R ' red byte
                    PixelArray(x, y, 1) = PixelValue.G ' green byte
                    PixelArray(x, y, 2) = PixelValue.B ' blue byte
                Next
            Next
            ' work out the width - type the character plus | at the end
            ' some of these are not coming out the same
            For x = 31 To 0 Step -1
                If PixelArray(x, 5, 0) <> 255 Then
                    width = x - 5 ' test this with a few characters - { is the tallest, underscore the lowest
                    Exit For
                End If
            Next
            Label6.Text = Strings.Str(width) + "x" + Strings.Str(FontHeight)
            RichTextBox7.Text = ""
            For y = 1 To FontHeight
                w = 2 ^ (width - 1)
                For x = 2 To 1 + width
                    If PixelArray(x, y, 0) = 0 Then
                        RichTextBox7.Text += "X"
                        CharacterArray(Character, y - 1) += w ' add to character array
                    Else
                        RichTextBox7.Text += "."
                    End If
                    w = w / 2 ' width counter in binary
                Next
                RichTextBox7.Text += vbCrLf
            Next y
            System.Windows.Forms.Application.DoEvents() ' display on screen
            'Sleep(500)
            WidthArray(Character) = width ' store the width
        Next Character
        ' work out how many longs
        k = FontHeight * 128 + 128 ' fontheight lines per character, 128 characters, plus 128 for the widths
        FileOpen(1, "c:\courier10.c", OpenMode.Output)
        ' save the font
        t = 0
        PrintLine(1, "// 128 rows, one for each ascii character 0 to 127")
        PrintLine(1, "// first long is 0000HHWW where HH is the height in hex and WW is the width in hex")
        PrintLine(1, "       unsigned long courier10_font[" + Trim(Strings.Str(k)) + "] =") ' fonts - 128x12 = 1536
        PrintLine(1, "       {")
        For i = 0 To 127 ' 128 lines each with 12 longs (12 lines per character)
            Lineoftext = "              "
            ' get the width and add the height
            k = WidthArray(i) + FontHeight * 256
            LongToHex(k, HexString)
            Lineoftext += "0x" + LCase(HexString) + ","
            For j = 0 To FontHeight - 1 ' each row
                ' add the pixels, one row per ascii character
                LongToHex(CharacterArray(i, j), HexString)
                Lineoftext += "0x" + LCase(HexString) + ", "
                t += 1
            Next
            PrintLine(1, Lineoftext) ' save the line
        Next i
        PrintLine(1, "       };")
        FileClose(1)
        Label29.Text = "Done"
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Shell("RunDll32.exe shell32.dll,Control_RunDLL hotplug.dll", AppWinStyle.NormalFocus, True)
        MsgBox("got to here")
    End Sub

    Public Sub RGB_to_HSL(ByVal c As Color)
        Dim Hue As Double
        Dim Saturation As Double
        Dim Luminance As Double
        c = Color.FromArgb(255, 40, 80, 120)
        Hue = c.GetHue
        Saturation = c.GetSaturation()
        Luminance = c.GetBrightness
    End Sub

    Private Sub HSVtoRGB(ByRef Red, ByRef Green, ByRef Blue, ByVal Hue, ByVal Sat, ByVal Value)
        Dim i As Long
        Dim f As Double, p As Double, q As Double, t As Double

        If Sat = 0 Then
            Red = Value
            Green = Value
            Blue = Value
            Exit Sub
        End If

        i = Hue \ 60
        Hue = Hue / 60
        f = Hue - i
        p = Value * (1 - Sat)
        q = Value * (1 - Sat * f)
        t = Value * (1 - Sat * (1 - f))

        Select Case i
            Case 0
                Red = Value
                Green = t
                Blue = p
            Case 1
                Red = q
                Green = Value
                Blue = p
            Case 2
                Red = p
                Green = Value
                Blue = t
            Case 3
                Red = p
                Green = q
                Blue = Value
            Case 4
                Red = t
                Green = p
                Blue = Value
            Case 5
                Red = Value
                Green = p
                Blue = q
        End Select

    End Sub

    'Function RGBtoHSV(Red, Green, Blue, ByRef Hue, ByRef Sat, ByRef Value)
    '    Dim Temp As Double
    '    Dim xa As Double
    '    Dim ya As Double
    '
    '    Temp = (Red + Green + Blue) / 3
    '    xa = (Green - Red) / Sqr(2)
    '    ya = (Blue + Blue - Red - Green) / Sqr(6)
    '    Hue = Arg(xa, ya) * 180 / pi + 150
    '    Sat = Arg(Temp, Module(Red - Temp, Green - Temp, Blue - Temp)) * 100 / Atn(Sqr(6))
    '    Value = Temp / 2.55
    '
    '    If Sat = 0 Or Value = 0 Then Hue = 0
    '    If Hue < 0 Then Hue = Hue + 360
    '    If Hue >= 360 Then Hue = Hue - 360
    'End Function

    Public Sub RGBtoHSV(ByVal Red, ByVal Green, ByVal Blue, ByRef Hue, ByRef Sat, ByRef Value)
        Dim min As Double, max As Double, delta As Double
        If Red <= Green And Red <= Blue Then min = Red
        If Green <= Red And Green <= Blue Then min = Green
        If Blue <= Red And Blue <= Green Then min = Blue

        If Red >= Green And Red >= Blue Then max = Red
        If Green >= Red And Green >= Blue Then max = Green
        If Blue >= Red And Blue >= Green Then max = Blue

        Value = max
        delta = max - min

        If Not delta = 0 Then
            Sat = delta / max
        Else
            Sat = 0
            Hue = 0
            Exit Sub
        End If

        If Red = max Then
            Hue = (Green - Blue) / delta
        ElseIf Green = max Then
            Hue = 2 + (Blue - Red)
        Else
            Hue = 4 + (Red - Green) / delta
        End If
        Hue = Hue * 60
        If Hue < 0 Then Hue = Hue + 360
    End Sub

    '  Private Sub UnRGB(ByVal Color As OLE_COLOR, ByRef r, ByRef g, ByRef b)
    '      r = Color And (Not &HFFFFFF00)
    '      g = (Color And (Not &HFFFF00FF)) \ &H100&
    '      b = (Color And (Not &HFF00FFFF)) \ &HFFFF&
    '  End Sub

    '  Function Modules(ByVal X, ByVal Y, ByVal z)
    ' ' Returns the module of a 3D vector
    '     Modules = Sqr(X * X + Y * Y + z * z)
    ' End Function

    '   Function Arg(ByVal xa, ByVal ya)
    ' 'Returns the argument (in radians) of a point in the (x,y) plan
    '
    '        If xa = 0 And ya = 0 Then Arg = 0 : Exit Function
    '        If xa = 0 And ya >= 0 Then Arg = pi / 2 : Exit Function
    '        If ya = 0 And xa < 0 Then Arg = pi : Exit Function
    '        If xa = 0 And ya < 0 Then Arg = -pi / 2 : Exit Function
    '
    '        If xa > 0 Then Arg = Atn(ya / xa) : Exit Function
    '
    '        If xa < 0 And ya >= 0 Then Arg = pi - Atn(-ya / xa)
    '        If xa < 0 And ya < 0 Then Arg = -pi + Atn(-ya / -xa)
    '
    '    End Function

    '/ <summary>
    '/ Converts a colour from HSL to RGB
    '/ </summary>
    '/ <remarks>Adapted from the algoritm in Foley and Van-Dam</remarks>
    '/ <param name="hsl">The HSL value</param>
    '/ <returns>A Color structure containing the equivalent RGB values</returns>
    'http://www.bobpowell.net/RGBHSB.htm
    Public Function HSL_to_RGB(ByVal H As Double, ByVal S As Double, ByVal L As Double) As Color
        ' HSL is the same as the vb.net color picker, gray = sat = 0, full color sat = 1, and L is black to color to white
        Dim r As Double = 0
        Dim g As Double = 0
        Dim b As Double = 0
        Dim temp1, temp2 As Double
        If L = 0 Then
            r = 0
            g = 0
            b = 0
        Else
            If S = 0 Then
                r = L
                g = L
                b = L
            Else
                temp2 = IIf(L <= 0.5, L * (1.0 + S), L + S - L * S)
                temp1 = 2.0 * L - temp2
                Dim t3() As Double = {H + 1.0 / 3.0, H, H - 1.0 / 3.0}
                Dim clr() As Double = {0, 0, 0}
                Dim i As Integer
                For i = 0 To 2
                    If t3(i) < 0 Then
                        t3(i) += 1.0
                    End If
                    If t3(i) > 1 Then
                        t3(i) -= 1.0
                    End If
                    If 6.0 * t3(i) < 1.0 Then
                        clr(i) = temp1 + (temp2 - temp1) * t3(i) * 6.0
                    ElseIf 2.0 * t3(i) < 1.0 Then
                        clr(i) = temp2
                    ElseIf 3.0 * t3(i) < 2.0 Then
                        clr(i) = temp1 + (temp2 - temp1) * (2.0 / 3.0 - t3(i)) * 6.0
                    Else
                        clr(i) = temp1
                    End If
                Next i
                r = clr(0)
                g = clr(1)
                b = clr(2)
            End If
        End If
        Return Color.FromArgb(CInt(255 * r), CInt(255 * g), CInt(255 * b))
    End Function 'HSL_to_RGB
 

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        Dim mycolor As Color


        ColorDialog1.ShowDialog()
        PictureBox8.BackColor = ColorDialog1.Color
        mycolor = PictureBox8.BackColor
        Label50.Text = Strings.Str(mycolor.R)
        Label51.Text = Strings.Str(mycolor.G)
        Label52.Text = Strings.Str(mycolor.B)
    End Sub

    Private Sub Button20_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button20.Click

        Dim mycolor As Color
        Dim H, S, L, R, G, B As Double
        H = 0.2
        S = 0
        L = 0.5
        mycolor = HSL_to_RGB(H, S, L)
        S = 0.7 ' saturation gray to full color
        L = 3 / 6 ' brightness
        ' note all values of 2.5 are closer to 2.0 on the actual screen ie yellow is more orange/brown
        PictureBox11.BackColor = HSL_to_RGB((11.5 / 16), S, L)
        PictureBox16.BackColor = HSL_to_RGB((10.5 / 16), S, L)
        PictureBox21.BackColor = HSL_to_RGB((9.5 / 16), S, L)
        PictureBox26.BackColor = HSL_to_RGB((8.5 / 16), S, L)
        PictureBox31.BackColor = HSL_to_RGB((7.5 / 16), S, L)
        PictureBox36.BackColor = HSL_to_RGB((6.5 / 16), S, L)
        PictureBox41.BackColor = HSL_to_RGB((5.5 / 16), S, L)
        PictureBox46.BackColor = HSL_to_RGB((4.5 / 16), S, L)
        PictureBox51.BackColor = HSL_to_RGB((3.5 / 16), S, L)
        PictureBox56.BackColor = HSL_to_RGB((2.5 / 16), S, L)
        PictureBox61.BackColor = HSL_to_RGB((1.5 / 16), S, L)
        PictureBox66.BackColor = HSL_to_RGB((0.5 / 16), S, L)
        PictureBox71.BackColor = HSL_to_RGB((15.5 / 16), S, L)
        PictureBox76.BackColor = HSL_to_RGB((14.5 / 16), S, L)
        PictureBox81.BackColor = HSL_to_RGB((13.5 / 16), S, L)
        PictureBox86.BackColor = HSL_to_RGB((12.5 / 16), S, L)
        L = 4 / 6
        PictureBox12.BackColor = HSL_to_RGB((11.5 / 16), S, L)
        PictureBox17.BackColor = HSL_to_RGB((10.5 / 16), S, L)
        PictureBox22.BackColor = HSL_to_RGB((9.5 / 16), S, L)
        PictureBox27.BackColor = HSL_to_RGB((8.5 / 16), S, L)
        PictureBox32.BackColor = HSL_to_RGB((7.5 / 16), S, L)
        PictureBox37.BackColor = HSL_to_RGB((6.5 / 16), S, L)
        PictureBox42.BackColor = HSL_to_RGB((5.5 / 16), S, L)
        PictureBox47.BackColor = HSL_to_RGB((4.5 / 16), S, L)
        PictureBox52.BackColor = HSL_to_RGB((3.5 / 16), S, L)
        PictureBox57.BackColor = HSL_to_RGB((2.5 / 16), S, L)
        PictureBox62.BackColor = HSL_to_RGB((1.5 / 16), S, L)
        PictureBox67.BackColor = HSL_to_RGB((0.5 / 16), S, L)
        PictureBox72.BackColor = HSL_to_RGB((15.5 / 16), S, L)
        PictureBox77.BackColor = HSL_to_RGB((14.5 / 16), S, L)
        PictureBox82.BackColor = HSL_to_RGB((13.5 / 16), S, L)
        PictureBox87.BackColor = HSL_to_RGB((12.5 / 16), S, L)
        L = 5 / 6
        PictureBox13.BackColor = HSL_to_RGB((11.5 / 16), S, L)
        PictureBox18.BackColor = HSL_to_RGB((10.5 / 16), S, L)
        PictureBox23.BackColor = HSL_to_RGB((9.5 / 16), S, L)
        PictureBox28.BackColor = HSL_to_RGB((8.5 / 16), S, L)
        PictureBox33.BackColor = HSL_to_RGB((7.5 / 16), S, L)
        PictureBox38.BackColor = HSL_to_RGB((6.5 / 16), S, L)
        PictureBox43.BackColor = HSL_to_RGB((5.5 / 16), S, L)
        PictureBox48.BackColor = HSL_to_RGB((4.5 / 16), S, L)
        PictureBox53.BackColor = HSL_to_RGB((3.5 / 16), S, L)
        PictureBox58.BackColor = HSL_to_RGB((2.5 / 16), S, L)
        PictureBox63.BackColor = HSL_to_RGB((1.5 / 16), S, L)
        PictureBox68.BackColor = HSL_to_RGB((0.5 / 16), S, L)
        PictureBox73.BackColor = HSL_to_RGB((15.5 / 16), S, L)
        PictureBox78.BackColor = HSL_to_RGB((14.5 / 16), S, L)
        PictureBox83.BackColor = HSL_to_RGB((13.5 / 16), S, L)
        PictureBox88.BackColor = HSL_to_RGB((12.5 / 16), S, L)
        L = 1 / 6
        PictureBox9.BackColor = HSL_to_RGB((11.5 / 16), S, L)
        PictureBox14.BackColor = HSL_to_RGB((10.5 / 16), S, L)
        PictureBox19.BackColor = HSL_to_RGB((9.5 / 16), S, L)
        PictureBox24.BackColor = HSL_to_RGB((8.5 / 16), S, L)
        PictureBox29.BackColor = HSL_to_RGB((7.5 / 16), S, L)
        PictureBox34.BackColor = HSL_to_RGB((6.5 / 16), S, L)
        PictureBox39.BackColor = HSL_to_RGB((5.5 / 16), S, L)
        PictureBox44.BackColor = HSL_to_RGB((4.5 / 16), S, L)
        PictureBox49.BackColor = HSL_to_RGB((3.5 / 16), S, L)
        PictureBox54.BackColor = HSL_to_RGB((2.5 / 16), S, L)
        PictureBox59.BackColor = HSL_to_RGB((1.5 / 16), S, L)
        PictureBox64.BackColor = HSL_to_RGB((0.5 / 16), S, L)
        PictureBox69.BackColor = HSL_to_RGB((15.5 / 16), S, L)
        PictureBox74.BackColor = HSL_to_RGB((14.5 / 16), S, L)
        PictureBox79.BackColor = HSL_to_RGB((13.5 / 16), S, L)
        PictureBox84.BackColor = HSL_to_RGB((12.5 / 16), S, L)
        L = 2 / 6
        PictureBox10.BackColor = HSL_to_RGB((11.5 / 16), S, L)
        PictureBox15.BackColor = HSL_to_RGB((10.5 / 16), S, L)
        PictureBox20.BackColor = HSL_to_RGB((9.5 / 16), S, L)
        PictureBox25.BackColor = HSL_to_RGB((8.5 / 16), S, L)
        PictureBox30.BackColor = HSL_to_RGB((7.5 / 16), S, L)
        PictureBox35.BackColor = HSL_to_RGB((6.5 / 16), S, L)
        PictureBox40.BackColor = HSL_to_RGB((5.5 / 16), S, L)
        PictureBox45.BackColor = HSL_to_RGB((4.5 / 16), S, L)
        PictureBox50.BackColor = HSL_to_RGB((3.5 / 16), S, L)
        PictureBox55.BackColor = HSL_to_RGB((2.5 / 16), S, L)
        PictureBox60.BackColor = HSL_to_RGB((1.5 / 16), S, L)
        PictureBox65.BackColor = HSL_to_RGB((0.5 / 16), S, L)
        PictureBox70.BackColor = HSL_to_RGB((15.5 / 16), S, L)
        PictureBox75.BackColor = HSL_to_RGB((14.5 / 16), S, L)
        PictureBox80.BackColor = HSL_to_RGB((13.5 / 16), S, L)
        PictureBox85.BackColor = HSL_to_RGB((12.5 / 16), S, L)
        ' do gray palattes
        PictureBox94.BackColor = Color.FromArgb(255, 0, 0, 0) 'black 02
        PictureBox95.BackColor = Color.FromArgb(255, 51, 51, 51) ' 03
        PictureBox96.BackColor = Color.FromArgb(255, 102, 102, 102) 'gray '04
        PictureBox97.BackColor = Color.FromArgb(255, 153, 153, 152) '05
        PictureBox98.BackColor = Color.FromArgb(255, 204, 204, 204) ' 06
        PictureBox99.BackColor = Color.FromArgb(255, 255, 255, 255) 'white 07
    End Sub

    Private Sub Button22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button22.Click
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        Dim MyColor As Color
        Dim R, G, B, H, S, L As Double
        Dim PropHue As Integer
        Dim PropLum As Double
        sizex = 128 - 1 ' baggers 'world demo' screen is 128x96
        sizey = 96 - 1
        Dim PixelArray(sizex, sizey, 9) As Double ' R,G,B,H,S,L, new H,S,L
        Dim x, y, i As Integer
        Dim OutputArray(20000) As Byte
        Dim t As Integer
        Dim Sourcefile As String
        Dim DestinationFile As String
        Sourcefile = TextBox31.Text + TextBox32.Text
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
        img = Image.FromStream(fs)
        fs.Close()
        PictureBox89.Image = img
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox89.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = PixelValue.R ' red byte
                PixelArray(x, y, 1) = PixelValue.G ' green byte
                PixelArray(x, y, 2) = PixelValue.B ' blue byte
            Next
        Next
        ' create the propeller TV color byte
        For y = 0 To sizey
            For x = 0 To sizex
                R = PixelArray(x, y, 0)
                G = PixelArray(x, y, 1)
                B = PixelArray(x, y, 2)
                MyColor = Color.FromArgb(255, R, G, B)
                H = MyColor.GetHue ' 0-359
                S = MyColor.GetSaturation ' 0-1
                L = MyColor.GetBrightness ' 0-1
                PixelArray(x, y, 3) = H ' original HSL
                PixelArray(x, y, 4) = S
                PixelArray(x, y, 5) = L
                ' now convert to propeller colors
                ' need a formula that lightens skin tones (reds) and darkens greens.

                If S > 0.25 Then ' some color present
                    S = 1 ' fully saturated colors
                Else
                    S = 0 ' gray scale
                End If
                If L > 0.84 Then ' a very bright color is almost white
                    S = 0 ' gray scale and white
                    L = 1
                End If
                If L < 0.16 Then ' black
                    S = 0 ' grayscale and black
                    L = 0
                End If
                L = L * 5 + 0.5 ' round to 5 discrete steps and add 0.5 offset so integer works
                L = Int(L)
                L = L / 5 ' convert back to 0-1

                H = 0.5 + H / 22.5 ' round to 0-15
                H = Int(H) ' round
                H = H * 22.5 ' convert back to degrees
                H = H / 360 ' convert to 0-1
                PixelArray(x, y, 6) = H ' save the changed values in the pixel array
                PixelArray(x, y, 7) = S
                PixelArray(x, y, 8) = L
                MyColor = HSL_to_RGB(H, S, L) ' convert back to a color
                MyBitmap.SetPixel(x, y, MyColor) ' set the pixels
            Next x
        Next y
        'MyBitmap.SetPixel(10, 10, Color.White)
        PictureBox90.Image = MyBitmap ' bitmap array to picturebox - need to convert pixelarray back to mybitmap to show the decreased color depth 
        ' now turn the pixelarray x,y,3 into a binary file suitabkle for the TV 
        t = 0
        For y = 0 To sizey
            For x = 0 To sizex
                H = PixelArray(x, y, 6) ' discrete HSL
                S = PixelArray(x, y, 7)
                L = PixelArray(x, y, 8)
                If S = 0 Then ' grayscale
                    PixelArray(x, y, 9) = 2 + L * 5 ' gray values hex 02,03,04,05,06,07
                Else
                    Select Case H * 16
                        Case 11 To 12 : PropHue = 0
                        Case 10 To 11 : PropHue = 1
                        Case 9 To 10 : PropHue = 2
                        Case 8 To 9 : PropHue = 3
                        Case 7 To 8 : PropHue = 4
                        Case 6 To 7 : PropHue = 5
                        Case 5 To 6 : PropHue = 6
                        Case 4 To 5 : PropHue = 7
                        Case 3 To 4 : PropHue = 8
                        Case 2 To 3 : PropHue = 9
                        Case 1 To 2 : PropHue = 10
                        Case 0 To 1 : PropHue = 11
                        Case 15 To 16 : PropHue = 12
                        Case 14 To 15 : PropHue = 13
                        Case 13 To 14 : PropHue = 14
                        Case 12 To 13 : PropHue = 15
                    End Select
                    PropLum = PixelArray(x, y, 5)
                    ' black and white already converted to gray scale so value will be 
                    ' 0.16 to 0.84. There are 5 discrete steps here which is 1 more than the gray scale
                    PropLum = PropLum - 0.16 ' remove the black, range is now 0 to 2/3
                    PropLum = PropLum * 7.5 ' 5/(2/3) is 15/2 = 7.5 so range 0 to 5
                    PropLum = Int(PropLum) ' scale to an integer
                    If PropLum > 4 Then PropLum = 4 ' now a value 0,1,2,3,4
                    If PropLum < 0 Then PropLum = 0
                    PixelArray(x, y, 9) = PropHue * 16 + PropLum + 10 ' convert to propeller value
                End If
                OutputArray(t) = PixelArray(x, y, 9) ' move to output array
                t += 1
            Next
        Next
        DestinationFile = TextBox31.Text + TextBox33.Text
        Dim OutputTV As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputTV.Write(OutputArray, 0, 12288) ' save 12288 bytes
        OutputTV.Close()
    End Sub

    Private Function RGB_to_PropTV(ByVal R As Byte, ByVal G As Byte, ByVal B As Byte)
        Dim PropByte As Byte
        Dim MyColor As Color
        Dim H, S, L As Double
        Dim NewH, NewS, NewL As Double
        Dim PropHue As Integer
        Dim PropLum As Double
        MyColor = Color.FromArgb(255, R, G, B) ' 0-255 for each value
        H = MyColor.GetHue ' 0-359
        S = MyColor.GetSaturation ' 0-1
        L = MyColor.GetBrightness ' 0-1
        NewH = H
        NewS = S
        NewL = L
        If S > 0.25 Then ' some color present
            NewS = 1 ' fully saturated colors
        Else
            NewS = 0 ' gray scale
        End If
        If L > 0.84 Then ' a very bright color is almost white
            NewS = 0 ' gray scale and white
            NewL = 1
        End If
        If L < 0.16 Then ' black
            NewS = 0 ' grayscale and black
            NewL = 0
        End If
        NewH = 0.5 + H / 22.5 ' round to 0-15
        NewH = Int(NewH) ' round
        NewH = NewH * 22.5 ' convert back to degrees
        NewH = NewH / 360 ' convert to 0-1
        If NewS = 0 Then ' grayscale
            NewL = NewL * 5 + 0.5 ' round to 5 discrete steps and add 0.5 offset so integer works
            NewL = Int(NewL)
            NewL = NewL / 5 ' convert back to 0-1
            PropByte = 2 + NewL * 5 ' gray values hex 02,03,04,05,06,07
        Else
            Select Case NewH * 16 ' there probably is a mathematical formula for this
                Case 11 To 12 : PropHue = 0
                Case 10 To 11 : PropHue = 1
                Case 9 To 10 : PropHue = 2
                Case 8 To 9 : PropHue = 3
                Case 7 To 8 : PropHue = 4
                Case 6 To 7 : PropHue = 5
                Case 5 To 6 : PropHue = 6
                Case 4 To 5 : PropHue = 7
                Case 3 To 4 : PropHue = 8
                Case 2 To 3 : PropHue = 9
                Case 1 To 2 : PropHue = 10
                Case 0 To 1 : PropHue = 11
                Case 15 To 16 : PropHue = 12
                Case 14 To 15 : PropHue = 13
                Case 13 To 14 : PropHue = 14
                Case 12 To 13 : PropHue = 15
            End Select
            PropLum = L ' original L value
            ' black and white already converted to gray scale so value will be 
            ' 0.16 to 0.84. There are 5 discrete steps here which is 1 more than the gray scale
            PropLum = PropLum - 0.16 ' remove the black, range is now 0 to 2/3
            PropLum = PropLum * 7.5 ' 5/(2/3) is 15/2 = 7.5 so range 0 to 5
            PropLum = Int(PropLum) ' scale to an integer
            If PropLum > 4 Then PropLum = 4 ' now a value 0,1,2,3,4
            If PropLum < 0 Then PropLum = 0
            PropByte = PropHue * 16 + PropLum + 10 ' convert to propeller value
        End If
        Return PropByte
    End Function

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        ' create a TV movie

        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        sizex = 128 - 1 ' baggers screen is 128x96
        sizey = 96 - 1
        Dim PixelArray(sizex, sizey, 3) As Byte ' R,G,B and calculated prop byte so 4 values
        Dim x, y, i As Integer
        Dim Propbyte As Byte
        Dim OutputArray(20000) As Byte
        Dim t As Integer
        Dim Sourcefile As String
        Dim DestinationFile As String
        Dim StartNumber As Integer
        Dim FinishNumber As Integer
        Dim Filecounter As Integer
        Dim LineofText As String
        DestinationFile = TextBox10.Text + TextBox20.Text
        StartNumber = Strings.Val(TextBox12.Text)
        FinishNumber = Strings.Val(TextBox13.Text)
        Dim OutputTV As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        For Filecounter = StartNumber To FinishNumber
            Sourcefile = TextBox10.Text + TextBox11.Text ' directory plus rootname
            ' add the right number of leading zeros, (AVS4YOU adds a different number based on how big the total file is)
            LineofText = Strings.Right("000000" + Trim(Strings.Str(Filecounter)), Strings.Len(TextBox12.Text)) ' convert to a string
            Label25.Text = LineofText
            Sourcefile += LineofText + ".bmp"
            ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
            Dim img As Image
            Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
            img = Image.FromStream(fs)
            fs.Close()
            ' display the image in the picture box
            PictureBox4.Image = img
            ' Get the source bitmap.
            Dim bm_source As New Bitmap(PictureBox4.Image)
            ' Make a bitmap for the result shrunk to 160x120
            Dim bm_dest As New Bitmap(CInt(sizex + 1), CInt(sizey + 1)) '128x96
            ' Make a Graphics object for the result Bitmap.
            Dim gr_dest As Graphics = Graphics.FromImage(bm_dest)
            ' Copy the source image into the destination bitmap.
            gr_dest.DrawImage(bm_source, 0, 0, bm_dest.Width + 1, bm_dest.Height + 1)
            ' Display the result.
            PictureBox7.Image = bm_dest
            gr_dest.Dispose()
            Dim MyBitmap As New System.Drawing.Bitmap(PictureBox7.Image) 'image from picture box
            For y = 0 To sizey
                For x = 0 To sizex
                    PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                    PixelArray(x, y, 0) = PixelValue.R ' red byte
                    PixelArray(x, y, 1) = PixelValue.G ' green byte
                    PixelArray(x, y, 2) = PixelValue.B ' blue byte
                    PixelArray(x, y, 3) = &H1B ' pre fill the prop byte with blue for Bagger's code
                Next
            Next
            ' create the propeller color byte
            For y = 0 To sizey
                For x = 0 To sizex
                    For i = 0 To 2
                        PixelArray(x, y, 3) = RGB_to_PropTV(PixelArray(x, y, 0), PixelArray(x, y, 1), PixelArray(x, y, 2))
                    Next i
                Next x
            Next y
            'PictureBox3.Image = MyBitmap ' bitmap array to picturebox - need to convert pixelarray back to mybitmap to show the decreased color depth 
            ' now turn the pixelarray x,y,3 into a binary file
            t = 0
            For y = 0 To sizey
                For x = 0 To sizex
                    OutputArray(t) = PixelArray(x, y, 3) ' move to output array
                    t += 1
                Next
            Next
            System.Windows.Forms.Application.DoEvents() ' update the display
            OutputTV.Write(OutputArray, 0, 12288) ' save bytes 128x96 is 12288
        Next Filecounter
        OutputTV.Close()
    End Sub

    Private Sub Button36_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button36.Click
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        sizex = 128 - 1 ' tv screen is 128x96
        sizey = 96 - 1
        Dim PixelArray(sizex, sizey, 3) As Byte ' R,G,B and calculated prop byte so 4 values
        Dim x, y, i As Integer
        Dim Propbyte As Byte
        Dim OutputArray(20000) As Byte
        Dim t As Integer
        Dim Sourcefile As String
        Dim DestinationFile As String
        Sourcefile = TextBox23.Text + TextBox22.Text
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
        img = Image.FromStream(fs)
        fs.Close()
        PictureBox91.Image = img
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox91.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = PixelValue.R ' red byte
                PixelArray(x, y, 1) = PixelValue.G ' green byte
                PixelArray(x, y, 2) = PixelValue.B ' blue byte
                PixelArray(x, y, 3) = 0 ' pre fill the prop byte with %00000000 for Kye's code
            Next
        Next
        ' create the propeller color byte
        For y = 0 To sizey
            For x = 0 To sizex
                For i = 0 To 2
                    PixelArray(x, y, 3) = RGB_to_PropTV(PixelArray(x, y, 0), PixelArray(x, y, 1), PixelArray(x, y, 2))
                Next i
            Next x
        Next y
        t = 0
        For y = 0 To sizey
            For x = 0 To sizex
                OutputArray(t) = PixelArray(x, y, 3) ' move to output array
                t += 1
            Next
        Next
        DestinationFile = TextBox23.Text + TextBox21.Text
        Dim OutputTV As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputTV.Write(OutputArray, 0, 12288) ' save 12288 bytes
        OutputTV.Close()
    End Sub

    Private Sub Button35_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button35.Click
        ' for testing reading bitmap files byte by byte. Use to build C and Spin code
        Dim Sourcefile As String
        Dim SourceBinary(100000) As Byte
        Dim Filesize As Long
        Dim Offset As Long
        Dim BitmapWidth As Long
        Dim BitmapHeight As Long
        Dim BitDepth As Long ' 24 for 24bit color
        Dim n As Long
        Dim x As Long
        Dim y As Long
        Dim R As Byte
        Dim G As Byte
        Dim B As Byte
        Dim Pixelcolor As Color
        Dim Colcounter As Integer
        Dim Rows As Integer
        Dim Remainder As Integer
        Sourcefile = TextBox24.Text
        Dim InputBinary As New FileStream(Sourcefile, FileMode.Open, FileAccess.Read)
        InputBinary.Read(SourceBinary, 1, 100000) ' offset of 1 so same as http://www.fortunecity.com/skyscraper/windows/364/bmpffrmt.html
        InputBinary.Close() ' close the file
        Filesize = SourceBinary(3) + SourceBinary(4) * &H100 + SourceBinary(5) * &H10000 + SourceBinary(6) * &H1000000
        Offset = SourceBinary(11) + SourceBinary(12) * &H100 + SourceBinary(13) * &H10000 + SourceBinary(14) * &H1000000
        BitmapWidth = SourceBinary(19) + SourceBinary(20) * &H100 + SourceBinary(21) * &H10000 + SourceBinary(22) * &H1000000
        BitmapHeight = SourceBinary(23) + SourceBinary(24) * &H100 + SourceBinary(25) * &H10000 + SourceBinary(26) * &H1000000
        BitDepth = SourceBinary(29) + SourceBinary(30) * &H100
        TextBox26.Text = Strings.Str(Filesize)
        TextBox27.Text = Strings.Str(Offset)
        TextBox25.Text = Strings.Str(BitmapWidth)
        TextBox28.Text = Strings.Str(BitmapHeight)
        TextBox29.Text = Strings.Str(BitDepth)
        Dim MyBitmap As New Bitmap(CInt(BitmapWidth), CInt(BitmapHeight)) ' array for the bitmap display
        PictureBox92.Width = BitmapWidth
        PictureBox92.Height = BitmapHeight
        n = Offset + 1 ' start reading the picture here - reads bottom row first but does not flip left to right
        y = BitmapHeight - 1
        For rowcounter = 0 To BitmapHeight - 1
            Colcounter = 0
            For x = 0 To BitmapWidth - 1
                R = SourceBinary(n + 2) ' stored as B,G,R
                G = SourceBinary(n + 1)
                B = SourceBinary(n)
                Pixelcolor = Color.FromArgb(R, G, B)
                MyBitmap.SetPixel(x, y, Pixelcolor)
                Colcounter += 3
                n += 3
            Next x
            Remainder = (Colcounter Mod 4)
            If Remainder <> 0 Then
                n = n + (4 - Remainder) ' end of rows are padded to a multiple of 4 so ignore
            End If
            y -= 1
        Next rowcounter
        PictureBox92.Image = MyBitmap
    End Sub

    Private Sub Button37_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button37.Click
        ' compare various formulas with the internal vb.net "gethue" etc.

        Dim Mycolor As Color
        Dim R, G, B, H, S, L As Double
        R = Strings.Val(TextBox30.Text)
        G = Strings.Val(TextBox34.Text)
        B = Strings.Val(TextBox35.Text)
        Mycolor = Color.FromArgb(255, R, G, B) ' 0-255 for each value
        PictureBox93.BackColor = Mycolor
        H = Int(Mycolor.GetHue) ' 0-359
        S = Int(Mycolor.GetSaturation * 255) ' 0-255
        L = Int(Mycolor.GetBrightness * 255) ' 0-255
        TextBox38.Text = Strings.Str(H)
        TextBox37.Text = Strings.Str(S)
        TextBox36.Text = Strings.Str(L)

        Dim Var_R, Var_G, Var_B, Var_Min, Var_Max, del_Max, Hue, Sat, Lum As Double
        Dim Del_R, Del_G, Del_B As Double
        ' do calculations 0 to 1
        Var_R = (R / 256)                     '//RGB from 0 to 255
        Var_G = (G / 256)
        Var_B = (B / 256)

        Var_Min = Var_R
        If Var_G < Var_Min Then Var_Min = Var_G
        If Var_B < Var_Min Then Var_Min = Var_B
        '
        'var_Min = min( var_R, var_G, var_B )    //Min. value of RGB
        Var_Max = Var_R
        If Var_G > Var_Max Then Var_Max = Var_G
        If Var_B > Var_Max Then Var_Max = Var_B
        'var_Max = max( var_R, var_G, var_B )    //Max. value of RGB

        'del_Max = var_Max - var_Min             //Delta RGB value
        del_Max = Var_Max - Var_Min
        '
        'L = ( var_Max + var_Min ) / 2
        Lum = (Var_Max + Var_Min) / 2
        '
        'if ( del_Max == 0 )                     //This is a gray, no chroma...
        '{
        '   H = 0                                //HSL results from 0 to 1
        '   S = 0
        '}
        'else                                    //Chromatic data...
        '{
        '   if ( L < 0.5 ) S = del_Max / ( var_Max + var_Min )
        '   else           S = del_Max / ( 2 - var_Max - var_Min )
        '
        '   del_R = ( ( ( var_Max - var_R ) / 6 ) + ( del_Max / 2 ) ) / del_Max
        '   del_G = ( ( ( var_Max - var_G ) / 6 ) + ( del_Max / 2 ) ) / del_Max
        '   del_B = ( ( ( var_Max - var_B ) / 6 ) + ( del_Max / 2 ) ) / del_Max
        '
        '   if      ( var_R == var_Max ) H = del_B - del_G
        '   else if ( var_G == var_Max ) H = ( 1 / 3 ) + del_R - del_B
        '   else if ( var_B == var_Max ) H = ( 2 / 3 ) + del_G - del_R
        '
        '   if ( H < 0 ) H += 1
        '   if ( H > 1 ) H -= 1

        If del_Max = 0 Then
            Hue = 0 ' this is a gray, no chroma
            Sat = 0
        Else
            If (Lum < 0.5) Then
                Sat = del_Max / (Var_Max + Var_Min) ' black to gray
            Else
                Sat = del_Max / (2 - Var_Max - Var_Min) ' gray to white 
            End If
            Del_R = (((Var_Max - Var_R) / 6) + (del_Max / 2)) / del_Max
            Del_G = (((Var_Max - Var_G) / 6) + (del_Max / 2)) / del_Max
            Del_B = (((Var_Max - Var_B) / 6) + (del_Max / 2)) / del_Max
            If (Var_R = Var_Max) Then
                Hue = Del_B - Del_G
            End If
            If (Var_G = Var_Max) Then
                Hue = 0.33333333 + Del_R - Del_B
            End If
            If (Var_B = Var_Max) Then
                Hue = 0.6666666 + Del_G - Del_R
            End If
            ' tidy up out of range values 
            If Hue < 0 Then Hue += 1
            If Hue > 1 Then Hue -= 1
        End If
        TextBox41.Text = Strings.Str(Int(Hue * 360))
        TextBox40.Text = Strings.Str(Int(Sat * 255))
        TextBox39.Text = Strings.Str(Int(Lum * 255))

        ' now do the above all scaled to 0-65536 instead of 0-1
        ' also split up a few lines
        Dim Var_R_Long, Var_G_Long, Var_B_Long, Var_Min_Long, Var_Max_Long, del_Max_Long, Hue_Long, Sat_Long, Lum_Long As Long
        Dim Del_R_Long, Del_G_Long, Del_B_Long As Long
        Var_R_Long = (R * 256)                     '//RGB from 0 to 65536
        Var_G_Long = (G * 256)
        Var_B_Long = (B * 256)
        Var_Min_Long = Var_R_Long
        If Var_G_Long < Var_Min_Long Then Var_Min_Long = Var_G_Long
        If Var_B_Long < Var_Min_Long Then Var_Min_Long = Var_B_Long
        Var_Max_Long = Var_R_Long
        If Var_G_Long > Var_Max_Long Then Var_Max_Long = Var_G_Long
        If Var_B_Long > Var_Max_Long Then Var_Max_Long = Var_B_Long
        del_Max_Long = Var_Max_Long - Var_Min_Long
        Lum_Long = (Var_Max_Long + Var_Min_Long) / 2
        If del_Max_Long = 0 Then
            Hue_Long = 0 ' this is a gray, no chroma
            Sat_Long = 0
        Else
            If (Lum_Long < 32768) Then
                Sat_Long = (65536 * del_Max_Long) / (Var_Max_Long + Var_Min_Long) ' black to gray
            Else
                Sat_Long = (65536 * del_Max_Long) / (131072 - Var_Max_Long - Var_Min_Long) ' gray to white 
            End If
            Del_R_Long = (65536 * ((Var_Max_Long - Var_R_Long) / 6) + (del_Max_Long / 2)) / del_Max_Long
            Del_G_Long = (65536 * ((Var_Max_Long - Var_G_Long) / 6) + (del_Max_Long / 2)) / del_Max_Long
            Del_B_Long = (65536 * ((Var_Max_Long - Var_B_Long) / 6) + (del_Max_Long / 2)) / del_Max_Long
            If (Var_R_Long = Var_Max_Long) Then
                Hue_Long = Del_B_Long - Del_G_Long
            End If
            If (Var_G_Long = Var_Max_Long) Then
                Hue_Long = 21845 + Del_R_Long - Del_B_Long
            End If
            If (Var_B_Long = Var_Max_Long) Then
                Hue_Long = 43691 + Del_G_Long - Del_R_Long
            End If
            ' tidy up out of range values - now 0-65535
            If Hue_Long < 0 Then Hue_Long += 65536 ' is <1 ok with unsigned longs??
            If Hue_Long > 65536 Then Hue_Long -= 65536 ' 100,5,40 RGB will trigger this
        End If
        TextBox44.Text = Strings.Str(Int(Hue_Long / 182))
        TextBox43.Text = Strings.Str(Int(Sat_Long / 255))
        TextBox42.Text = Strings.Str(Int(Lum_Long / 255))
    End Sub
    Private Function RGBtoPropByte(ByVal R As Integer, ByVal G As Integer, ByVal B As Integer)
        ' uses no floating point values and uses Longs for conversion to Propeller Spin
        ' doesn't use the internal vb.net conversion but has been checked against this
        ' requires signed longs ie -2^30 to + 2^30
        Dim Var_R_Long, Var_G_Long, Var_B_Long, Var_Min_Long, Var_Max_Long, del_Max_Long, Hue_Long, Sat_Long, Lum_Long As Long
        Dim Del_R_Long, Del_G_Long, Del_B_Long As Long
        Dim PropByte As Byte
        Dim PropHue, PropLum As Integer
        Var_R_Long = (R * 256)                     '//RGB from 0 to 65536
        Var_G_Long = (G * 256)
        Var_B_Long = (B * 256)
        Var_Min_Long = Var_R_Long
        If Var_G_Long < Var_Min_Long Then Var_Min_Long = Var_G_Long
        If Var_B_Long < Var_Min_Long Then Var_Min_Long = Var_B_Long
        Var_Max_Long = Var_R_Long
        If Var_G_Long > Var_Max_Long Then Var_Max_Long = Var_G_Long
        If Var_B_Long > Var_Max_Long Then Var_Max_Long = Var_B_Long
        del_Max_Long = Var_Max_Long - Var_Min_Long
        Lum_Long = (Var_Max_Long + Var_Min_Long) / 2
        If del_Max_Long = 0 Then
            Hue_Long = 0 ' this is a gray, no chroma
            Sat_Long = 0
        Else
            If (Lum_Long < 32768) Then
                Sat_Long = (65536 * del_Max_Long) / (Var_Max_Long + Var_Min_Long) ' black to gray
            Else
                Sat_Long = (65536 * del_Max_Long) / (131072 - Var_Max_Long - Var_Min_Long) ' gray to white 
            End If
            Del_R_Long = (65536 * ((Var_Max_Long - Var_R_Long) / 6) + (del_Max_Long / 2)) / del_Max_Long
            Del_G_Long = (65536 * ((Var_Max_Long - Var_G_Long) / 6) + (del_Max_Long / 2)) / del_Max_Long
            Del_B_Long = (65536 * ((Var_Max_Long - Var_B_Long) / 6) + (del_Max_Long / 2)) / del_Max_Long
            If (Var_R_Long = Var_Max_Long) Then
                Hue_Long = Del_B_Long - Del_G_Long
            End If
            If (Var_G_Long = Var_Max_Long) Then
                Hue_Long = 21845 + Del_R_Long - Del_B_Long
            End If
            If (Var_B_Long = Var_Max_Long) Then
                Hue_Long = 43691 + Del_G_Long - Del_R_Long
            End If
            ' tidy up out of range values - now 0-65535
            If Hue_Long < 0 Then Hue_Long += 65536 ' is <1 ok with unsigned longs - used signed longs
            If Hue_Long > 65536 Then Hue_Long -= 65536 ' 100,5,40 RGB will trigger this
        End If
        ' now have Hue_Long,Sat_Long and Lum_Long, all 0-65535, integer values
        If Sat_Long > 65535 Then Sat_Long = 65535 ' range testing
        If Lum_Long > 65535 Then Lum_Long = 65535 ' range testing
        ' Saturation is lost as a scale, convert to 'no saturation' (<0.25) or 'full saturation' 
        If (Lum_Long < 10922) Or (Lum_Long > 54613) Or (Sat_Long < 16384) Then
            ' black or white or little saturation so use gray scale
            Select Case Lum_Long ' this is the same as converting to integers then back to a larger scale to give discrete values
                Case 0 To 10922 : PropByte = 2 ' black
                Case 10923 To 21844 : PropByte = 3 ' dark gray
                Case 21845 To 32766 : PropByte = 4
                Case 32767 To 43688 : PropByte = 5
                Case 43689 To 54610 : PropByte = 6 ' light gray
                Case 54611 To 65536 : PropByte = 7 ' white
            End Select
        Else
            ' colors and not white or black
            Select Case Hue_Long ' there probably is a mathematical formula for this, rotate, scale to integer and reverse order
                Case 45057 To 49152 : PropHue = 0
                Case 40961 To 45056 : PropHue = 1
                Case 36865 To 40960 : PropHue = 2
                Case 32769 To 36864 : PropHue = 3
                Case 28673 To 32768 : PropHue = 4
                Case 24577 To 28672 : PropHue = 5
                Case 20481 To 24576 : PropHue = 6
                Case 16385 To 20480 : PropHue = 7
                Case 12289 To 16384 : PropHue = 8
                Case 8193 To 12288 : PropHue = 9
                Case 4097 To 8192 : PropHue = 10
                Case 0 To 4096 : PropHue = 11
                Case 61441 To 65536 : PropHue = 12
                Case 57345 To 61440 : PropHue = 13
                Case 53249 To 57344 : PropHue = 14
                Case 49153 To 53248 : PropHue = 15
            End Select
            ' black and white already converted to gray scale
            Select Case Lum_Long ' original value. Convert to 7 discrete values
                Case 0 To 9362 : PropLum = 0 ' not used as this will be a black value from earlier
                Case 9363 To 18724 : PropLum = 0 ' darkest color
                Case 18725 To 28086 : PropLum = 1
                Case 28087 To 37449 : PropLum = 2
                Case 37450 To 46811 : PropLum = 3
                Case 46812 To 56173 : PropLum = 4 ' lightest color
                Case 56174 To 65536 : PropLum = 4 ' this will also be discarded as this is white
            End Select
            PropByte = PropHue * 16 + PropLum + 10 ' convert to propeller value
        End If
        Return PropByte
    End Function

    Private Sub Button38_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button38.Click
        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        sizex = 128 - 1 ' tv screen is 128x96
        sizey = 96 - 1
        Dim PixelArray(sizex, sizey, 3) As Byte ' R,G,B and calculated prop byte so 4 values
        Dim x, y, i As Integer
        Dim Propbyte As Byte
        Dim OutputArray(20000) As Byte
        Dim t As Integer
        Dim Sourcefile As String
        Dim DestinationFile As String
        Sourcefile = TextBox23.Text + TextBox22.Text
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
        img = Image.FromStream(fs)
        fs.Close()
        PictureBox91.Image = img
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox91.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = PixelValue.R ' red byte
                PixelArray(x, y, 1) = PixelValue.G ' green byte
                PixelArray(x, y, 2) = PixelValue.B ' blue byte
                PixelArray(x, y, 3) = 0 ' pre fill the prop byte with %00000000 for Kye's code
            Next
        Next
        ' create the propeller color byte
        For y = 0 To sizey
            For x = 0 To sizex
                For i = 0 To 2
                    PixelArray(x, y, 3) = RGBtoPropByte(PixelArray(x, y, 0), PixelArray(x, y, 1), PixelArray(x, y, 2))
                Next i
            Next x
        Next y
        t = 0
        For y = 0 To sizey
            For x = 0 To sizex
                OutputArray(t) = PixelArray(x, y, 3) ' move to output array
                t += 1
            Next
        Next
        DestinationFile = TextBox23.Text + TextBox21.Text
        Dim OutputTV As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputTV.Write(OutputArray, 0, 12288) ' save 12288 bytes
        OutputTV.Close()
    End Sub

    Private Sub CreateTVPalette(ByVal Palette(,) As Integer)
        ' create the TV palette (minus the super saturated colors)
        Dim i As Integer
        Dim n, S, L As Double
        Dim Mycolor As Color
        i = 0 ' counter
        S = 0.7 ' approx value that matches the propeller demo the best
        For x = 0 To 15
            n = (15 - x) - 3.5 ' calculate hue
            If n < 0 Then n += 16 ' rotate around the color wheel
            'H = n / 16 ' hue
            For y = 5 To 1 Step -1
                L = y / 6 ' luminance
                Mycolor = HSL_to_RGB((n / 16), S, L)
                Palette(i, 0) = Mycolor.R ' red value
                Palette(i, 1) = Mycolor.G ' green value
                Palette(i, 2) = Mycolor.B ' blue value
                Palette(i, 3) = x * 16 + 9 + y ' calculate the propeller byte value
                i += 1
            Next
        Next
        ' now do the grays
        i = 0
        For x = 80 To 85
            For y = 0 To 2
                Palette(x, y) = i * 51 ' scale of grays 0 to 255 step 51
            Next
            Palette(x, 3) = i + 2 ' propeller byte value
            i += 1 ' increment counter
        Next
    End Sub
    Private Sub FloydSteinberg(ByVal Palette(,) As Integer, ByVal FSPixelarray(,,) As Double, ByVal SizeX As Integer, ByVal SizeY As Integer)
        ' pass a pixel array. Returns the same array after transformation and bounds (0-255) checking
        ' now do the transform
        ' oldpixel := pixel[x][y]
        'newpixel := find_closest_palette_color(oldpixel)
        'pixel[x][y] := newpixel
        'quant_error := oldpixel - newpixel
        'pixel[x+1][y] := pixel[x+1][y] + 7/16 * quant_error
        'pixel[x-1][y+1] := pixel[x-1][y+1] + 3/16 * quant_error
        'pixel[x][y+1] := pixel[x][y+1] + 5/16 * quant_error
        'pixel[x+1][y+1] := pixel[x+1][y+1] + 1/16 * quant_error
        Dim R, G, B, H, S, L As Double
        Dim BestIndex As Integer ' best match
        Dim QuantErrorR, QuantErrorG, QuantErrorB As Double
        Dim NewR, NewG, NewB As Integer
        Dim x, y, i As Integer
        For y = 1 To SizeY - 1
            For x = 1 To SizeX - 1
                R = FSPixelarray(x, y, 0) ' old red
                G = FSPixelarray(x, y, 1) ' old green
                B = FSPixelarray(x, y, 2) ' old blue
                ' range checking as sometimes values run away
                If R < 0 Then R = 0
                If R > 255 Then R = 255
                If G < 0 Then G = 0
                If G > 255 Then G = 255
                If B < 0 Then B = 0
                If B > 255 Then B = 255
                ' find the closest match
                BestIndex = FindNearestColor(Palette, R, G, B) ' find closest palette color
                NewR = Palette(BestIndex, 0)
                NewG = Palette(BestIndex, 1)
                NewB = Palette(BestIndex, 2)
                'pixel[x][y] := newpixel
                FSPixelarray(x, y, 0) = NewR
                FSPixelarray(x, y, 1) = NewG
                FSPixelarray(x, y, 2) = NewB
                'quant_error := oldpixel - newpixel
                QuantErrorR = R - NewR
                QuantErrorG = G - NewG
                QuantErrorB = B - NewB
                'pixel[x+1][y] := pixel[x+1][y] + 7/16 * quant_error
                FSPixelarray(x + 1, y, 0) = FSPixelarray(x + 1, y, 0) + (7 / 16) * QuantErrorR
                FSPixelarray(x + 1, y, 1) = FSPixelarray(x + 1, y, 1) + (7 / 16) * QuantErrorG
                FSPixelarray(x + 1, y, 2) = FSPixelarray(x + 1, y, 2) + (7 / 16) * QuantErrorB
                'pixel[x-1][y+1] := pixel[x-1][y+1] + 3/16 * quant_error
                FSPixelarray(x - 1, y + 1, 0) = FSPixelarray(x - 1, y + 1, 0) + (3 / 16) * QuantErrorR
                FSPixelarray(x - 1, y + 1, 1) = FSPixelarray(x - 1, y + 1, 1) + (3 / 16) * QuantErrorG
                FSPixelarray(x - 1, y + 1, 2) = FSPixelarray(x - 1, y + 1, 2) + (3 / 16) * QuantErrorB
                'pixel[x][y+1] := pixel[x][y+1] + 5/16 * quant_error
                FSPixelarray(x, y + 1, 0) = FSPixelarray(x, y + 1, 0) + (5 / 16) * QuantErrorR
                FSPixelarray(x, y + 1, 1) = FSPixelarray(x, y + 1, 1) + (5 / 16) * QuantErrorG
                FSPixelarray(x, y + 1, 2) = FSPixelarray(x, y + 1, 2) + (5 / 16) * QuantErrorB
                'pixel[x+1][y+1] := pixel[x+1][y+1] + 1/16 * quant_error
                FSPixelarray(x + 1, y + 1, 0) = FSPixelarray(x + 1, y + 1, 0) + (1 / 16) * QuantErrorR
                FSPixelarray(x + 1, y + 1, 1) = FSPixelarray(x + 1, y + 1, 1) + (1 / 16) * QuantErrorG
                FSPixelarray(x + 1, y + 1, 2) = FSPixelarray(x + 1, y + 1, 2) + (1 / 16) * QuantErrorB
            Next
        Next
        ' now check all values are in range (ones near the bottom right might be >255)
        For y = 0 To SizeY
            For x = 0 To SizeX
                For i = 0 To 2
                    If FSPixelarray(x, y, i) < 0 Then FSPixelarray(x, y, i) = 0
                    If FSPixelarray(x, y, i) > 255 Then FSPixelarray(x, y, i) = 255
                Next i
            Next x
        Next y
    End Sub


    Private Sub Button39_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button39.Click
        ' take a picture, convert using Floyd-Steinberg dithering
        ' First create the palatte including gray scale. These have been matched by eye
        ' as close as possible to the propeller palatte
        ' see the palette program in Spin and also the Palette button on this form
        ' there are 86 colors in the palette - 80 colors and 6 grays
        ' the following formula could be saved as an array if transferred to spin
        Dim Palette(85, 3) As Integer
        Dim R, G, B, H, S, L As Double
        Dim Mycolor As Color
        Dim i, j, x, y As Integer
        Dim n, m As Double
        Dim sizex, sizey As Integer
        ' *** this first section creating the palellete can be replaced by reading in an array that has been precalculated
        ' for Spin code, replace this with a read from an SD card as it will be faster
        ' and also the HLS_to_RGB code is not needed
        CreateTVPalette(Palette)
        ' ************* end code for creating the palette array *************
        ' load in the picture
        sizex = 128 - 1 ' baggers 'world demo' screen is 128x96
        sizey = 96 - 1
        Dim PixelArray(sizex, sizey, 3) As Double
        Dim Sourcefile, DestinationFile As String
        'Dim DestinationFile As String
        Sourcefile = TextBox31.Text + TextBox32.Text
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
        img = Image.FromStream(fs)
        fs.Close()
        PictureBox100.Image = img
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox100.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                Mycolor = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = Mycolor.R ' red byte
                PixelArray(x, y, 1) = Mycolor.G ' green byte
                PixelArray(x, y, 2) = Mycolor.B ' blue byte
            Next
        Next
        ' floyd-steinberb diffusion 1/16 times array
        ' 0,0,0
        ' 0,n,7
        ' 3,5,1
        ' http://en.wikipedia.org/wiki/Floyd%E2%80%93Steinberg_dithering
        ' http://en.literateprograms.org/Floyd-Steinberg_dithering_%28C%29
        '       oldpixel := pixel[x][y]
        'newpixel := find_closest_palette_color(oldpixel)
        'pixel[x][y] := newpixel
        'quant_error := oldpixel - newpixel
        'pixel[x+1][y] := pixel[x+1][y] + 7/16 * quant_error
        'pixel[x-1][y+1] := pixel[x-1][y+1] + 3/16 * quant_error
        'pixel[x][y+1] := pixel[x][y+1] + 5/16 * quant_error
        'pixel[x+1][y+1] := pixel[x+1][y+1] + 1/16 * quant_error
        ' just converting to the nearest color based on the error is very good
        ' this next bit is just to display the picture pre-transform
        Dim MyBitmapPre As New System.Drawing.Bitmap(PictureBox100.Image) 'image from picture box
        Dim BestIndex As Integer ' best match
        ' do a least mean squares example - lots of color banding
        For y = 1 To sizey - 1
            For x = 1 To sizex - 1
                R = PixelArray(x, y, 0) ' old red
                G = PixelArray(x, y, 1) ' old green
                B = PixelArray(x, y, 2) ' old blue
                ' find the closest match
                BestIndex = FindNearestColor(Palette, R, G, B)
                ' put this color back into the picture - pre floyd-steinberg
                Mycolor = Color.FromArgb(255, Palette(BestIndex, 0), Palette(BestIndex, 1), Palette(BestIndex, 2))
                MyBitmapPre.SetPixel(x, y, Mycolor) ' set the pixels back to this palette color
            Next
        Next
        PictureBox101.Image = MyBitmapPre ' display the picture with minimum error - not bad already!!
        ' now do the FS transform
        FloydSteinberg(Palette, PixelArray, sizex, sizey) ' do the transform
        '  convert to propeller values 
        Dim OutputArray(12288) As Byte
        j = 0
        For y = 0 To sizey
            For x = 0 To sizex
                ' save the prop value
                R = PixelArray(x, y, 0) ' old red
                G = PixelArray(x, y, 1) ' old green
                B = PixelArray(x, y, 2) ' old blue
                ' find the closest match
                BestIndex = FindNearestColor(Palette, R, G, B) ' find closest palette color
                OutputArray(j) = Palette(BestIndex, 3) ' store prop color
                j += 1
            Next x
        Next y
        ' now display on a third picture
        For y = 0 To sizey
            For x = 0 To sizex
                Mycolor = Color.FromArgb(255, PixelArray(x, y, 0), PixelArray(x, y, 1), PixelArray(x, y, 2))
                MyBitmap.SetPixel(x, y, Mycolor) ' set the pixels back to this palette color
            Next x
        Next y
        PictureBox102.Image = MyBitmap ' display the picture after processing
        ' save as a .tv file
        DestinationFile = TextBox31.Text + TextBox33.Text
        Dim OutputTV As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputTV.Write(OutputArray, 0, 12288) ' save 12288 bytes
        OutputTV.Close()
        '*************************************************************
        ' now create a 256x96 picture. This ends up being scaled
        ' to 4:3 on a TV screen
        ' go back to the original picture and create two pixels the same for each pixel
        Dim MyBitmapNew As New System.Drawing.Bitmap(PictureBox100.Image) 'image from picture box
        ' new mybitmapnew array otherwise reads the changed file
        Dim PixelArrayStretched(255, 95, 3) As Double
        For y = 0 To sizey
            For x = 0 To sizex
                Mycolor = MyBitmapNew.GetPixel(x, y) ' get the color
                PixelArrayStretched(x * 2, y, 0) = Mycolor.R ' red byte
                PixelArrayStretched(x * 2, y, 1) = Mycolor.G ' green byte
                PixelArrayStretched(x * 2, y, 2) = Mycolor.B ' blue byte
                ' second pixel
                PixelArrayStretched(x * 2 + 1, y, 0) = Mycolor.R ' red byte
                PixelArrayStretched(x * 2 + 1, y, 1) = Mycolor.G ' green byte
                PixelArrayStretched(x * 2 + 1, y, 2) = Mycolor.B ' blue byte
            Next
        Next
        sizex = 255 ' new sizex
        FloydSteinberg(Palette, PixelArrayStretched, sizex, sizey) ' do the transform
        ' convert to a picture on the screen - can leave this out for speed if required
        ' creating a system.drawing.bitmap seems to not work
        ' so read in an image from a dummy file or set the background image to a file
        ' this file needs to exist 
        Dim fs1 As New FileStream("c:\propeller\icons\blank256192.bmp", IO.FileMode.Open)
        img = Image.FromStream(fs1)
        fs1.Close()
        PictureBox103.Image = img
        Dim MyBitmapStr As New System.Drawing.Bitmap(PictureBox103.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                Mycolor = Color.FromArgb(255, PixelArrayStretched(x, y, 0), PixelArrayStretched(x, y, 1), PixelArrayStretched(x, y, 2))
                MyBitmapStr.SetPixel(x, y * 2, Mycolor) ' set the pixels back to this palette color
                MyBitmapStr.SetPixel(x, y * 2 + 1, Mycolor) ' set the pixels back to this palette color
            Next x
        Next y
        PictureBox103.Image = MyBitmapStr ' display the picture after processing
        ' convert to prop values
        Dim OutputArray2(24576) As Byte
        j = 0
        For y = 0 To sizey
            For x = 0 To sizex
                ' save the prop value
                R = PixelArrayStretched(x, y, 0) ' old red
                G = PixelArrayStretched(x, y, 1) ' old green
                B = PixelArrayStretched(x, y, 2) ' old blue
                ' find the closest match
                BestIndex = FindNearestColor(Palette, R, G, B) ' find closest palette color
                OutputArray2(j) = Palette(BestIndex, 3) ' store prop color
                j += 1
            Next x
        Next y
        ' save as a .tv file
        DestinationFile = TextBox31.Text + TextBox45.Text
        Dim OutputTV2 As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputTV2.Write(OutputArray2, 0, 24576) ' save 
        OutputTV2.Close()
    End Sub
    Private Function FindNearestColor(ByVal Palette As Integer(,), ByVal R As Integer, ByVal G As Integer, ByVal B As Integer)
        ' minimum straight line distance from color to the color cube color
        Dim i, BestIndex As Integer
        Dim DistanceSquared, MinDistanceSquared, Rdiff, Gdiff, Bdiff As Long
        MinDistanceSquared = 255 * 255 + 255 * 255 + 255 * 255 + 1
        For i = 0 To 85
            Rdiff = R - Palette(i, 0)
            Gdiff = G - Palette(i, 1)
            Bdiff = B - Palette(i, 2)
            DistanceSquared = Rdiff * Rdiff + Gdiff * Gdiff + Bdiff * Bdiff
            If DistanceSquared < MinDistanceSquared Then
                MinDistanceSquared = DistanceSquared
                BestIndex = i
            End If
        Next
        Return BestIndex
    End Function

    Private Sub Button40_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button40.Click
        Dim Palette(85, 3) As Integer
        Dim H, S, L As Double
        Dim Mycolor As Color
        Dim i, j, n As Integer
        Dim OutputArray(344) As Byte
        CreateTVPalette(Palette)
        n = 0
        For i = 0 To 85
            For j = 0 To 3
                OutputArray(n) = Palette(i, j)
                n += 1
            Next j
        Next i
        Dim OutputPalette As New FileStream("c:\propeller\icons\Palette.pal", FileMode.Create, FileAccess.Write)
        OutputPalette.Write(OutputArray, 0, 344) ' save
        OutputPalette.Close()
    End Sub

    Private Sub Button41_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button41.Click
        ' Movie Floyd-Steinberg
        Dim Palette(85, 3) As Integer
        Dim R, G, B, H, S, L As Double
        Dim Mycolor As Color
        Dim i, j, x, y As Integer
        Dim n, m As Double
        ' create the palatte array
        CreateTVPalette(Palette)
        ' palette array created
        ' floyd-steinberb diffusion 1/16 times array
        ' 0,0,0
        ' 0,n,7
        ' 3,5,1
        ' http://en.wikipedia.org/wiki/Floyd%E2%80%93Steinberg_dithering
        ' http://en.literateprograms.org/Floyd-Steinberg_dithering_%28C%29
        '       oldpixel := pixel[x][y]
        'newpixel := find_closest_palette_color(oldpixel)
        'pixel[x][y] := newpixel
        'quant_error := oldpixel - newpixel
        'pixel[x+1][y] := pixel[x+1][y] + 7/16 * quant_error
        'pixel[x-1][y+1] := pixel[x-1][y+1] + 3/16 * quant_error
        'pixel[x][y+1] := pixel[x][y+1] + 5/16 * quant_error
        'pixel[x+1][y+1] := pixel[x+1][y+1] + 1/16 * quant_error
        ' just converting to the nearest color based on the error is very good
        ' this next bit is just to display the picture pre-transform
        ' movie creater
        ' create a TV movie

        Dim sizex As Integer
        Dim sizey As Integer
        Dim PixelValue As Color
        sizex = 128 - 1 ' baggers screen is 128x96
        sizey = 96 - 1
        Dim PixelArray(sizex, sizey, 3) As Double ' R,G,B and calculated prop byte so 4 values
        Dim Sourcefile As String
        Dim DestinationFile As String
        Dim StartNumber As Integer
        Dim FinishNumber As Integer
        Dim Filecounter As Integer
        Dim LineofText As String
        Dim BestIndex As Integer ' best match
        Dim OutputArray(12288) As Byte
        DestinationFile = TextBox10.Text + TextBox20.Text
        StartNumber = Strings.Val(TextBox12.Text)
        FinishNumber = Strings.Val(TextBox13.Text)
        Dim OutputTV As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        For Filecounter = StartNumber To FinishNumber
            Sourcefile = TextBox10.Text + TextBox11.Text ' directory plus rootname
            ' add the right number of leading zeros, (AVS4YOU adds a different number based on how big the total file is)
            LineofText = Strings.Right("000000" + Trim(Strings.Str(Filecounter)), Strings.Len(TextBox12.Text)) ' convert to a string
            Label25.Text = LineofText
            Sourcefile += LineofText + ".bmp"
            ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
            Dim img As Image
            Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
            img = Image.FromStream(fs)
            fs.Close()
            ' display the image in the picture box
            PictureBox4.Image = img
            ' Get the source bitmap.
            Dim bm_source As New Bitmap(PictureBox4.Image)
            ' Make a bitmap for the result shrunk to 160x120
            Dim bm_dest As New Bitmap(CInt(sizex + 1), CInt(sizey + 1)) '128x96
            ' Make a Graphics object for the result Bitmap.
            Dim gr_dest As Graphics = Graphics.FromImage(bm_dest)
            ' Copy the source image into the destination bitmap.
            gr_dest.DrawImage(bm_source, 0, 0, bm_dest.Width + 1, bm_dest.Height + 1)
            ' Display the result.
            PictureBox7.Image = bm_dest
            gr_dest.Dispose()
            Dim MyBitmap As New System.Drawing.Bitmap(PictureBox7.Image) 'image from picture box

            For y = 0 To sizey
                For x = 0 To sizex
                    PixelValue = MyBitmap.GetPixel(x, y) ' get the color
                    PixelArray(x, y, 0) = PixelValue.R ' red byte
                    PixelArray(x, y, 1) = PixelValue.G ' green byte
                    PixelArray(x, y, 2) = PixelValue.B ' blue byte
                Next
            Next
            FloydSteinberg(Palette, PixelArray, sizex, sizey) ' do the transform
            ' convert to propeller values 
            j = 0
            For y = 0 To sizey
                For x = 0 To sizex
                    ' save the prop value
                    R = PixelArray(x, y, 0) ' old red
                    G = PixelArray(x, y, 1) ' old green
                    B = PixelArray(x, y, 2) ' old blue
                    ' find the closest match
                    BestIndex = FindNearestColor(Palette, R, G, B) ' find closest palette color
                    OutputArray(j) = Palette(BestIndex, 3) ' store prop color
                    j += 1
                Next x
            Next y
            System.Windows.Forms.Application.DoEvents() ' update the display
            OutputTV.Write(OutputArray, 0, 12288) ' save bytes 128x96 is 12288
        Next Filecounter
        OutputTV.Close()

    End Sub

    Private Sub Button42_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button42.Click
        Create256TV()
    End Sub
    Private Sub Create256TV()
        Dim Sourcefile As String
        Dim Sizex, sizey As Integer
        Dim CroppedOrgX, CroppedOrgY, CroppedWidth, CroppedHeight As Integer
        Dim x, y, i As Integer
        Dim R, G, B As Double
        Sizex = 256
        sizey = 192

        sourcefile = TextBox46.Text + TextBox47.Text
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Sourcefile, IO.FileMode.Open)
        img = Image.FromStream(fs)
        fs.Close()
        ' display the image in the picture box
        PictureBox104.Image = img ' display image
        ' Get the source bitmap.
        Dim bm_source As New Bitmap(PictureBox104.Image)
        ' create a cropped array
        CroppedOrgX = Strings.Val(TextBox48.Text)
        CroppedOrgY = Strings.Val(TextBox49.Text)
        CroppedWidth = Strings.Val(TextBox50.Text)
        CroppedHeight = Strings.Val(TextBox51.Text)
        PictureBox105.Width = CroppedWidth
        PictureBox105.Height = CroppedHeight
        Dim Cropped As New Bitmap(PictureBox104.Image, CroppedWidth, CroppedHeight)
        Dim srcRect As New RectangleF(CroppedOrgX, CroppedOrgY, CroppedWidth, CroppedHeight)
        Dim mygraphics As Graphics = Graphics.FromImage(Cropped)
        mygraphics.DrawImage(bm_source, 0, 0, srcRect, GraphicsUnit.Pixel)
        PictureBox105.Image = Cropped
        mygraphics.Dispose()
        ' now rescale to a different size
        PictureBox106.Width = Sizex
        PictureBox106.Height = sizey
        Dim cropped_source As New Bitmap(PictureBox105.Image)
        ' Make a bitmap for the result shrunk to a different size
        Dim bm_dest As New Bitmap(CInt(Sizex + 1), CInt(sizey + 1)) ' new size
        ' Make a Graphics object for the result Bitmap.
        Dim gr_dest As Graphics = Graphics.FromImage(bm_dest)
        ' Copy the source image into the destination bitmap.
        gr_dest.DrawImage(cropped_source, 0, 0, bm_dest.Width + 1, bm_dest.Height + 1)
        ' Display the result.
        PictureBox106.Image = bm_dest ' scaled image to 256x192
        gr_dest.Dispose()
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox106.Image) 'image from picture box
        Dim mycolor As Color
        Dim PixelArray(Sizex, sizey, 3) As Double ' convert to an array
        For y = 0 To sizey - 1
            For x = 0 To Sizex - 1
                Mycolor = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = Mycolor.R ' red byte
                PixelArray(x, y, 1) = Mycolor.G ' green byte
                PixelArray(x, y, 2) = Mycolor.B ' blue byte
            Next
        Next
        ' average each vertical pixel so halves the height
        Dim Halfy As Integer
        Halfy = sizey / 2
        Dim HalfHeight(Sizex, halfy, 3) As Double
        For y = 0 To Halfy - 1
            For x = 0 To Sizex
                For i = 0 To 3
                    HalfHeight(x, y, i) = (PixelArray(x, y * 2, i) + PixelArray(x, y * 2 + 1, i)) / 2
                Next
            Next
        Next
        ' now have a picture ready for Floyd Steinberg manipulation
        Dim Palette(85, 3) As Integer
        Dim BestIndex As Integer ' best match
        CreateTVPalette(Palette) ' create the palatte
        FloydSteinberg(Palette, HalfHeight, Sizex, Halfy) ' do the transform
        '  convert to propeller values 
        Dim OutputArray(Sizex * Halfy) As Byte
        i = 0
        For y = 0 To Halfy - 1
            For x = 0 To Sizex - 1
                ' save the prop value
                R = HalfHeight(x, y, 0) ' old red
                G = HalfHeight(x, y, 1) ' old green
                B = HalfHeight(x, y, 2) ' old blue
                ' find the closest match
                BestIndex = FindNearestColor(Palette, R, G, B) ' find closest palette color
                OutputArray(i) = Palette(BestIndex, 3) ' store prop color
                i += 1
            Next x
        Next y
        Dim DestinationFile As String
        ' save as a .tv file
        DestinationFile = TextBox46.Text + TextBox52.Text
        Dim OutputTV As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputTV.Write(OutputArray, 0, Sizex * Halfy) ' save 
        OutputTV.Close()
    End Sub


    Private Sub TextBox50_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox50.TextChanged
        ' scaling has been worked out such that the 256x96 display ends up with a circle
        ' display with black bars is 170x145mm with a ratio of 1.17
        ' actual is 1.33
        '1.33/1.17 = 1.51
        TextBox51.Enabled = True
        TextBox51.Text = Strings.Str(Int(0.662 * Strings.Val(TextBox50.Text))) ' scale correctly
        TextBox51.Enabled = False
    End Sub

    Private Sub Button43_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button43.Click
        Dim Firstnumber, Lastnumber, filecounter As Integer
        Dim SourceFile, lineoftext, DestinationFile, Tempfilename As String
        Dim TVArray(24576) As Byte
        DestinationFile = TextBox46.Text + TextBox56.Text
        Dim OutputTV As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        TextBox52.Text = "temp.tv" ' save as a temporary file
        Tempfilename = TextBox46.Text + "temp.tv" '
        Firstnumber = Strings.Val(TextBox54.Text)
        Lastnumber = Strings.Val(TextBox55.Text)
        For filecounter = Firstnumber To Lastnumber Step 2 ' speed ends up about right if skip alt frames
            SourceFile = TextBox53.Text ' rootname
            ' add the right number of leading zeros, (AVS4YOU adds a different number based on how big the total file is)
            lineoftext = Strings.Right("000000" + Trim(Strings.Str(filecounter)), Strings.Len(TextBox54.Text)) ' convert to a string
            SourceFile += lineoftext + ".bmp"
            TextBox47.Text = SourceFile ' put back into the text box
            Create256TV() ' create the tv file from the picture
            Dim InputTV As New FileStream(Tempfilename, FileMode.Open, FileAccess.Read)
            InputTV.Read(TVArray, 0, 24576) ' read back in the temp.tv file
            InputTV.Close() ' close
            OutputTV.Write(TVArray, 0, 24576) ' save to the movie file
            System.Windows.Forms.Application.DoEvents() ' refresh display
            Label104.Text = Strings.Str(filecounter)
        Next
        OutputTV.Close()
    End Sub
End Class

